package ecp.vcs.com.ecpsyncplugin.re_sync.database;

import android.content.ContentValues;
import android.content.Context;
import android.database.Cursor;
import android.database.SQLException;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteStatement;
import android.os.Build;
import android.util.Log;

import com.google.gson.JsonArray;
import com.google.gson.JsonObject;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.Map;

import ecp.vcs.com.ecpsyncplugin.R;
import ecp.vcs.com.ecpsyncplugin.re_sync.SynchronizationService;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CityModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CreateNewCustomer;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoCMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoEMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.BarcodeModel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CustomerTypeDetails;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorReturn;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorReturnProduct;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.MenuAccess;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.PoliticalLevel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.ScannedPoints;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.UserConfigurationMst;

import ecp.vcs.com.ecpsyncplugin.re_sync.interfaces.DatabaseError;
import ecp.vcs.com.ecpsyncplugin.re_sync.logging.LogHelper;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CpmCustomerProductStock;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CreateNewCustomer;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoCMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CtoEMapping;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.CustomerTypeDetails;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopCFADispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopDistributorDispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.IshopTollerDispatch;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.LastSyncDateTime;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.MenuAccess;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.PoliticalDetail;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.PoliticalLevel;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.SalesRepInitiatedProduct;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.Synchronization;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.ScannedPoints;
import ecp.vcs.com.ecpsyncplugin.re_sync.model.UserConfigurationMst;
import ecp.vcs.com.ecpsyncplugin.re_sync.networking.AppUtil;
import ecp.vcs.com.ecpsyncplugin.re_sync.database.Database_Column;
import ecp.vcs.com.ecpsyncplugin.re_sync.storage.ScopedStorage;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.CheckList;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Const;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.Content;
import ecp.vcs.com.ecpsyncplugin.re_sync.utils.SyncErrorCode;

//import android.database.Cursor;
//import android.database.SQLException;
//import android.database.sqlite.SQLiteDatabase;
//import android.database.sqlite.SQLiteStatement;

/**
 * Created by vcsdev0114 on 31/05/2017.
 */

public class DatabaseCRUD {

    private static DatabaseError callback;
    private Context context;
    //ProductTypeNameCountry
    private final static String TAG = "DatabaseCRUD";
    // Database fields
    public static SQLiteDatabase database;
    public static final ArrayList<IshopTollerDispatch> arrayListTollerDispatch = new ArrayList<>();
    public static final ArrayList<CreateNewCustomer> arrayListCustomer = new ArrayList<>();
    public static final ArrayList<PoliticalLevel> arrayListPoliticalLevel = new ArrayList<>();
    public static final ArrayList<PoliticalDetail> arrayListPoliticalDetails = new ArrayList<>();
    public static final ArrayList<MenuAccess> arrayListMenuAccess = new ArrayList<>();
    public static final ArrayList<CpmCustomerProductStock> arrayListCustomerProductStock = new ArrayList<>();
    public static final ArrayList<UserConfigurationMst> arrayListUserConfigurationMst = new ArrayList<>();
    public static final ArrayList<SalesRepInitiatedProduct> arrayListSalesRepInitiatedProduct = new ArrayList<>();
    public static final ArrayList<CtoCMapping> arrayListCtoCMapping = new ArrayList<>();
    public static final ArrayList<CtoEMapping> arrayListCtoEMapping = new ArrayList<>();

    public static final ArrayList<LastSyncDateTime> arrayListLastSyncDateTime = new ArrayList<>();
    public static final ArrayList<CustomerTypeDetails> arrayListCustomerType_Details = new ArrayList<>();
    private static DataBaseHelper dbHelper;
    public static final ArrayList<ScannedPoints> arrayListScannedPoints = new ArrayList<>();

    public DatabaseCRUD(Context context) {
        try {
            this.context = context;
            dbHelper = DataBaseHelper.getInstance(context);
//            dbHelper = new DataBaseHelper(context);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public DatabaseCRUD(Context context, DatabaseError callback) {
        DatabaseCRUD.callback = callback;
        try {
            this.context = context;
//            dbHelper = new DataBaseHelper(context);
            dbHelper = DataBaseHelper.getInstance(context);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void open() throws SQLException {
        database = dbHelper.writeDB();
    }

    public static void close() {
        if (database.isOpen()) {
            database.close();
        }
    }

    public String checkIfDataExist() {
        JSONArray TABLE_TRANSACTION_ERROR = getJsonFromTable(DataBaseHelper.TABLE_TRANSACTION_ERROR_LOG, database, "0");
        JSONArray TABLE_ISHOP_PALLET_DETAILS = getJsonFromTable(DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS, database, "0");
//        JSONArray TABLE_DEVICE_TOKEN = getJsonFromTable(DataBaseHelper.TABLE_DEVICE_TOKEN, database, "0");
//        JSONArray TABLE_SAVE_OFFLINE_LOG = getJsonFromTable(DataBaseHelper.TABLE_SAVE_OFFLINE_LOG, database, "0");
        JSONArray TABLE_TOLLER_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_TOLLER_DISPATCH, database, "0");
        JSONArray TABLE_TOLLER_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper
                        .TABLE_TOLLER_DISPATCH_PRODUCT,
                database, "0");
        JSONArray TABLE_RETAILER_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_RETAILER_DISPATCH,
                database, "1");
        JSONArray TABLE_RETAILER_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper
                        .TABLE_RETAILER_DISPATCH_PRODUCT,
                database, "0");
        //asdf
        JSONArray TABLE_CFA_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_CFA_DISPATCH, database, "1");
        JSONArray TABLE_CFA_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_CFA_DISPATCH_PRODUCT,
                database, "0");
        JSONArray TABLE_SAMPLE_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH, database, "1");
        JSONArray TABLE_SAMPLE_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT,
                database, "0");
        JSONArray TABLE_CFA_RETURN = getJsonFromTable(DataBaseHelper.TABLE_CFA_RETURN, database, "0");

        JSONArray TABLE_DISTRIBUTOR_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH,
                database, "1");

        JSONArray TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper
                .TABLE_DISTRIBUTOR_DISPATCH_PRODUCT, database, "0");

        //For Sample and FOC Invalid
        TABLE_DISTRIBUTOR_DISPATCH=addDistributorDispatchForSampleAndFOC(TABLE_DISTRIBUTOR_DISPATCH);
        TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = addDistributorDispatchForSampleAndFOCProduct(TABLE_DISTRIBUTOR_DISPATCH_PRODUCT);


        //Amit Vaghela changes
        JSONArray TABLE_ishop_distributor_received = getJsonFromTable(DataBaseHelper
                        .TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED,
                database, "1");
        JSONArray TABLE_ishop_distributor_received_product = getJsonFromTable(DataBaseHelper
                .TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT, database, "0");
        JSONArray TABLE_ishop_reatialer_received = getJsonFromTable(DataBaseHelper
                        .TABLE_BF_ISHOP_RETAILER_RECEIVED,
                database, "1");
        JSONArray TABLE_ishop_reatialer_received_product = getJsonFromTable(DataBaseHelper
                .TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT, database, "0");

        JSONArray TABLE_bf_ishop_cfa_return = getJsonFromTable(DataBaseHelper.TABLE_CFA_RETURN, database, "1");
        JSONArray TABLE_bf_ishop_cfa_return_product = getJsonFromTable(DataBaseHelper.TABLE_CFA_RETURN_PRODUCT,
                database, "0");

        JSONArray TABLE_bf_ishop_distributor_return_request = getJsonFromTable(DataBaseHelper
                .TABLE_DISTRIBUTOR_RETURN_REQUEST, database, "1");
        JSONArray TABLE_bf_ishop_distributor_return_request_product = getJsonFromTable(DataBaseHelper
                        .TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT,
                database, "0");

        JSONArray TABLE_SALES_REP_INITIATED_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_SALES_REP_INITIATED_PRODUCT, database, "2");


        JSONArray TABLE_CFA_DAMAGE = getJsonFromTable(DataBaseHelper.TABLE_CFA_DAMAGE, database, "0");
        JSONArray TABLE_CFA_DAMAGE_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_CFA_DAMAGE_PRODUCT, database, "0");

        JSONArray TABLE_DIST_DAMAGE = getJsonFromTable(DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE, database, "0");
        JSONArray TABLE_DIST_DAMAGE_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT, database, "0");

        JSONArray TABLE_RET_DAMAGE = getJsonFromTable(DataBaseHelper.TABLE_RETAILER_DAMAGE, database, "0");
        JSONArray TABLE_RET_DAMAGE_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_RETAILER_DAMAGE_PRODUCT, database, "0");
        //JSONArray TABLE_CustomerType_Details = getJsonFromTable(DataBaseHelper.TABLE_CustomerType_Details, database, "0");
        /*  TODO CHange By Praveen  */
        JSONArray TABLE_VIDEO_HELP_DETAIL = getJsonFromTable(DataBaseHelper.TABLE_HELP_VIDEO_DETAIL, database, "0");

        //$result['ishop_distributor_received'] = $ishop_distributor_received;
        // $result['ishop_distributor_received_product'] = $ishop_distributor_received_product;

        // bf_tmp_ishop_distributor_dispatch
        //DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH
        JSONObject jsonObject;
        Synchronization object = new Synchronization();

        //object.setIshop_cfa_dispatch(CFADispatchSyncData());
        //object.setIshop_cfa_dispatch_product(CFADispatchSyncDataProduct());

        /*object.setIshop_cfa_return(CFAReturnSyncData());
        object.setBf_ishop_cfa_return_product(CFAReturnProductSyncData());*/

        //object.setIshop_distributor_dispatch(DistributorDispatchSyncData());
        //object.setIshop_distributor_dispatch_product(DistributorDispatchSyncDataProduct());

        object.setIshop_distributor_return(DistributorReturnSyncData());
        object.setIshop_distributor_return_product(DistributorReturnProductSyncData());
        //asdf
        /*object.setIshop_distributor_return_request(DistributorReturnRequestSyncData());
        object.setIshop_distributor_return_request_product(DistributorReturnRequestProductSyncData());*/

        //object.setIshop_retailer_dispatch(RetailerDispatchSyncData());
        //object.setIshop_retailer_dispatch_product(RetailerDispatchSyncDataProduct());

        String jsonObject1 = AppUtil.getJsonFromObject(object);
        try {
            jsonObject = new JSONObject(jsonObject1);

            Log.e("", "" + TABLE_TOLLER_DISPATCH);
            if (TABLE_TOLLER_DISPATCH != null && TABLE_TOLLER_DISPATCH.length() > 0)
                jsonObject.put("ishop_toller_dispatch", TABLE_TOLLER_DISPATCH);

            if (TABLE_TOLLER_DISPATCH_PRODUCT != null && TABLE_TOLLER_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_toller_dispatch_product", TABLE_TOLLER_DISPATCH_PRODUCT);

            Log.e("", "" + TABLE_RETAILER_DISPATCH);
            if (TABLE_RETAILER_DISPATCH != null && TABLE_RETAILER_DISPATCH.length() > 0)
                jsonObject.put("ishop_retailer_dispatch", TABLE_RETAILER_DISPATCH);

            Log.e("", "" + TABLE_RETAILER_DISPATCH_PRODUCT);
            if (TABLE_RETAILER_DISPATCH_PRODUCT != null && TABLE_RETAILER_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_retailer_dispatch_product", TABLE_RETAILER_DISPATCH_PRODUCT);

            if (TABLE_CFA_DISPATCH != null && TABLE_CFA_DISPATCH.length() > 0)
                jsonObject.put("ishop_cfa_dispatch", TABLE_CFA_DISPATCH);

            if (TABLE_CFA_DISPATCH_PRODUCT != null && TABLE_CFA_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_cfa_dispatch_product", TABLE_CFA_DISPATCH_PRODUCT);

            if (TABLE_SAMPLE_DISPATCH != null && TABLE_SAMPLE_DISPATCH.length() > 0)
                jsonObject.put("ishop_sample_dispatch", TABLE_SAMPLE_DISPATCH);

            if (TABLE_SAMPLE_DISPATCH_PRODUCT != null && TABLE_SAMPLE_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_sample_dispatch_product", TABLE_SAMPLE_DISPATCH_PRODUCT);

            if (TABLE_CFA_RETURN != null && TABLE_CFA_RETURN.length() > 0)
                jsonObject.put("ishop_cfa_return", TABLE_CFA_RETURN);

            if (TABLE_DISTRIBUTOR_DISPATCH != null && TABLE_DISTRIBUTOR_DISPATCH.length() > 0)
                jsonObject.put("ishop_distributor_dispatch", TABLE_DISTRIBUTOR_DISPATCH);

            if (TABLE_DISTRIBUTOR_DISPATCH_PRODUCT != null && TABLE_DISTRIBUTOR_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_distributor_dispatch_product", TABLE_DISTRIBUTOR_DISPATCH_PRODUCT);

            if (TABLE_ishop_distributor_received != null && TABLE_ishop_distributor_received.length() > 0)
                jsonObject.put("ishop_distributor_received", TABLE_ishop_distributor_received);

            if (TABLE_ishop_distributor_received_product != null && TABLE_ishop_distributor_received_product
                    .length() > 0)
                jsonObject.put("ishop_distributor_received_product", TABLE_ishop_distributor_received_product);

            if (TABLE_ishop_reatialer_received != null && TABLE_ishop_reatialer_received.length() > 0)
                jsonObject.put("ishop_retailer_received", TABLE_ishop_reatialer_received);

            if (TABLE_ishop_reatialer_received_product != null && TABLE_ishop_reatialer_received_product
                    .length() > 0)
                jsonObject.put("ishop_retailer_received_product", TABLE_ishop_reatialer_received_product);

            if (TABLE_bf_ishop_cfa_return != null && TABLE_bf_ishop_cfa_return.length() > 0)
                jsonObject.put("ishop_cfa_return", TABLE_bf_ishop_cfa_return);

            if (TABLE_bf_ishop_cfa_return_product != null && TABLE_bf_ishop_cfa_return_product.length() > 0)
                jsonObject.put("ishop_cfa_return_product", TABLE_bf_ishop_cfa_return_product);

            if (TABLE_bf_ishop_distributor_return_request != null && TABLE_bf_ishop_distributor_return_request
                    .length() > 0)
                jsonObject.put("ishop_distributor_return_request", TABLE_bf_ishop_distributor_return_request);

            if (TABLE_bf_ishop_distributor_return_request_product != null &&
                    TABLE_bf_ishop_distributor_return_request_product.length() > 0)
                jsonObject.put("ishop_distributor_return_request_product",
                        TABLE_bf_ishop_distributor_return_request_product);

            if (TABLE_SALES_REP_INITIATED_PRODUCT != null && TABLE_SALES_REP_INITIATED_PRODUCT.length() > 0)
                jsonObject.put("sales_rep_initiated_product", TABLE_SALES_REP_INITIATED_PRODUCT);

            if (TABLE_CFA_DAMAGE != null && TABLE_CFA_DAMAGE.length() > 0)
                jsonObject.put("ishop_cfa_damage", TABLE_CFA_DAMAGE);

            if (TABLE_CFA_DAMAGE_PRODUCT != null && TABLE_CFA_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_cfa_damage_product", TABLE_CFA_DAMAGE_PRODUCT);


            if (TABLE_DIST_DAMAGE != null && TABLE_DIST_DAMAGE.length() > 0)
                jsonObject.put("ishop_distributor_damage", TABLE_DIST_DAMAGE);

            if (TABLE_DIST_DAMAGE_PRODUCT != null && TABLE_DIST_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_distributor_damage_product", TABLE_DIST_DAMAGE_PRODUCT);


            if (TABLE_RET_DAMAGE != null && TABLE_RET_DAMAGE.length() > 0)
                jsonObject.put("ishop_retailer_damage", TABLE_RET_DAMAGE);

            if (TABLE_RET_DAMAGE_PRODUCT != null && TABLE_RET_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_retailer_damage_product", TABLE_RET_DAMAGE_PRODUCT);


            /*TODO Changes By Praveen */

            if (TABLE_VIDEO_HELP_DETAIL != null && TABLE_VIDEO_HELP_DETAIL.length() > 0) {
                jsonObject.put("bf_master_cpm_help_video_details", TABLE_VIDEO_HELP_DETAIL);
            }
            /*if (TABLE_CustomerType_Details != null && TABLE_CustomerType_Details.length() > 0)
                jsonObject.put("CustomerType_Details", TABLE_CustomerType_Details);*/

//            if (TABLE_SAVE_OFFLINE_LOG != null && TABLE_SAVE_OFFLINE_LOG.length() > 0) {
//                jsonObject.put("bf_ishop_save_offline_log_android_cpm", TABLE_SAVE_OFFLINE_LOG);
//            }

//            if (TABLE_DEVICE_TOKEN != null && TABLE_DEVICE_TOKEN.length() > 0) {
//                jsonObject.put("table_device_token", TABLE_DEVICE_TOKEN);
//            }

            if (TABLE_TRANSACTION_ERROR != null && TABLE_TRANSACTION_ERROR.length() > 0) {
                jsonObject.put("bf_ishop_transaction_error_log", TABLE_TRANSACTION_ERROR);
            }

            if (TABLE_ISHOP_PALLET_DETAILS != null && TABLE_ISHOP_PALLET_DETAILS.length() > 0) {
                jsonObject.put("bf_ishop_pallet_details", TABLE_ISHOP_PALLET_DETAILS);
            }

            /*Todo change by praveen */


//            JSONArray deviceDetailArray = new JSONArray(getDeviceDetail().toString());
//            JSONObject deviceDetailobj= new JSONObject(getDeviceDetail().toString().replace("\n",""));


//            jsonObject.put("deviceDeatail",getDeviceDetail().toString().replace("\n",""));


            writeStringAsFile(jsonObject.toString(), "RE_CPM",context);
            Log.e(TAG, "SYNCHRONIZATION JSON : " + jsonObject);
            return jsonObject.toString();
        } catch (JSONException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            Log.e("error", "->>" + e);
            return "json not found";
        }
    }

    public static ArrayList<String> getInValidQRCodeList(String dispatchId) {
        ArrayList<String> arrayList = new ArrayList<>();

        String query = "SELECT ifnull(barcodeNo, '') AS barcodeNo\n" +
                "  FROM table_scannedsticker\n" +
                " WHERE isValid=0";
        Log.e("getInValidQRCodeList", "" + query);

        Cursor cursor = database.rawQuery(query, null);
        try {
            if (cursor != null && cursor.moveToFirst()) {
                do {
                    arrayList.add(cursor.getString(0));
                } while (cursor.moveToNext());
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (cursor != null) cursor.close();
        }

        return arrayList;
    }

    public static boolean InsertMenuAccess(MenuAccess object) {

        ContentValues contentValues = new ContentValues();

        contentValues.put(DataBaseHelper.KEY_ORDER, object.getOrder());
        contentValues.put(DataBaseHelper.KEY_ALIAS, object.getAlias());
        contentValues.put(DataBaseHelper.KEY_MENU_ID, object.getMenuId());
        contentValues.put(DataBaseHelper.KEY_TITLE, object.getTitle());

        database.insert(DataBaseHelper.TABLE_MENU_ACCESS, null, contentValues);

        Log.e(TAG, "TABLE PRODUCT TYPE NAME COUNTRY INSERT SUCCESSFULLY");

        return true;
    }

    public static void writeStringAsFile(final String fileContents, String fileName,Context context) {
        //Context context = App.instance.getApplicationContext();

//        String path = Environment.getExternalStorageDirectory() + "/sendJson";
        String path = ScopedStorage.getInstance(context).getPath(ScopedStorage.SEND_JSON);
        File f = new File(path);
        if (!f.exists()) {
            f.mkdirs();
        }

        try {
            FileWriter out = new FileWriter(new File(path, fileName));
            out.write(fileContents);
            out.close();
        } catch (IOException e) {
            // Logger.logError(TAG, e);
            Log.e("error", "file write");
        }
    }

    public void DumpEmployeeDetails() {

        database = dbHelper.writeDB();
        //InsertNewCustomer
        database.execSQL("delete from " + DataBaseHelper.TABLE_NEW_CUSTOMER);
        for (CreateNewCustomer object : arrayListCustomer) {
            InsertNewCustomer(object);
        }
        // INSERT TABLE_POLITICAL_LEVEL
        database.execSQL("delete from " + DataBaseHelper.TABLE_POLITICAL_LEVEL);
        for (PoliticalLevel object : arrayListPoliticalLevel) {
            InsertTABLE_POLITICAL_LEVEL(object);
        }

        //InsertMenuAccess
        database.execSQL("delete from " + DataBaseHelper.TABLE_MENU_ACCESS);
        for (MenuAccess object : arrayListMenuAccess) {
            InsertMenuAccess(object);
        }

        //CtoCMapping

        database.execSQL("delete from " + DataBaseHelper.TABLE_CTOCMAPPING);

        for (CtoCMapping object : arrayListCtoCMapping) {
            InsertCtoCMapping(object);
        }

        //CtoCMapping

        database.execSQL("delete from " + DataBaseHelper.TABLE_CTOEMAPPING);

        for (CtoEMapping object : arrayListCtoEMapping) {
            InsertCtoEMapping(object);
        }

        //Insertuser_configuration_mst

        database.execSQL("delete from " + DataBaseHelper.USER_CONFIGURATION_MST);

        for (UserConfigurationMst object : arrayListUserConfigurationMst) {
            InsertUserConfigurationMst(object);
        }

//        database.execSQL("delete from " + DataBaseHelper.TABLE_Last_Sync_Date_Time);
//
//        for (LastSyncDateTime object : arrayListLastSyncDateTime) {
//            InsertLastSyncDateTime(object);
//        }

        database.execSQL("delete from " + DataBaseHelper.TABLE_CustomerType_Details);
        for (CustomerTypeDetails object : arrayListCustomerType_Details) {
            InsertCustomerTypeDetails(object);
        }

        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_SCANNED_IN_STICKER);

        for (ScannedPoints object : arrayListScannedPoints) {
            InsertRETAILERSCANNEDIN(object);
        }
    }

    public boolean InsertCFADispatch(IshopCFADispatch object, int isDispatch) {

        try {
            ContentValues contentValues = new ContentValues();

            contentValues.put(DataBaseHelper.KEY_CFA_DISPATCH_ID, object.getCFADispatchId());
            contentValues.put(DataBaseHelper.KEY_CUSTOMER_FROM_ID, object.getCustomerFromId());
            contentValues.put(DataBaseHelper.KEY_CUSTOMER_TO_ID, object.getCustomerToId());
            contentValues.put(DataBaseHelper.KEY_SAP_ID, object.getSAPId());
            contentValues.put(DataBaseHelper.KEY_DISPATCH_TYPE, object.getDispatchType());
            contentValues.put(DataBaseHelper.KEY_DO_STO_NO, object.getDoSTONo());
            contentValues.put(DataBaseHelper.KEY_DISPATCH_DATE, object.getDispatchDate());
            contentValues.put(DataBaseHelper.KEY_RECEIVED, object.getReceived());
            contentValues.put(DataBaseHelper.KEY_RECEIVED_DATE, object.getReceivedDate());
            contentValues.put(DataBaseHelper.KEY_COUNTRY_ID, object.getCountyId());
            contentValues.put(DataBaseHelper.KEY_CREATED_BY_USER, object.getCreatedByUser());
            contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
            contentValues.put(DataBaseHelper.KEY_STATUS, object.getStatus());
            contentValues.put(DataBaseHelper.KEY_CREATE_ON, object.getCreatedOn());
            contentValues.put(DataBaseHelper.KEY_MODIFIED_ON, object.getModifiedOn());
            contentValues.put(DataBaseHelper.KEY_SYNC_CODE, object.getSyncCode());
            contentValues.put(DataBaseHelper.KEY_SYNC_FLAG, object.getSyncFlag());
            contentValues.put(DataBaseHelper.KEY_SYNC_DATE, object.getSyncDate());
            contentValues.put(DataBaseHelper.KEY_READ, object.getRead());
            contentValues.put(DataBaseHelper.KEY_READ_DATE, object.getReadDate());
            contentValues.put(DataBaseHelper.KEY_SYNC_USER, object.getSyncByUser());
            contentValues.put(DataBaseHelper.KEY_IS_DISPATCH, isDispatch);

            database.insert(DataBaseHelper.TABLE_CFA_DISPATCH, null, contentValues);

            Log.e(TAG, "TABLE CFA DISPATCH INSERT SUCCESSFULLY");
        } catch (Exception e) {
            e.printStackTrace();
        }

        return true;
    }

//    public boolean InsertDistributorDispatch(IshopDistributorDispatch object, int isDispatch) {
//
//        ContentValues contentValues = new ContentValues();
//
//        contentValues.put(DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_ID, object.getDistributorDispatchId());
//        contentValues.put(DataBaseHelper.KEY_CUSTOMER_FROM_ID, object.getCustomerFromId());
//        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TO_ID, object.getCustomerToId());
//        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID, object.getCustomerTypeCountryId());
//        contentValues.put(DataBaseHelper.KEY_IS_NEW_CUSTOMER, object.getIsNewCustomer());
//        contentValues.put(DataBaseHelper.KEY_DISPATCH_DATE, object.getDispatchDate());
//        //  contentValues.put(DataBaseHelper.KEY_RECEIVED, object.getReceived());
//        // contentValues.put(DataBaseHelper.KEY_RECEIVED_DATE, object.getReceivedDate());
//        contentValues.put(DataBaseHelper.KEY_COUNTRY_ID, object.getCountryId());
//        contentValues.put(DataBaseHelper.KEY_CREATED_BY_USER, object.getCreatedByUser());
//        contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
//        contentValues.put(DataBaseHelper.KEY_STATUS, object.getStatus());
//        contentValues.put(DataBaseHelper.KEY_CREATE_ON, object.getCreatedOn());
//        contentValues.put(DataBaseHelper.KEY_MODIFIED_ON, object.getModifiedOn());
//        contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
//        contentValues.put(DataBaseHelper.KEY_SYNC_CODE, object.getSyncCode());
//        contentValues.put(DataBaseHelper.KEY_SYNC_FLAG, object.getSyncFlag());
//        contentValues.put(DataBaseHelper.KEY_SYNC_DATE, object.getSyncDate());
//        contentValues.put(DataBaseHelper.KEY_SYNC_USER, object.getSyncByUser());
//        contentValues.put(DataBaseHelper.KEY_READ, object.getRead());
//        contentValues.put(DataBaseHelper.KEY_READ_DATE, object.getReadDate());
//        contentValues.put(DataBaseHelper.KEY_IS_DISPATCH, isDispatch);
//        contentValues.put(DataBaseHelper.KEY_customer_to_name, object.getCustomer_to_name());
//        contentValues.put(DataBaseHelper.KEY_customer_to_phone, object.getCustomer_to_phone());
//        contentValues.put(DataBaseHelper.KEY_new_customer_type, object.getNew_customer_type());
//
//        long d = database.insert(DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH, null, contentValues);
//        if (d > 0) {
//            Log.e(TAG, "TABLE DISTRIBUTOR DISPATCH INSERT SUCCESSFULLY");
//        } else {
//            Log.e(TAG, "TABLE DISTRIBUTOR DISPATCH not INSERT SUCCESSFULLY");
//        }
//
//        return true;
//    }

    public boolean InsertNewCustomer(CreateNewCustomer object) {

        ContentValues contentValues = new ContentValues();

        contentValues.put(DataBaseHelper.KEY_CUSTOMER_NAME, object.getCustomerName());
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTY_ID, object.getCustomerTypeCountyId());
        contentValues.put(DataBaseHelper.KEY_MOBILE_NO, object.getMobileNo());
        contentValues.put(DataBaseHelper.KEY_CREATED_BY_USER, object.getCreatedByUser());
        contentValues.put(DataBaseHelper.KEY_CREATE_ON, object.getCreatedOn());
        //contentValues.put(DataBaseHelper.KEY_COUNTRY_ID, object.getCountryId());
        contentValues.put(DataBaseHelper.KEY_SYNC_CODE, object.getSyncCode());
        contentValues.put(DataBaseHelper.KEY_SYNC_FLAG, object.getSyncFlag());
        contentValues.put(DataBaseHelper.KEY_SYNC_DATE, object.getSyncDate());
        contentValues.put(DataBaseHelper.KEY_SYNC_USER, object.getSyncByUser());

        database.insert(DataBaseHelper.TABLE_NEW_CUSTOMER, null, contentValues);
        Log.e(TAG, "TABLE NEW CUSTOMER INSERT SUCCESSFULLY");

        return true;
    }

    public void InsertTABLE_POLITICAL_LEVEL(final PoliticalLevel objectData) {

        ContentValues contentValues = new ContentValues();

        contentValues.put(DataBaseHelper.KEY_POLITICAL_GEOGRAPHY_COUNTRY_LEVEL_ID, objectData
                .getPoliticalGeographyCountrylevelId());
        contentValues.put(DataBaseHelper.KEY_LEVEL_NAME, objectData.getLevelName());
        contentValues.put(DataBaseHelper.KEY_LEVEL, objectData.getLevel());

        database.insert(DataBaseHelper.TABLE_POLITICAL_LEVEL, null, contentValues);

        Log.e(TAG, "TABLE_POLITICAL_LEVEL Add SUCCESSFULLY");
    }

    public void InsertSalesRepInitiatedProductNew() {
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_SALES_REP_INITIATED_PRODUCT + " (" + DataBaseHelper.SRIP_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                    + DataBaseHelper.FK_PBG_COUNTRY_ID + ","
                    + DataBaseHelper.FK_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.DECQTY + ","
                    + DataBaseHelper.VARREMARKS + ","
                    + DataBaseHelper.KEY_DELETED + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.CREATED_BY_NAME + ","
                    + DataBaseHelper.MODIFIED_BY_NAME + ","
                    + DataBaseHelper.SYNC_BY_USER + ","
                    + DataBaseHelper.SCAN_COUNT
                    + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            for (SalesRepInitiatedProduct object : arrayListSalesRepInitiatedProduct) {
                SQLiteStatement statement = database.compileStatement(sql);
                statement.bindString(1, object.getSrip_id());
                statement.bindString(2, object.getCustomer_from_id());
                statement.bindString(3, object.getCustomer_to_id());
                statement.bindString(4, object.getFk_PBG_Country_id());
                statement.bindString(5, object.getFk_Sku_Country_id());
                statement.bindString(6, object.getDecQty());
                statement.bindString(7, object.getVarRemarks());
                statement.bindString(8, object.getDeleted());
                statement.bindString(9, object.getStatus());
                statement.bindString(10, object.getCreated_by_user());
                statement.bindString(11, object.getModified_by_user());
                statement.bindString(12, object.getCreated_on());
                statement.bindString(13, object.getModified_on());
                statement.bindString(14, object.getSync_code());
                statement.bindString(15, object.getSync_flag());
                statement.bindString(16, object.getSync_date());
                statement.bindString(17, object.getCreated_by_name());
                statement.bindString(18, object.getModified_by_name());
                statement.bindString(19, object.getSync_by_user());
                statement.bindString(20, object.getScan_count());
                statement.execute();
                Log.e(TAG, "TABLE_SALES_REP_INITIATED_PRODUCT Add SUCCESSFULLY");
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }

    }

    public void InsertCtoCMapping(CtoCMapping objectData) {
        ContentValues contentValues = new ContentValues();
        contentValues.put(DataBaseHelper.FROM_CUSTOMER_ID, objectData.getFrom_customer_id());
        contentValues.put(DataBaseHelper.TO_CUSTOMER_ID, objectData.getTo_customer_id());

        database.insert(DataBaseHelper.TABLE_CTOCMAPPING, null, contentValues);

        Log.e(TAG, "TABLE_SALES_REP_INITIATED_PRODUCT Add SUCCESSFULLY");
    }

    public void InsertCtoEMapping(CtoEMapping objectData) {
        try {
            ContentValues contentValues = new ContentValues();
            contentValues.put(DataBaseHelper.EMPLOYEE_ID, objectData.getEmployee_id());
            contentValues.put(DataBaseHelper.CUSTOMER_ID, objectData.getCustomer_id());
            contentValues.put(DataBaseHelper.USER_CODE, objectData.getUser_code());
            contentValues.put(DataBaseHelper.DISPLAY_NAME, objectData.getDisplay_name());
            contentValues.put(DataBaseHelper.EMAIL, objectData.getEmail());
            contentValues.put(DataBaseHelper.PRIMARY_MOBILE_NO, objectData.getPrimary_mobile_no());

            database.insert(DataBaseHelper.TABLE_CTOEMAPPING, null, contentValues);

            Log.e(TAG, "TABLE_SALES_REP_INITIATED_PRODUCT Add SUCCESSFULLY");
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public void InsertUserConfigurationMst(UserConfigurationMst objectData) {
        ContentValues contentValues = new ContentValues();
        contentValues.put(DataBaseHelper.ID, objectData.getId());
        contentValues.put(DataBaseHelper.DISPATCH_SCAN_TYPE, objectData.getDispatch_scan_type());
        Log.e("DataBaseHelper.RECEIVED", "           " + objectData.getReceived());
        contentValues.put(DataBaseHelper.RECEIVED, objectData.getReceived());
        contentValues.put(DataBaseHelper.RETURNED, objectData.getReturned());
        contentValues.put(DataBaseHelper.Political_Geo_4, objectData.getPolitical_geo_level_4());
        contentValues.put(DataBaseHelper.RECIEVE_Days, objectData.getIntReceiveDays());
        contentValues.put(DataBaseHelper.RECIEVE_POPUP, objectData.getCharReceivePopUp());
        contentValues.put(DataBaseHelper.CUSTOMER_SYNC_DISABLE, objectData.getChr_cust_sync_enable());
        contentValues.put(DataBaseHelper.INT_SYNC_MINUTES, objectData.getInt_sync_minutes());
        contentValues.put(DataBaseHelper.INT_SCAN_SCREEN, objectData.getIntScanScreen());
        contentValues.put(DataBaseHelper.CHAR_PALLATE_ENABLE, objectData.getChr_pallet_enable());

        contentValues.put(DataBaseHelper.FTP_HOST, objectData.getFtp_host());
        contentValues.put(DataBaseHelper.FTP_PORT, objectData.getFtp_port());
        contentValues.put(DataBaseHelper.FTP_USERNAME, objectData.getFtp_username());
        contentValues.put(DataBaseHelper.FTP_PASSWORD, objectData.getFtp_password());
        contentValues.put(DataBaseHelper.INT_SCAN_ALERT_MINUTES, objectData.getInt_scan_alert_bg_minutes());
        contentValues.put(DataBaseHelper.INT_SYNC_ALERT_MINUTES, objectData.getInt_sync_alert_bg_minutes());
        contentValues.put(DataBaseHelper.CHR_SCM_CPM, objectData.getChr_scm_cpm());
        contentValues.put(DataBaseHelper.INT_SALES_RET_LIMIT, objectData.getInt_sales_return_limit());
        contentValues.put(DataBaseHelper.IS_SYNC_POPUP, objectData.getIs_Sync_PopUp());
        contentValues.put(DataBaseHelper.IS_EXPIRE_ENABLE, objectData.getIs_expire_enable());
        contentValues.put(DataBaseHelper.INT_MINIMUM_MINS, objectData.getInt_minimum_minutes());
        contentValues.put(DataBaseHelper.INT_MAXIMUM_MINS, objectData.getInt_maximum_minutes());
        contentValues.put(DataBaseHelper.CHR_SCAN_TYPE_RADIO_BTN, objectData.getChr_scan_type_radio_btn());

        database.insert(DataBaseHelper.USER_CONFIGURATION_MST, null, contentValues);

        Log.e(TAG, "TABLE UserConfigurationMst Add SUCCESSFULLY");
    }

    public void InsertCustomerTypeDetails(CustomerTypeDetails objectData) {
        ContentValues contentValues = new ContentValues();
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID, objectData.getCustomer_type_country_id());
        contentValues.put(DataBaseHelper.KEY_customer_level, objectData.getCustomer_level());
        contentValues.put(DataBaseHelper.KEY_customer_type_name, objectData.getCustomer_type_name());
        contentValues.put(DataBaseHelper.KEY_Customer_type_name_country, objectData.getCustomer_type_name_country());
        contentValues.put(DataBaseHelper.AUTO_SYNC, objectData.getAutosync());
        contentValues.put(DataBaseHelper.AUTO_SYNC_DAY, objectData.getAutosyncday());

        database.insert(DataBaseHelper.TABLE_CustomerType_Details, null, contentValues);

        Log.e(TAG, "TABLE CustomerTypeDetails Add SUCCESSFULLY");
    }


    /**
     * Inserting EToRMapping
     *
     * @param arrayEToRMapping
     */
    public void InsertETORMAPPINGNew(JSONArray arrayEToRMapping) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_ETORMAPPING);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_ETORMAPPING + " ("
                    + DataBaseHelper.KEY_ID + ","
                    + DataBaseHelper.KEY_EMAIL + ","
                    + DataBaseHelper.KEY_USER_CODE + ","
                    + DataBaseHelper.KEY_BUSSINESS_CODE + ","
                    + DataBaseHelper.KEY_DISPLAY_NAME + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_CODE + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_NAME + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_NAME + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_CODE + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_LEVEL + ","
                    + DataBaseHelper.KEY_POLITICAL_GEO_ID + ","
                    + DataBaseHelper.KEY_political_geography_countrylevel_id + ","
                    + DataBaseHelper.KEY_political_regional_level + ","
                    + DataBaseHelper.KEY_SAP_ID + ","
                    + DataBaseHelper.DISPATCH_SCAN_TYPE + ","
                    + DataBaseHelper.PRIMARY_MOBILE_NO
                    + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            try {
                for (int i = 0; i < arrayEToRMapping.length(); i++) {
                    JSONObject object = arrayEToRMapping.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("id"));
                    statement.bindString(2, object.getString("email"));
                    statement.bindString(3, object.getString("user_code"));
                    statement.bindString(4, object.getString("bussiness_code"));
                    statement.bindString(5, object.getString("display_name"));
                    statement.bindString(6, object.getString("customer_type_country_id"));
                    statement.bindString(7, object.getString("customer_type_country_code"));
                    statement.bindString(8, object.getString("customer_type_country_name"));
                    statement.bindString(9, object.getString("customer_type_regional_id"));
                    statement.bindString(10, object.getString("customer_type_regional_name"));
                    statement.bindString(11, object.getString("customer_type_regional_code"));
                    statement.bindString(12, object.getString("customer_regional_level"));
                    statement.bindString(13, object.getString("political_geo_id"));
                    statement.bindString(14, object.getString("political_geography_countrylevel_id"));
                    statement.bindString(15, object.getString("political_regional_level"));
                    statement.bindString(16, object.getString("sap_id"));
                    statement.bindString(17, object.getString("dispatch_scan_type"));
                    statement.bindString(18, object.getString("primary_mobile_no"));
                    statement.execute();
                }
            } catch (Exception e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertETORMAPPINGNew";
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertETORMAPPINGNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertETORMAPPINGNew";
        } finally {
            database.endTransaction();
//            close();
        }
    }


    public void InsertRtoRMappingNew(JSONArray arrarRtoRMapping) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_RTORMAPPING);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RTORMAPPING + " ("
                    + DataBaseHelper.FROM_CUSTOMER_LEVEL + ","
                    + DataBaseHelper.FROM_CUSTOMER_ID + ","
                    + DataBaseHelper.TO_CUSTOMER_LEVEL + ","
                    + DataBaseHelper.TO_CUSTOMER_ID + ") VALUES (?,?,?,?)";

            try {
                for (int i = 0; i < arrarRtoRMapping.length(); i++) {
                    JSONObject object = arrarRtoRMapping.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("from_customer_level"));
                    statement.bindString(2, object.getString("from_customer_id"));
                    statement.bindString(3, object.getString("to_customer_level"));
                    statement.bindString(4, object.getString("to_customer_id"));
                    statement.execute();
                }
            } catch (JSONException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRtoRMappingNew";
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRtoRMappingNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRtoRMappingNew";
        } finally {
            database.endTransaction();
//            close();
        }
    }

    public void InsertDtoRMappingNew(JSONArray arrayDtoRMapping) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_DTORMAPPING);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DTORMAPPING + " ("
                    + DataBaseHelper.FROM_CUSTOMER_LEVEL + ","
                    + DataBaseHelper.FROM_CUSTOMER_ID + ","
                    + DataBaseHelper.TO_CUSTOMER_LEVEL + ","
                    + DataBaseHelper.TO_CUSTOMER_ID + ") VALUES (?,?,?,?)";

            try {
                for (int i = 0; i < arrayDtoRMapping.length(); i++) {
                    JSONObject object = arrayDtoRMapping.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("from_customer_level"));
                    statement.bindString(2, object.getString("from_customer_id"));
                    statement.bindString(3, object.getString("to_customer_level"));
                    statement.bindString(4, object.getString("to_customer_id"));
                    statement.execute();
                }
            } catch (Exception e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDtoRMappingNew";
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDtoRMappingNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDtoRMappingNew";
        } finally {
            database.endTransaction();
//            close();
        }

    }

    public void InsertRETAILERSCANNEDIN(ScannedPoints objectData) {
        ContentValues contentValues = new ContentValues();
        contentValues.put(DataBaseHelper.TOTALINSCANNED, objectData.getTotalInScanned());
        contentValues.put(DataBaseHelper.DTMONTH, objectData.getDtmonth());
        database.insert(DataBaseHelper.TABLE_RETAILER_SCANNED_IN_STICKER, null, contentValues);
        Log.e(TAG, "TABLE_RETAILER_SCANNED_IN_STICKER");
    }

    // SELECTION QUERY //
//    public ArrayList<CityModel> getCityList(Context context) {
//
//        ArrayList<CityModel> arrayListCity = new ArrayList<>();
//
//        CityModel objectCity = new CityModel();
//        objectCity.setPoliticalId("0");
//        //   objectCity.setCityName(context.getResources().getString(R.string.province));
//        if (Content.getPreferenceValue(context, Const.LANGUAGE_CODE).equalsIgnoreCase("en") || Content.getPreferenceValue(context, Const.LANGUAGE_CODE).equalsIgnoreCase("") || Content.getPreferenceValue(context, Const.LANGUAGE_CODE).equalsIgnoreCase("th")) {
//            objectCity.setCityName(Content.getPreferenceValue(context, Const.CUSTOMER_GEO_LEVEL));
//        } else if (Content.getPreferenceValue(context, Const.LANGUAGE_CODE).equalsIgnoreCase("in")) {
//            objectCity.setCityName(context.getString(R.string.province));
//        }
////        objectCity.setCityName(Content.getPreferenceValue(context, Const.CUSTOMER_GEO_LEVEL));
////        objectCity.setCityName(context.getString(R.string.province));
//        arrayListCity.add(objectCity);
//        String query = "select pd.political_geo_id,pd.political_geography_name from political_details as pd " +
//                "INNER JOIN political_level  as pl on pd.geo_level_id=pl.political_geography_countrylevel_id where " +
//                "pl.level='L5' order by pd.political_geography_name";
//        Log.e(TAG, "QUERY : " + query);
//
//
//        /*
//        SELECT pd.political_geo_id,
//" +
//           "       pd.political_geography_name\n" +
//           "  FROM political_details AS pd\n" +
//           "       INNER JOIN political_level AS pl\n" +
//           "               ON pd.geo_level_id = pl.political_geography_countrylevel_id\n" +
//           " WHERE pl.level = 'L5';
//        * */
//        Cursor cursor = database.rawQuery(query, null);
//        try {
//            if (cursor != null && cursor.moveToFirst()) {
//                do {
//                    CityModel object = new CityModel();
//                    object.setPoliticalId(cursor.getString(0));
//                    object.setCityName(cursor.getString(1));
//                    arrayListCity.add(object);
//                    // Content.access_role_vice_menu.add(cursor.getString(cursor.getColumnIndex(DataBase_V1.ALIAS))
//                    // ); // jo_in.getString("alias")
//                    //Content.access_role_vice_menu_by_position.put(Integer.parseInt(cursor.getString(cursor
//                    // .getColumnIndex(DataBase_V1.ORDER))), cursor.getString(cursor.getColumnIndex
//                    // (DataBase_V1.ALIAS)));
//                    // Employee
//                    // listEmployeeSelection
//                } while (cursor.moveToNext());
//            }
//        } catch (Exception e) {
//            e.printStackTrace();
//        } finally {
//            if (cursor != null) cursor.close();
//        }
//
//        return arrayListCity;
//    }

    public static final ArrayList<String> distname = new ArrayList<>();
//    public static final ArrayList<WhereHouseDispatchDistributorModel> distname1 = new ArrayList<>();
    public static final ArrayList<String> distnameSalesReturn = new ArrayList<>();

    private int getCustomerLoginID() {
        int id = 0;
        Cursor c = database.rawQuery("SELECT fk_personGlcode FROM login;", null);
        if (c != null && c.getCount() > 0) {
            c.moveToFirst();
            int activity_planning_id = Integer.parseInt(c.getString(c.getColumnIndex("fk_personGlcode")));
            c.close();
            return activity_planning_id;
        }
        return id;
    }

    public void updateCFADispatch(String dispatchId) {
        //String query = "UPDATE " + DataBaseHelper.TABLE_CFA_DISPATCH + " SET " + DataBaseHelper
        // .KEY_IS_DISPATCH + " = '1'" + " WHERE " + DataBaseHelper.KEY_CFA_DISPATCH_ID + " = " + dispatchId;
        //database.rawQuery(query, null);
        ContentValues cv = new ContentValues();
        cv.put(DataBaseHelper.KEY_IS_DISPATCH, 1);
        cv.put(DataBaseHelper.KEY_SYNC_FLAG, "Y");
        long id = database.update(DataBaseHelper.TABLE_CFA_DISPATCH, cv, DataBaseHelper.KEY_CFA_DISPATCH_ID +
                " = " + dispatchId, null);
        if (id > 0) {
            Log.e("updateCFADispatch", "done");
        } else {
            Log.e("updateCFADispatch", "not done");
        }
    }

    public String getSynchronization() {
        JSONArray TABLE_TRANSACTION_ERROR = getJsonFromTable(DataBaseHelper.TABLE_TRANSACTION_ERROR_LOG, database, "0");
        JSONArray TABLE_ISHOP_PALLET_DETAILS = getJsonFromTable(DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS, database, "0");
        JSONArray TABLE_DEVICE_TOKEN = getJsonFromTable(DataBaseHelper.TABLE_DEVICE_TOKEN, database, "0");
        JSONArray TABLE_SAVE_OFFLINE_LOG = getJsonFromTable(DataBaseHelper.TABLE_SAVE_OFFLINE_LOG, database, "0");
        JSONArray TABLE_TOLLER_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_TOLLER_DISPATCH, database, "0");
        JSONArray TABLE_TOLLER_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper
                        .TABLE_TOLLER_DISPATCH_PRODUCT,
                database, "0");
        JSONArray TABLE_RETAILER_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_RETAILER_DISPATCH,
                database, "1");
        JSONArray TABLE_RETAILER_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper
                        .TABLE_RETAILER_DISPATCH_PRODUCT,
                database, "0");
        //asdf
        JSONArray TABLE_CFA_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_CFA_DISPATCH, database, "1");
        JSONArray TABLE_CFA_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_CFA_DISPATCH_PRODUCT,
                database, "0");
        JSONArray TABLE_SAMPLE_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH, database, "1");
        JSONArray TABLE_SAMPLE_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT,
                database, "0");
        JSONArray TABLE_CFA_RETURN = getJsonFromTable(DataBaseHelper.TABLE_CFA_RETURN, database, "0");

        JSONArray TABLE_DISTRIBUTOR_DISPATCH = getJsonFromTable(DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH,
                database, "1");

        JSONArray TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = getJsonFromTable(DataBaseHelper
                .TABLE_DISTRIBUTOR_DISPATCH_PRODUCT, database, "0");

        //For Sample and FOC Invalid
        TABLE_DISTRIBUTOR_DISPATCH=addDistributorDispatchForSampleAndFOC(TABLE_DISTRIBUTOR_DISPATCH);
        TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = addDistributorDispatchForSampleAndFOCProduct(TABLE_DISTRIBUTOR_DISPATCH_PRODUCT);


        //Amit Vaghela changes
        JSONArray TABLE_ishop_distributor_received = getJsonFromTable(DataBaseHelper
                        .TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED,
                database, "1");
        JSONArray TABLE_ishop_distributor_received_product = getJsonFromTable(DataBaseHelper
                .TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT, database, "0");
        JSONArray TABLE_ishop_reatialer_received = getJsonFromTable(DataBaseHelper
                        .TABLE_BF_ISHOP_RETAILER_RECEIVED,
                database, "1");
        JSONArray TABLE_ishop_reatialer_received_product = getJsonFromTable(DataBaseHelper
                .TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT, database, "0");

        JSONArray TABLE_bf_ishop_cfa_return = getJsonFromTable(DataBaseHelper.TABLE_CFA_RETURN, database, "1");
        JSONArray TABLE_bf_ishop_cfa_return_product = getJsonFromTable(DataBaseHelper.TABLE_CFA_RETURN_PRODUCT,
                database, "0");

        JSONArray TABLE_bf_ishop_distributor_return_request = getJsonFromTable(DataBaseHelper
                .TABLE_DISTRIBUTOR_RETURN_REQUEST, database, "1");
        JSONArray TABLE_bf_ishop_distributor_return_request_product = getJsonFromTable(DataBaseHelper
                        .TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT,
                database, "0");

        JSONArray TABLE_SALES_REP_INITIATED_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_SALES_REP_INITIATED_PRODUCT, database, "2");


        JSONArray TABLE_CFA_DAMAGE = getJsonFromTable(DataBaseHelper.TABLE_CFA_DAMAGE, database, "0");
        JSONArray TABLE_CFA_DAMAGE_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_CFA_DAMAGE_PRODUCT, database, "0");

        JSONArray TABLE_DIST_DAMAGE = getJsonFromTable(DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE, database, "0");
        JSONArray TABLE_DIST_DAMAGE_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT, database, "0");

        JSONArray TABLE_RET_DAMAGE = getJsonFromTable(DataBaseHelper.TABLE_RETAILER_DAMAGE, database, "0");
        JSONArray TABLE_RET_DAMAGE_PRODUCT = getJsonFromTable(DataBaseHelper.TABLE_RETAILER_DAMAGE_PRODUCT, database, "0");
        //JSONArray TABLE_CustomerType_Details = getJsonFromTable(DataBaseHelper.TABLE_CustomerType_Details, database, "0");
        /*  TODO CHange By Praveen  */
        JSONArray TABLE_VIDEO_HELP_DETAIL = getJsonFromTable(DataBaseHelper.TABLE_HELP_VIDEO_DETAIL, database, "0");

        JSONObject jsonObject;
        Synchronization object = new Synchronization();

        object.setIshop_distributor_return(DistributorReturnSyncData());
        object.setIshop_distributor_return_product(DistributorReturnProductSyncData());

        String jsonObject1 = AppUtil.getJsonFromObject(object);
        try {
            jsonObject = new JSONObject(jsonObject1);

            Log.e("", "" + TABLE_TOLLER_DISPATCH);
            if (TABLE_TOLLER_DISPATCH != null && TABLE_TOLLER_DISPATCH.length() > 0)
                jsonObject.put("ishop_toller_dispatch", TABLE_TOLLER_DISPATCH);

            if (TABLE_TOLLER_DISPATCH_PRODUCT != null && TABLE_TOLLER_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_toller_dispatch_product", TABLE_TOLLER_DISPATCH_PRODUCT);

            Log.e("", "" + TABLE_RETAILER_DISPATCH);
            if (TABLE_RETAILER_DISPATCH != null && TABLE_RETAILER_DISPATCH.length() > 0)
                jsonObject.put("ishop_retailer_dispatch", TABLE_RETAILER_DISPATCH);

            Log.e("", "" + TABLE_RETAILER_DISPATCH_PRODUCT);
            if (TABLE_RETAILER_DISPATCH_PRODUCT != null && TABLE_RETAILER_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_retailer_dispatch_product", TABLE_RETAILER_DISPATCH_PRODUCT);

            if (TABLE_CFA_DISPATCH != null && TABLE_CFA_DISPATCH.length() > 0)
                jsonObject.put("ishop_cfa_dispatch", TABLE_CFA_DISPATCH);

            if (TABLE_CFA_DISPATCH_PRODUCT != null && TABLE_CFA_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_cfa_dispatch_product", TABLE_CFA_DISPATCH_PRODUCT);

            if (TABLE_SAMPLE_DISPATCH != null && TABLE_SAMPLE_DISPATCH.length() > 0)
                jsonObject.put("ishop_sample_dispatch", TABLE_SAMPLE_DISPATCH);

            if (TABLE_SAMPLE_DISPATCH_PRODUCT != null && TABLE_SAMPLE_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_sample_dispatch_product", TABLE_SAMPLE_DISPATCH_PRODUCT);

            if (TABLE_CFA_RETURN != null && TABLE_CFA_RETURN.length() > 0)
                jsonObject.put("ishop_cfa_return", TABLE_CFA_RETURN);

            if (TABLE_DISTRIBUTOR_DISPATCH != null && TABLE_DISTRIBUTOR_DISPATCH.length() > 0)
                jsonObject.put("ishop_distributor_dispatch", TABLE_DISTRIBUTOR_DISPATCH);

            if (TABLE_DISTRIBUTOR_DISPATCH_PRODUCT != null && TABLE_DISTRIBUTOR_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_distributor_dispatch_product", TABLE_DISTRIBUTOR_DISPATCH_PRODUCT);

            if (TABLE_ishop_distributor_received != null && TABLE_ishop_distributor_received.length() > 0)
                jsonObject.put("ishop_distributor_received", TABLE_ishop_distributor_received);

            if (TABLE_ishop_distributor_received_product != null && TABLE_ishop_distributor_received_product
                    .length() > 0)
                jsonObject.put("ishop_distributor_received_product", TABLE_ishop_distributor_received_product);

            if (TABLE_ishop_reatialer_received != null && TABLE_ishop_reatialer_received.length() > 0)
                jsonObject.put("ishop_retailer_received", TABLE_ishop_reatialer_received);

            if (TABLE_ishop_reatialer_received_product != null && TABLE_ishop_reatialer_received_product
                    .length() > 0)
                jsonObject.put("ishop_retailer_received_product", TABLE_ishop_reatialer_received_product);

            if (TABLE_bf_ishop_cfa_return != null && TABLE_bf_ishop_cfa_return.length() > 0)
                jsonObject.put("ishop_cfa_return", TABLE_bf_ishop_cfa_return);

            if (TABLE_bf_ishop_cfa_return_product != null && TABLE_bf_ishop_cfa_return_product.length() > 0)
                jsonObject.put("ishop_cfa_return_product", TABLE_bf_ishop_cfa_return_product);

            if (TABLE_bf_ishop_distributor_return_request != null && TABLE_bf_ishop_distributor_return_request
                    .length() > 0)
                jsonObject.put("ishop_distributor_return_request", TABLE_bf_ishop_distributor_return_request);

            if (TABLE_bf_ishop_distributor_return_request_product != null &&
                    TABLE_bf_ishop_distributor_return_request_product.length() > 0)
                jsonObject.put("ishop_distributor_return_request_product",
                        TABLE_bf_ishop_distributor_return_request_product);

            if (TABLE_SALES_REP_INITIATED_PRODUCT != null && TABLE_SALES_REP_INITIATED_PRODUCT.length() > 0)
                jsonObject.put("sales_rep_initiated_product", TABLE_SALES_REP_INITIATED_PRODUCT);

            if (TABLE_CFA_DAMAGE != null && TABLE_CFA_DAMAGE.length() > 0)
                jsonObject.put("ishop_cfa_damage", TABLE_CFA_DAMAGE);

            if (TABLE_CFA_DAMAGE_PRODUCT != null && TABLE_CFA_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_cfa_damage_product", TABLE_CFA_DAMAGE_PRODUCT);


            if (TABLE_DIST_DAMAGE != null && TABLE_DIST_DAMAGE.length() > 0)
                jsonObject.put("ishop_distributor_damage", TABLE_DIST_DAMAGE);

            if (TABLE_DIST_DAMAGE_PRODUCT != null && TABLE_DIST_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_distributor_damage_product", TABLE_DIST_DAMAGE_PRODUCT);


            if (TABLE_RET_DAMAGE != null && TABLE_RET_DAMAGE.length() > 0)
                jsonObject.put("ishop_retailer_damage", TABLE_RET_DAMAGE);

            if (TABLE_RET_DAMAGE_PRODUCT != null && TABLE_RET_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_retailer_damage_product", TABLE_RET_DAMAGE_PRODUCT);


            /*TODO Changes By Praveen */

            if (TABLE_VIDEO_HELP_DETAIL != null && TABLE_VIDEO_HELP_DETAIL.length() > 0) {
                jsonObject.put("bf_master_cpm_help_video_details", TABLE_VIDEO_HELP_DETAIL);
            }

            if (TABLE_SAVE_OFFLINE_LOG != null && TABLE_SAVE_OFFLINE_LOG.length() > 0) {
                jsonObject.put("bf_ishop_save_offline_log_android_cpm", TABLE_SAVE_OFFLINE_LOG);
            }

            if (TABLE_DEVICE_TOKEN != null && TABLE_DEVICE_TOKEN.length() > 0) {
                jsonObject.put("table_device_token", TABLE_DEVICE_TOKEN);
            }

            if (TABLE_TRANSACTION_ERROR != null && TABLE_TRANSACTION_ERROR.length() > 0) {
                jsonObject.put("bf_ishop_transaction_error_log", TABLE_TRANSACTION_ERROR);
            }

            if (TABLE_ISHOP_PALLET_DETAILS != null && TABLE_ISHOP_PALLET_DETAILS.length() > 0) {
                jsonObject.put("bf_ishop_pallet_details", TABLE_ISHOP_PALLET_DETAILS);
            }

            writeStringAsFile(jsonObject.toString(), "RE_CPM",context);
            Log.e(TAG, "SYNCHRONIZATION JSON : " + jsonObject);
            return jsonObject.toString();
        } catch (JSONException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            Log.e("error", "->>" + e);
            return "json not found";
        }
    }

    public JSONArray getJsonFromTable(String tableName, SQLiteDatabase db, String isDispatch) {
        JSONArray jsonTableData = new JSONArray();
        String qry = "";
        if (isDispatch.equalsIgnoreCase("1")) {
            qry = "select * from  " + tableName + " where sync_flag = 'Y' and isDispatch = 1";
        } else if (isDispatch.equalsIgnoreCase("2")) {
            qry = "select * from  " + tableName + " where sync_flag = 'Y'";
        } else {
            if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_TOLLER_DISPATCH_PRODUCT)) {
                qry = "select * from  " + tableName + " where sync_flag = 'Y'";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_CFA_DISPATCH_PRODUCT)) {
                qry = "SELECT bicdp.* FROM bf_ishop_cfa_dispatch_product as bicdp\n" +
                        " INNER JOIN bf_ishop_cfa_dispatch as bicd on " +
                        " bicdp.cfa_dispatch_id=bicd.cfa_dispatch_id\n" +
                        " WHERE bicdp.sync_flag='Y' AND bicd.isDispatch=1";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT)) {
                qry = "SELECT biddp.* FROM bf_ishop_distributor_dispatch_product as biddp\n" +
                        " INNER JOIN bf_ishop_distributor_dispatch as bidd on biddp.distributor_dispatch_id=bidd" +
                        ".distributor_dispatch_id\n" +
                        " where biddp.sync_flag='Y' AND bidd.isDispatch=1";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_RETAILER_DISPATCH_PRODUCT)) {
                qry = "SELECT birdp.* FROM bf_ishop_retailer_dispatch_product as birdp\n" +
                        " INNER JOIN bf_ishop_retailer_dispatch as bird on birdp.retailer_dispatch_id=bird" +
                        ".retailer_dispatch_id\n" +
                        " where birdp.sync_flag='Y' AND bird.isDispatch=1";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT)) {
                qry = "SELECT birdp.* FROM bf_ishop_distributor_received_product as birdp\n" +
                        " INNER JOIN bf_ishop_distributor_received as bird on birdp.distributor_received_id=bird" +
                        ".distributor_received_id\n" +
                        " where birdp.sync_flag='Y' AND bird.isDispatch=1";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT)) {
                qry = "SELECT birdp.*\n" +
                        "  FROM bf_ishop_retailer_received_product AS birdp\n" +
                        "       INNER JOIN bf_ishop_retailer_received AS bird\n" +
                        "               ON birdp.retailer_received_id = bird.retailer_received_id\n" +
                        " WHERE birdp.sync_flag = 'Y' \n" +
                        "       AND\n" +
                        "       bird.isDispatch = 1;\n";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_CFA_RETURN_PRODUCT)) {
                qry = "SELECT birdp.*\n" +
                        "  FROM bf_ishop_cfa_return_product AS birdp\n" +
                        "       INNER JOIN bf_ishop_cfa_return AS bird\n" +
                        "               ON birdp.cfa_return_id = bird.cfa_return_id\n" +
                        " WHERE birdp.sync_flag = 'Y' \n" +
                        "       AND\n" +
                        "       bird.isDispatch = 1;\n";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT)) {
                qry = "SELECT birdp.*\n" +
                        "  FROM bf_ishop_distributor_return_request_product AS birdp\n" +
                        "       INNER JOIN bf_ishop_distributor_return_request AS bird\n" +
                        "               ON birdp.distributor_return_request_id = bird.distributor_return_request_id\n" +
                        " WHERE birdp.sync_flag = 'Y' \n" +
                        "       AND\n" +
                        "       bird.isDispatch = 1;\n";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_CustomerType_Details)) {
                qry = "Select * from CustomerType_Details;";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_CFA_DAMAGE)) {
                qry = "Select * from bf_ishop_cfa_damage WHERE isDamage='1' AND sync_flag='Y';";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_CFA_DAMAGE_PRODUCT)) {
                qry = "SELECT bicdp.*\n" +
                        "  FROM bf_ishop_cfa_damage_product AS bicdp\n" +
                        "       INNER JOIN\n" +
                        "       bf_ishop_cfa_damage AS bicd ON bicd.cfa_damage_id = bicdp.cfa_damage_id\n" +
                        " WHERE bicdp.sync_flag = 'Y' AND \n" +
                        "       bicd.isDamage = '1';";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE)) {
                qry = "Select * from bf_ishop_distributor_damage WHERE isDamage='1' AND sync_flag='Y';";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_DISTRIBUTOR_DAMAGE_PRODUCT)) {
                qry = "SELECT bicdp.*\n" +
                        "  FROM bf_ishop_distributor_damage_product AS bicdp\n" +
                        "       INNER JOIN\n" +
                        "       bf_ishop_distributor_damage AS bicd ON bicd.distributor_damage_id = bicdp.distributor_damage_id\n" +
                        " WHERE bicdp.sync_flag = 'Y' AND \n" +
                        "       bicd.isDamage = '1';";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_RETAILER_DAMAGE)) {
                qry = "Select * from bf_ishop_retailer_damage WHERE isDamage='1' AND sync_flag='Y';";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_RETAILER_DAMAGE_PRODUCT)) {
                qry = "SELECT bicdp.*\n" +
                        "  FROM bf_ishop_retailer_damage_product AS bicdp\n" +
                        "       INNER JOIN\n" +
                        "       bf_ishop_retailer_damage AS bicd ON bicd.retailer_damage_id = bicdp.retailer_damage_id\n" +
                        " WHERE bicdp.sync_flag = 'Y' AND \n" +
                        "       bicd.isDamage = '1';";
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_HELP_VIDEO_DETAIL)) {
                qry = " Select video_type_details_id,video_type_id,customer_id,isDownload,created_on,modified_on,sync_flag,sync_date,sync_by_user,country_id,imeino AS imei_no from  bf_master_cpm_help_video_details where sync_flag = 'Y'";

            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_SAVE_OFFLINE_LOG)) {
                qry = "select * from  " + tableName;

            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_DEVICE_TOKEN)) {
                qry = "select * from  " + tableName;
            } else if (tableName.equalsIgnoreCase(DataBaseHelper.TABLE_TRANSACTION_ERROR_LOG)) {
                qry = "select * from  " + tableName;
            } else {
                qry = "select * from  " + tableName + " where sync_flag = 'Y'";
            }
        }
        Cursor c = db.rawQuery(qry, null);
        if (c != null && c.getCount() > 0) {
            c.moveToFirst();

            //int i = 0;
            //for (int i = 0; i < c.getColumnCount(); i++) {
            do {
                int totalColumn = c.getColumnCount();
                if (totalColumn > 0) {
                    JSONObject rowObject = new JSONObject();
                    for (int i = 0; i < totalColumn; i++) {
                        String cName = c.getColumnName(i);
                        Log.e("getType", ":::::" + c.getType(i));
                        try {
                            switch (c.getType(i)) {
                                case Cursor.FIELD_TYPE_INTEGER:
                                    if (cName.equalsIgnoreCase("id") || cName.equalsIgnoreCase("_id")) {
                                        continue;
                                    } else if (cName.equalsIgnoreCase("intglcode")) {
                                        continue;
                                    } else {
                                        if (c.getInt(i) != 0) {
                                            rowObject.put(cName, c.getInt(i));
                                        } else {
                                            rowObject.put(cName, 0);
                                        }
                                    }
                                    break;
                                case Cursor.FIELD_TYPE_FLOAT:
                                    if (c.getFloat(i) != 0) {
                                        rowObject.put(cName, c.getFloat(i));
                                    } else {
                                        rowObject.put(cName, 0);
                                    }
                                    break;
                                case Cursor.FIELD_TYPE_STRING:
                                    //isDispatch
                                    if (cName.equalsIgnoreCase("isDispatch")) {
                                        continue;
                                    } else if (c.getString(i) != null && !c.getString(i).equalsIgnoreCase("")) {
                                        rowObject.put(cName, c.getString(i));
                                    } else {
                                        rowObject.put(cName, "");
                                    }
                                    break;
                                case Cursor.FIELD_TYPE_NULL:
                                    rowObject.put(cName, "");
                                    break;
                            }
                        } catch (Exception ex) {
                            ex.printStackTrace();
                            Log.e("", "Exception converting cursor column to json field: " + cName);
                            insertTransactionErrorLog(context, this.getClass().getSimpleName(), "getJsonFromTable",
                                    AppUtil.getStackTrace(ex),
                                    AppUtil.getStackTrace(ex),
                                    "1",SynchronizationService.userID);
                        }
                    }
                    jsonTableData.put(rowObject);
                }
            } while (c.moveToNext());
        }
        assert c != null;
        c.close();
        return jsonTableData;
    }

    private ArrayList<IshopDistributorReturn> DistributorReturnSyncData() {
        ArrayList<IshopDistributorReturn> arrayList = new ArrayList<>();
        String query = "SELECT * FROM " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN + " WHERE " +
                DataBaseHelper.KEY_SYNC_FLAG + "= 'Y'";
        Cursor cursor = database.rawQuery(query, null);
        try {
            if (cursor != null && cursor.moveToFirst()) {
                do {

                    IshopDistributorReturn object = new IshopDistributorReturn();
                    object.setDistributorReturnId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_DISTRIBUTOR_RETURN_ID)));
                    object.setCustomerFromId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_CUSTOMER_FROM_ID)));
                    object.setCustomerToId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_CUSTOMER_TO_ID)));
                    object.setCustomerTypeCountryId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_CUSTOMER_TYPE_COUNTRY_ID)));
                    object.setIsNewCustomer(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_IS_NEW_CUSTOMER)));
                    object.setReturnDate(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_RETURN_DATE)));
                    object.setCountryId(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_COUNTRY_ID)));
                    object.setCreatedByUser(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_CREATED_BY_USER)));
                    object.setModifiedByUser(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_MODIFIED_BY_USER)));
                    object.setStatus(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_STATUS)));
                    object.setCreatedOn(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_CREATE_ON)));
                    object.setModifiedOn(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_MODIFIED_ON)));
                    object.setSyncCode(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_CODE)));
                    object.setSyncFlag(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_FLAG)));
                    object.setSyncDate(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_DATE)));
                    object.setSyncByUser(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_USER)));
                    arrayList.add(object);
                } while (cursor.moveToNext());
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (cursor != null) cursor.close();
        }

        return arrayList;
    }

    private ArrayList<IshopDistributorReturnProduct> DistributorReturnProductSyncData() {

        ArrayList<IshopDistributorReturnProduct> arrayList = new ArrayList<>();
        String query = "SELECT * FROM " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT + " WHERE " +
                DataBaseHelper.KEY_SYNC_FLAG + "= 'Y'";
        Cursor cursor = database.rawQuery(query, null);
        try {
            if (cursor != null && cursor.moveToFirst()) {
                do {

                    IshopDistributorReturnProduct object = new IshopDistributorReturnProduct();
                    object.setDistributorReturnProductId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_DISTRIBUTOR_RETURN_PRODUCT_ID)));
                    object.setDistributorReturnId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_DISTRIBUTOR_RETURN_PRODUCT_ID)));
                    object.setProductSkuId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_PRODUCT_SKU_ID)));
                    object.setStickerDetailsId(cursor.getString(cursor.getColumnIndex(DataBaseHelper
                            .KEY_STICKER_DETAILS_ID)));
                    object.setBtcNoOut(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_BTC_NO_OUT)));
                    object.setQrCodeOut(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_QR_CODE_OUT)));
                    object.setQuantity(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_QUANTITY)));
                    object.setAmount(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_AMOUNT)));
                    object.setUnit(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_UNIT)));
                    object.setQtyKgl(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_QTY_KGL)));
                    object.setIsValid(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_IS_VALID)));
                    object.setSyncCode(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_CODE)));
                    object.setSyncFlag(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_FLAG)));
                    object.setSyncDate(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_DATE)));
                    object.setSyncByUser(cursor.getString(cursor.getColumnIndex(DataBaseHelper.KEY_SYNC_USER)));
                    arrayList.add(object);
                } while (cursor.moveToNext());
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (cursor != null) cursor.close();
        }

        return arrayList;
    }

    public String getConfigReturned() {
        String returned = "";
        try {
            String sql = "Select * from user_configuration_mst;";
            Cursor cursor = database.rawQuery(sql, null);
            try {
                if (cursor != null && cursor.getCount() > 0) {
                    while (cursor.moveToNext()) {
                        returned = cursor.getString(cursor.getColumnIndex("returned"));
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                if (cursor != null) {
                    cursor.close();
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return returned;
    }

    public void manageProductTable() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_cfa_dispatch_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_cfa_dispatch_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_cfa_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_cfa_dispatch_product (\n" +
                "                                              cfa_dispatch_product_id,\n" +
                "                                              cfa_dispatch_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              dispatch_scan_type\n" +
                "                                          )\n" +
                "                                          SELECT cfa_dispatch_product_id,\n" +
                "                                                 cfa_dispatch_id,\n" +
                "                                                 product_sku_id,\n" +
                "                                                 sticker_details_id,\n" +
                "                                                 btc_no_out,\n" +
                "                                                 qr_code_out,\n" +
                "                                                 quantity,\n" +
                "                                                 amount,\n" +
                "                                                 unit,\n" +
                "                                                 qty_kgl,\n" +
                "                                                 is_valid,\n" +
                "                                                 sync_code,\n" +
                "                                                 sync_flag,\n" +
                "                                                 sync_date,\n" +
                "                                                 sync_by_user,\n" +
                "                                                 received,\n" +
                "                                                 received_date,\n" +
                "                                                 dispatch_scan_type\n" +
                "                                            FROM bf_ishop_cfa_dispatch_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DISPATCH_PRODUCT_COPY);
    }

    public void InsertDistributorReceivedNew(JSONArray ishop_distributor_received) {

        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED
                        + " (" + DataBaseHelper.DISTRIBUTOR_RECEIVED_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_isDispatch + ","
                        + DataBaseHelper.SYNC_BY_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


                for (int k = 0; k < ishop_distributor_received.length(); k++) {
                    try {
                        JSONObject object = ishop_distributor_received.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("distributor_received_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("customer_type_country_id"));
                        statement.bindString(5, object.getString("received_date"));
                        statement.bindString(6, object.getString("country_id"));
                        statement.bindString(7, object.getString("created_by_user"));
                        statement.bindString(8, object.getString("modified_by_user"));
                        statement.bindString(9, object.getString("status"));
                        statement.bindString(10, object.getString("created_on"));
                        statement.bindString(11, object.getString("modified_on"));
                        statement.bindString(12, object.getString("sync_code"));
                        statement.bindString(13, object.getString("sync_flag"));
                        statement.bindString(14, object.getString("sync_date"));
                        statement.bindString(15, "1");
                        statement.bindString(16, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReceivedNew";
                    }
                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReceivedNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReceivedNew";
            } finally {
                database.endTransaction();
//                close();
            }
        } else {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY
                        + " (" + DataBaseHelper.DISTRIBUTOR_RECEIVED_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_isDispatch + ","
                        + DataBaseHelper.SYNC_BY_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


                for (int k = 0; k < ishop_distributor_received.length(); k++) {
                    try {
                        JSONObject object = ishop_distributor_received.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("distributor_received_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("customer_type_country_id"));
                        statement.bindString(5, object.getString("received_date"));
                        statement.bindString(6, object.getString("country_id"));
                        statement.bindString(7, object.getString("created_by_user"));
                        statement.bindString(8, object.getString("modified_by_user"));
                        statement.bindString(9, object.getString("status"));
                        statement.bindString(10, object.getString("created_on"));
                        statement.bindString(11, object.getString("modified_on"));
                        statement.bindString(12, object.getString("sync_code"));
                        statement.bindString(13, object.getString("sync_flag"));
                        statement.bindString(14, object.getString("sync_date"));
                        statement.bindString(15, "1");
                        statement.bindString(16, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReceivedNew";
                    }
                }

                manageDistReceiveCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReceivedNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReceivedNew";
            } finally {
                database.endTransaction();
//                close();
            }

            Log.e(TAG, "TABLE DistributorReceived Add SUCCESSFULLY");
        }
    }

    private void manageDistReceiveCopy() {
        database.execSQL("DELETE FROM bf_ishop_distributor_received\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_received AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_received_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_received (\n" +
                "                                              distributor_received_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              distributor_received_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_distributor_received_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_COPY);
    }

    public void InsertDistributorReturnNew(JSONArray ishop_distributor_return) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN
                        + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_RETURN_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_distributor_return.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_distributor_return.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("distributor_return_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("customer_type_country_id"));
                        statement.bindString(5, object.getString("is_new_customer"));
                        statement.bindString(6, object.getString("return_date"));
                        statement.bindString(7, object.getString("country_id"));
                        statement.bindString(8, object.getString("created_by_user"));
                        statement.bindString(9, object.getString("modified_by_user"));
                        statement.bindString(10, object.getString("status"));
                        statement.bindString(11, object.getString("created_on"));
                        statement.bindString(12, object.getString("modified_on"));
                        statement.bindString(13, object.getString("sync_code"));
                        statement.bindString(14, object.getString("sync_flag"));
                        statement.bindString(15, object.getString("sync_date"));
                        statement.bindString(16, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnNew";
                    }

                }
                database.setTransactionSuccessful();

            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnNew";
            } finally {
                database.endTransaction();
//                close();
            }
        } else {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_COPY
                        + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_RETURN_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_distributor_return.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_distributor_return.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("distributor_return_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("customer_type_country_id"));
                        statement.bindString(5, object.getString("is_new_customer"));
                        statement.bindString(6, object.getString("return_date"));
                        statement.bindString(7, object.getString("country_id"));
                        statement.bindString(8, object.getString("created_by_user"));
                        statement.bindString(9, object.getString("modified_by_user"));
                        statement.bindString(10, object.getString("status"));
                        statement.bindString(11, object.getString("created_on"));
                        statement.bindString(12, object.getString("modified_on"));
                        statement.bindString(13, object.getString("sync_code"));
                        statement.bindString(14, object.getString("sync_flag"));
                        statement.bindString(15, object.getString("sync_date"));
                        statement.bindString(16, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnNew";
                    }

                }

                manageDistRetunCopy();

                database.setTransactionSuccessful();

            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnNew";
            } finally {
                database.endTransaction();
//                close();
            }
        }

    }

    private void manageDistRetunCopy() {
        database.execSQL("DELETE FROM bf_ishop_distributor_return\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_return AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_return_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_return (\n" +
                "                                              distributor_return_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              return_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              distributor_return_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              return_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_distributor_return_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_COPY);
    }

//    public void InsertDistributorReturnProductNew(JSONArray ishop_distributor_return_product) {
//        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT);
//        database.beginTransaction();
//        try {
//            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT
//                    + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_PRODUCT_ID + ","
//                    + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_ID + ","
//                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
//                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
//                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
//                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
//                    + DataBaseHelper.KEY_QUANTITY + ","
//                    + DataBaseHelper.KEY_AMOUNT + ","
//                    + DataBaseHelper.KEY_UNIT + ","
//                    + DataBaseHelper.KEY_QTY_KGL + ","
//                    + DataBaseHelper.KEY_IS_VALID + ","
//                    + DataBaseHelper.KEY_SYNC_CODE + ","
//                    + DataBaseHelper.KEY_SYNC_FLAG + ","
//                    + DataBaseHelper.KEY_SYNC_DATE + ","
//                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
//
//
//            for (int k = 0; k < ishop_distributor_return_product.length(); k++) {
//                JSONObject object = null;
//                try {
//                    object = ishop_distributor_return_product.getJSONObject(k);
//                    SQLiteStatement statement = database.compileStatement(sql);
//                    statement.bindString(1, object.getString("distributor_return_product_id"));
//                    statement.bindString(2, object.getString("distributor_return_id"));
//                    statement.bindString(3, object.getString("product_sku_id"));
//                    statement.bindString(4, object.getString("sticker_details_id"));
//                    statement.bindString(5, object.getString("btc_no_out"));
//                    statement.bindString(6, object.getString("qr_code_out"));
//                    statement.bindString(7, object.getString("quantity"));
//                    statement.bindString(8, object.getString("amount"));
//                    statement.bindString(9, object.getString("unit"));
//                    statement.bindString(10, object.getString("qty_kgl"));
//                    statement.bindString(11, object.getString("is_valid"));
//                    statement.bindString(12, object.getString("sync_code"));
//                    statement.bindString(13, object.getString("sync_flag"));
//                    statement.bindString(14, object.getString("sync_date"));
//                    statement.bindString(15, object.getString("sync_by_user"));
//                    statement.execute();
//                } catch (JSONException e) {
//                    e.printStackTrace();
//                }
//
//            }
//            database.setTransactionSuccessful();
//        } catch (SQLException e) {
//            e.printStackTrace();
//        } catch (NumberFormatException e) {
//            e.printStackTrace();
//        } finally {
//            database.endTransaction();
//        }
//    }

    public void InsertDistributorReturnRequestNew(JSONArray ishop_distributor_return_request) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST
                        + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID + ","
                        + DataBaseHelper.SRIP_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_RETURN_REQUEST_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_isDispatch + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


                for (int k = 0; k < ishop_distributor_return_request.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_distributor_return_request.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("distributor_return_request_id"));
                        statement.bindString(2, object.getString("srip_id"));
                        statement.bindString(3, object.getString("customer_from_id"));
                        statement.bindString(4, object.getString("customer_to_id"));
                        statement.bindString(5, object.getString("return_request_date"));
                        statement.bindString(6, object.getString("country_id"));
                        statement.bindString(7, object.getString("created_by_user"));
                        statement.bindString(8, object.getString("modified_by_user"));
                        statement.bindString(9, object.getString("status"));
                        statement.bindString(10, object.getString("created_on"));
                        statement.bindString(11, object.getString("modified_on"));
                        statement.bindString(12, object.getString("sync_code"));
                        statement.bindString(13, object.getString("sync_flag"));
                        statement.bindString(14, object.getString("sync_date"));
                        statement.bindString(15, "1");
                        statement.bindString(16, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
                    }
                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
            } finally {
                database.endTransaction();
//                close();
            }
        } else {

//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY
                        + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID + ","
                        + DataBaseHelper.SRIP_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_RETURN_REQUEST_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_isDispatch + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


                for (int k = 0; k < ishop_distributor_return_request.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_distributor_return_request.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("distributor_return_request_id"));
                        statement.bindString(2, object.getString("srip_id"));
                        statement.bindString(3, object.getString("customer_from_id"));
                        statement.bindString(4, object.getString("customer_to_id"));
                        statement.bindString(5, object.getString("return_request_date"));
                        statement.bindString(6, object.getString("country_id"));
                        statement.bindString(7, object.getString("created_by_user"));
                        statement.bindString(8, object.getString("modified_by_user"));
                        statement.bindString(9, object.getString("status"));
                        statement.bindString(10, object.getString("created_on"));
                        statement.bindString(11, object.getString("modified_on"));
                        statement.bindString(12, object.getString("sync_code"));
                        statement.bindString(13, object.getString("sync_flag"));
                        statement.bindString(14, object.getString("sync_date"));
                        statement.bindString(15, "1");
                        statement.bindString(16, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
                    }
                }

                manageDistReturnRequestCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
            } finally {
                database.endTransaction();
            }

        }

//        close();
    }

    private void manageDistReturnRequestCopy() {
        database.execSQL("DELETE FROM bf_ishop_distributor_return_request\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_return_request AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_return_request_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_return_request (\n" +
                "                                              distributor_return_request_id,\n" +
                "                                              srip_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              return_request_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              distributor_return_request_id,\n" +
                "                                              srip_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              return_request_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_distributor_return_request_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY);
    }

    public void InsertRetailerDispatchNew(JSONArray ishop_retailer_dispatch) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DISPATCH);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_DISPATCH
                        + " (" + DataBaseHelper.KEY_RETAILER_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_customer_to_name + ","
                        + DataBaseHelper.KEY_customer_to_phone + ","
                        + DataBaseHelper.KEY_new_customer_type + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_retailer_dispatch.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_retailer_dispatch.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("retailer_dispatch_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("customer_type_country_id"));
                        statement.bindString(5, object.getString("is_new_customer"));
                        statement.bindString(6, object.getString("dispatch_date"));
                        statement.bindString(7, object.getString("country_id"));
                        statement.bindString(8, object.getString("created_by_user"));
                        statement.bindString(9, object.getString("modified_by_user"));
                        statement.bindString(10, object.getString("status"));
                        statement.bindString(11, object.getString("created_on"));
                        statement.bindString(12, object.getString("modified_on"));
                        statement.bindString(13, object.getString("sync_code"));
                        statement.bindString(14, object.getString("sync_flag"));
                        statement.bindString(15, object.getString("sync_date"));
                        statement.bindString(16, object.getString("isRead"));
                        statement.bindString(17, object.getString("customer_to_name"));
                        statement.bindString(18, object.getString("customer_to_phone"));
                        statement.bindString(19, object.getString("new_customer_type"));
                        statement.bindString(20, "1");
                        statement.bindString(21, object.getString("read_date"));
                        statement.bindString(22, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
            } finally {
                database.endTransaction();
            }

//            close();
        } else {
//            open();
            database.beginTransaction();
            database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DISPATCH_COPY);

            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_DISPATCH_COPY
                        + " (" + DataBaseHelper.KEY_RETAILER_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_customer_to_name + ","
                        + DataBaseHelper.KEY_customer_to_phone + ","
                        + DataBaseHelper.KEY_new_customer_type + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_retailer_dispatch.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_retailer_dispatch.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("retailer_dispatch_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("customer_type_country_id"));
                        statement.bindString(5, object.getString("is_new_customer"));
                        statement.bindString(6, object.getString("dispatch_date"));
                        statement.bindString(7, object.getString("country_id"));
                        statement.bindString(8, object.getString("created_by_user"));
                        statement.bindString(9, object.getString("modified_by_user"));
                        statement.bindString(10, object.getString("status"));
                        statement.bindString(11, object.getString("created_on"));
                        statement.bindString(12, object.getString("modified_on"));
                        statement.bindString(13, object.getString("sync_code"));
                        statement.bindString(14, object.getString("sync_flag"));
                        statement.bindString(15, object.getString("sync_date"));
                        statement.bindString(16, object.getString("isRead"));
                        statement.bindString(17, object.getString("customer_to_name"));
                        statement.bindString(18, object.getString("customer_to_phone"));
                        statement.bindString(19, object.getString("new_customer_type"));
                        statement.bindString(20, "1");
                        statement.bindString(21, object.getString("read_date"));
                        statement.bindString(22, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }


                manageRetailerDispatchCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
            } finally {
                database.endTransaction();
            }
//            close();
        }
    }

    private void manageRetailerDispatchCopy() {
        database.execSQL("DELETE FROM bf_ishop_retailer_dispatch\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_retailer_dispatch AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_retailer_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_retailer_dispatch (\n" +
                "                                              retailer_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              dispatch_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isRead,\n" +
                "                                              customer_to_name,\n" +
                "                                              customer_to_phone,\n" +
                "                                              new_customer_type,\n" +
                "                                              isDispatch,\n" +
                "                                              read_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              retailer_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              dispatch_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isRead,\n" +
                "                                              customer_to_name,\n" +
                "                                              customer_to_phone,\n" +
                "                                              new_customer_type,\n" +
                "                                              isDispatch,\n" +
                "                                              read_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_retailer_dispatch_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DISPATCH_COPY);
    }

//    public void InsertRetailerDispatchProductNew(JSONArray ishop_retailer_dispatch_product) {
//        database.beginTransaction();
//        try {
//            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_DISPATCH_PRODUCT
//                    + " (" + DataBaseHelper.KEY_RETAILER_DISPATCH_PRODUCT_ID + ","
//                    + DataBaseHelper.KEY_RETAILER_DISPATCH_ID + ","
//                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
//                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
//                    + DataBaseHelper.KEY_BTC_NO + ","
//                    + DataBaseHelper.KEY_qr_code + ","
//                    + DataBaseHelper.KEY_BTC_TYPE + ","
//                    + DataBaseHelper.KEY_QUANTITY + ","
//                    + DataBaseHelper.KEY_AMOUNT + ","
//                    + DataBaseHelper.KEY_UNIT + ","
//                    + DataBaseHelper.KEY_QTY_KGL + ","
//                    + DataBaseHelper.KEY_IS_VALID + ","
//                    + DataBaseHelper.KEY_RECEIVED + ","
//                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
//                    + DataBaseHelper.KEY_SYNC_CODE + ","
//                    + DataBaseHelper.KEY_SYNC_FLAG + ","
//                    + DataBaseHelper.KEY_SYNC_DATE + ","
//                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
//
//            for (int k = 0; k < ishop_retailer_dispatch_product.length(); k++) {
//                JSONObject object = null;
//                try {
//                    object = ishop_retailer_dispatch_product.getJSONObject(k);
//                    SQLiteStatement statement = database.compileStatement(sql);
//                    statement.bindString(1, object.getString("retailer_dispatch_product_id"));
//                    statement.bindString(2, object.getString("retailer_dispatch_id"));
//                    statement.bindString(3, object.getString("product_sku_id"));
//                    statement.bindString(4, object.getString("sticker_details_id"));
//                    statement.bindString(5, object.getString("btc_no"));
//                    statement.bindString(6, object.getString("qr_code"));
//                    statement.bindString(7, object.getString("btc_type"));
//                    statement.bindString(8, object.getString("quantity"));
//                    statement.bindString(9, object.getString("amount"));
//                    statement.bindString(10, object.getString("unit"));
//                    statement.bindString(11, object.getString("qty_kgl"));
//                    statement.bindString(12, object.getString("is_valid"));
//                    statement.bindString(13, object.getString("received"));
//                    statement.bindString(14, object.getString("received_date"));
//                    statement.bindString(15, object.getString("sync_code"));
//                    statement.bindString(16, object.getString("sync_flag"));
//                    statement.bindString(17, object.getString("sync_date"));
//                    statement.bindString(18, object.getString("sync_by_user"));
//                    statement.execute();
//                } catch (JSONException e) {
//                    e.printStackTrace();
//                }
//
//            }
//            database.setTransactionSuccessful();
//        } catch (SQLException e) {
//            e.printStackTrace();
//        } catch (NumberFormatException e) {
//            e.printStackTrace();
//        } finally {
//            database.endTransaction();
//        }
//    }

    public void InsertRetailerReturnNew(JSONArray ishop_retailer_return, String fileName) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            if (fileName.equalsIgnoreCase("1.txt")) {
                database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN);
            }

            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_RETURN
                        + " (" + DataBaseHelper.KEY_RETAILER_RETURN_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_RETURN_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_retailer_return.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_retailer_return.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//retailer_return_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("D"));//customer_type_country_id
                        statement.bindString(5, object.getString("E"));//is_new_customer
                        statement.bindString(6, object.getString("F"));//return_date
                        statement.bindString(7, object.getString("G"));//country_id
                        statement.bindString(8, object.getString("H"));//created_by_user
                        statement.bindString(9, object.getString("I"));//modified_by_user
                        statement.bindString(10, object.getString("J"));//status
                        statement.bindString(11, object.getString("K"));//created_on
                        statement.bindString(12, object.getString("L"));//modified_on
                        statement.bindString(13, object.getString("M"));//sync_code
                        statement.bindString(14, object.getString("N"));//sync_flag
                        statement.bindString(15, object.getString("O"));//sync_date
                        statement.bindString(16, object.getString("P"));//sync_by_user
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnNew";
                    }

                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnNew";
            } finally {
                database.endTransaction();
//                close();
            }
        } else {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_RETURN_COPY
                        + " (" + DataBaseHelper.KEY_RETAILER_RETURN_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_RETURN_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_retailer_return.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_retailer_return.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//retailer_return_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("D"));//customer_type_country_id
                        statement.bindString(5, object.getString("E"));//is_new_customer
                        statement.bindString(6, object.getString("F"));//return_date
                        statement.bindString(7, object.getString("G"));//country_id
                        statement.bindString(8, object.getString("H"));//created_by_user
                        statement.bindString(9, object.getString("I"));//modified_by_user
                        statement.bindString(10, object.getString("J"));//status
                        statement.bindString(11, object.getString("K"));//created_on
                        statement.bindString(12, object.getString("L"));//modified_on
                        statement.bindString(13, object.getString("M"));//sync_code
                        statement.bindString(14, object.getString("N"));//sync_flag
                        statement.bindString(15, object.getString("O"));//sync_date
                        statement.bindString(16, object.getString("P"));//sync_by_user
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnNew";
                    }

                }

                manageRetailerReturnCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnNew";
            } finally {
                database.endTransaction();
//                close();
            }

        }


    }

    private void manageRetailerReturnCopy() {
        database.execSQL("DELETE FROM bf_ishop_retailer_return\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_retailer_return AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_retailer_return_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_retailer_return (\n" +
                "                                              retailer_return_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              return_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT  " +
                "                                              retailer_return_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              return_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_retailer_return_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN_COPY);
    }

//    public void InsertRetailerReturnProductNew(JSONArray ishop_retailer_return_product) {
//        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT);
//        database.beginTransaction();
//        try {
//            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT
//                    + " (" + DataBaseHelper.KEY_RETAILER_RETURN_PRODUCT_ID + ","
//                    + DataBaseHelper.KEY_RETAILER_RETURN_ID + ","
//                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
//                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
//                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
//                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
//                    + DataBaseHelper.KEY_QUANTITY + ","
//                    + DataBaseHelper.KEY_AMOUNT + ","
//                    + DataBaseHelper.KEY_UNIT + ","
//                    + DataBaseHelper.KEY_QTY_KGL + ","
//                    + DataBaseHelper.KEY_IS_VALID + ","
//                    + DataBaseHelper.KEY_SYNC_CODE + ","
//                    + DataBaseHelper.KEY_SYNC_FLAG + ","
//                    + DataBaseHelper.KEY_SYNC_DATE + ","
//                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
//
//            for (int k = 0; k < ishop_retailer_return_product.length(); k++) {
//                JSONObject object = null;
//                try {
//                    object = ishop_retailer_return_product.getJSONObject(k);
//                    SQLiteStatement statement = database.compileStatement(sql);
//                    statement.bindString(1, object.getString("retailer_return_product_id"));
//                    statement.bindString(2, object.getString("retailer_return_id"));
//                    statement.bindString(3, object.getString("product_sku_id"));
//                    statement.bindString(4, object.getString("sticker_details_id"));
//                    statement.bindString(5, object.getString("btc_no_out"));
//                    statement.bindString(6, object.getString("qr_code_out"));
//                    statement.bindString(7, object.getString("quantity"));
//                    statement.bindString(8, object.getString("amount"));
//                    statement.bindString(9, object.getString("unit"));
//                    statement.bindString(10, object.getString("qty_kgl"));
//                    statement.bindString(11, object.getString("is_valid"));
//                    statement.bindString(12, object.getString("sync_code"));
//                    statement.bindString(13, object.getString("sync_flag"));
//                    statement.bindString(14, object.getString("sync_date"));
//                    statement.bindString(15, object.getString("sync_by_user"));
//                    statement.execute();
//                } catch (JSONException e) {
//                    e.printStackTrace();
//                }
//
//            }
//            database.setTransactionSuccessful();
//        } catch (SQLException e) {
//            e.printStackTrace();
//        } catch (NumberFormatException e) {
//            e.printStackTrace();
//        } finally {
//            database.endTransaction();
//        }
//    }


    public void InsertCFAReturnNew(JSONArray ishop_cfa_return) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_RETURN
                        + " (" + DataBaseHelper.KEY_CFA_RETURN_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_RETURN_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


                for (int k = 0; k < ishop_cfa_return.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_cfa_return.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("cfa_return_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("return_date"));
                        statement.bindString(5, object.getString("country_id"));
                        statement.bindString(6, object.getString("created_by_user"));
                        statement.bindString(7, object.getString("modified_by_user"));
                        statement.bindString(8, object.getString("status"));
                        statement.bindString(9, object.getString("created_on"));
                        statement.bindString(10, object.getString("modified_on"));
                        statement.bindString(11, object.getString("sync_code"));
                        statement.bindString(12, object.getString("sync_flag"));
                        statement.bindString(13, object.getString("sync_date"));
                        statement.bindString(14, "1");
                        statement.bindString(15, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
                    }

                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
            } finally {
                database.endTransaction();
//                close();
            }
        } else {

//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_RETURN_COPY
                        + " (" + DataBaseHelper.KEY_CFA_RETURN_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_RETURN_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


                for (int k = 0; k < ishop_cfa_return.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_cfa_return.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("cfa_return_id"));
                        statement.bindString(2, object.getString("customer_from_id"));
                        statement.bindString(3, object.getString("customer_to_id"));
                        statement.bindString(4, object.getString("return_date"));
                        statement.bindString(5, object.getString("country_id"));
                        statement.bindString(6, object.getString("created_by_user"));
                        statement.bindString(7, object.getString("modified_by_user"));
                        statement.bindString(8, object.getString("status"));
                        statement.bindString(9, object.getString("created_on"));
                        statement.bindString(10, object.getString("modified_on"));
                        statement.bindString(11, object.getString("sync_code"));
                        statement.bindString(12, object.getString("sync_flag"));
                        statement.bindString(13, object.getString("sync_date"));
                        statement.bindString(14, "1");
                        statement.bindString(15, object.getString("sync_by_user"));
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
                    }

                }

                manageCfaReturnCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
            } finally {
                database.endTransaction();
//                close();
            }

        }

    }

    private void manageCfaReturnCopy() {
        database.execSQL("DELETE FROM bf_ishop_cfa_return\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_cfa_return AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_cfa_return_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_cfa_return (\n" +
                "                                              cfa_return_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              return_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              cfa_return_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              return_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_cfa_return_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_COPY);
    }

    private void manageDistributorProductTable() {
// delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_distributor_dispatch_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_dispatch_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_dispatch_product (\n" +
                "                                              distributor_dispatch_product_id,\n" +
                "                                              distributor_dispatch_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              dispatch_scan_type,\n" +
                "                                              btc_type\n" +
                "                                          )\n" +
                "                                          SELECT distributor_dispatch_product_id,\n" +
                "                                                 distributor_dispatch_id,\n" +
                "                                                 product_sku_id,\n" +
                "                                                 sticker_details_id,\n" +
                "                                                 btc_no_out,\n" +
                "                                                 qr_code_out,\n" +
                "                                                 quantity,\n" +
                "                                                 amount,\n" +
                "                                                 unit,\n" +
                "                                                 qty_kgl,\n" +
                "                                                 is_valid,\n" +
                "                                                 sync_code,\n" +
                "                                                 sync_flag,\n" +
                "                                                 sync_date,\n" +
                "                                                 sync_by_user,\n" +
                "                                                 received,\n" +
                "                                                 received_date,\n" +
                "                                                 dispatch_scan_type,\n" +
                "                                                 btc_type\n" +
                "                                            FROM bf_ishop_distributor_dispatch_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY);
    }

    private void manageRetailerDispatchProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_retailer_dispatch_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_retailer_dispatch_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_retailer_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_retailer_dispatch_product (\n" +
                "                                              retailer_dispatch_product_id,\n" +
                "                                              retailer_dispatch_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no,\n" +
                "                                              qr_code,\n" +
                "                                              btc_type,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              dispatch_scan_type\n" +
                "                                          )\n" +
                "                                          SELECT retailer_dispatch_product_id,\n" +
                "                                              retailer_dispatch_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no,\n" +
                "                                              qr_code,\n" +
                "                                              btc_type,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              dispatch_scan_type\n" +
                "                                            FROM bf_ishop_retailer_dispatch_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DISPATCH_PRODUCT_COPY);
    }

    private void manageDistributorReturnProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_distributor_return_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_return_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_return_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_return_product (\n" +
                "                                              distributor_return_product_id,\n" +
                "                                              distributor_return_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT distributor_return_product_id,\n" +
                "                                                 distributor_return_id,\n" +
                "                                                 product_sku_id,\n" +
                "                                                 sticker_details_id,\n" +
                "                                                 btc_no_out,\n" +
                "                                                 qr_code_out,\n" +
                "                                                 quantity,\n" +
                "                                                 amount,\n" +
                "                                                 unit,\n" +
                "                                                 qty_kgl,\n" +
                "                                                 is_valid,\n" +
                "                                                 sync_code,\n" +
                "                                                 sync_flag,\n" +
                "                                                 sync_date,\n" +
                "                                                 sync_by_user\n" +
                "                                            FROM bf_ishop_distributor_return_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY);
    }

    private void manageDistributorReturnRequestProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_distributor_return_request_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_return_request_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_return_request_product_copy AS st_copy ON st.sync_code = st_copy.sync_code" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_return_request_product (\n" +
                "                                              distributor_return_request_product_id,\n" +
                "                                              distributor_return_request_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              reject,\n" +
                "                                              rejected_date,\n" +
                "                                              rejected_comment,\n" +
                "                                              rejected_reason\n" +
                "                                          )\n" +
                "                                          SELECT distributor_return_request_product_id,\n" +
                "                                                 distributor_return_request_id,\n" +
                "                                                 product_sku_id,\n" +
                "                                                 sticker_details_id,\n" +
                "                                                 btc_no_out,\n" +
                "                                                 qr_code_out,\n" +
                "                                                 quantity,\n" +
                "                                                 amount,\n" +
                "                                                 unit,\n" +
                "                                                 qty_kgl,\n" +
                "                                                 is_valid,\n" +
                "                                                 received,\n" +
                "                                                 received_date,\n" +
                "                                                 sync_code,\n" +
                "                                                 sync_flag,\n" +
                "                                                 sync_date,\n" +
                "                                                 sync_by_user,\n" +
                "                                                 reject,\n" +
                "                                                 rejected_date,\n" +
                "                                                 rejected_comment,\n" +
                "                                                 rejected_reason\n" +
                "                                            FROM bf_ishop_distributor_return_request_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);
    }

    private void manageRetailerReceiveProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_retailer_received_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_retailer_received_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_retailer_received_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_retailer_received_product (\n" +
                "                                              retailer_received_product_id,\n" +
                "                                              retailer_received_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              created_by,\n" +
                "                                              created_on,\n" +
                "                                              out_point_calculate,\n" +
                "                                              received_scan_type\n" +
                "                                          )\n" +
                "                                          SELECT retailer_received_product_id,\n" +
                "                                              retailer_received_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              created_by,\n" +
                "                                              created_on,\n" +
                "                                              out_point_calculate,\n" +
                "                                              received_scan_type\n" +
                "                                            FROM bf_ishop_retailer_received_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY);
    }

    public void InsertRetailerReturnProductNew(JSONArray ishop_retailer_return_product, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_RETAILER_RETURN_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_RETAILER_RETURN_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int k = 0; k < ishop_retailer_return_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_retailer_return_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//retailer_return_product_id
                    statement.bindString(2, object.getString("B"));//retailer_return_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("L"));//sync_code
                    statement.bindString(13, object.getString("M"));//sync_flag
                    statement.bindString(14, object.getString("N"));//sync_date
                    statement.bindString(15, object.getString("O"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnProductNew";
                }

            }
            manageRetailerReturnProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReturnProductNew";
        } finally {
            database.endTransaction();
//            close();
        }
    }

    private void manageRetailerReturnProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_retailer_return_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_retailer_return_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_retailer_return_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_retailer_return_product (\n" +
                "                                              retailer_return_product_id,\n" +
                "                                              retailer_return_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT retailer_return_product_id,\n" +
                "                                              retailer_return_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_retailer_return_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_RETURN_PRODUCT_COPY);
    }

    private void manageTollerDispatchProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_toller_dispatch_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_toller_dispatch_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_toller_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_toller_dispatch_product (\n" +
                "                                              toller_dispatch_product_id,\n" +
                "                                              toller_dispatch_id,\n" +
                "                                              product_sku_country_id,\n" +
                "                                              sticker_id,\n" +
                "                                              batch_no,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT toller_dispatch_product_id,\n" +
                "                                              toller_dispatch_id,\n" +
                "                                              product_sku_country_id,\n" +
                "                                              sticker_id,\n" +
                "                                              batch_no,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_toller_dispatch_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_TOLLER_DISPATCH_PRODUCT_COPY);
    }

    public void InsertCFAReturnProductNew(JSONArray ishop_cfa_return_product) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_CFA_RETURN_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_CFA_RETURN_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_cfa_return_product.length(); k++) {
                try {
                    JSONObject object = ishop_cfa_return_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("cfa_return_product_id"));//cfa_return_product_id
                    statement.bindString(2, object.getString("cfa_return_id"));//cfa_return_id
                    statement.bindString(3, object.getString("product_sku_id"));//product_sku_id
                    statement.bindString(4, object.getString("sticker_details_id"));//sticker_details_id
                    statement.bindString(5, object.getString("btc_no_out"));//btc_no_out
                    statement.bindString(6, object.getString("quantity"));//quantity
                    statement.bindString(7, object.getString("amount"));//amount
                    statement.bindString(8, object.getString("unit"));//unit
                    statement.bindString(9, object.getString("qty_kgl"));//qty_kgl
                    statement.bindString(10, object.getString("is_valid"));//is_valid
                    statement.bindString(11, object.getString("sync_code"));//sync_code
                    statement.bindString(12, object.getString("sync_flag"));//sync_flag
                    statement.bindString(13, object.getString("sync_date"));//sync_date
                    statement.bindString(14, object.getString("sync_by_user"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
                }

            }
            manageCFAReturnProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
        } finally {
            database.endTransaction();
        }
    }

    private void manageCFAReturnProduct() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_cfa_return_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_cfa_return_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_cfa_return_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_cfa_return_product (\n" +
                "                                              cfa_return_product_id,\n" +
                "                                              cfa_return_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT cfa_return_product_id,\n" +
                "                                              cfa_return_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_cfa_return_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY);
    }

    public void insertRetailerScannedOutSticker(JSONArray arrayRetailerScannedOutSticker) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_SCANNED_OUT_STICKER);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_SCANNED_OUT_STICKER
                    + " (" + DataBaseHelper.TOTALINSCANNED + ","
                    + DataBaseHelper.DTMONTH + ") VALUES (?,?)";


            for (int k = 0; k < arrayRetailerScannedOutSticker.length(); k++) {
                try {
                    JSONObject object = arrayRetailerScannedOutSticker.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("TotalInScanned"));
                    statement.bindString(2, object.getString("dtmonth"));
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertRetailerScannedOutSticker";
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertRetailerScannedOutSticker";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertRetailerScannedOutSticker";
        } finally {
            database.endTransaction();
//            close();
        }
    }

    public void deleteUnreceivedValidData() {
        database.execSQL("DELETE\n" +
                "  FROM bf_ishop_distributor_received_product\n" +
                " WHERE distributor_received_id NOT IN ( \n" +
                "           SELECT bidr.distributor_received_id\n" +
                "             FROM bf_ishop_distributor_received AS bidr \n" +
                "       )");
        database.execSQL("DELETE\n" +
                "  FROM bf_ishop_retailer_received_product\n" +
                " WHERE retailer_received_id NOT IN ( \n" +
                "           SELECT bidr.retailer_received_id\n" +
                "             FROM bf_ishop_retailer_received AS bidr \n" +
                "       )");
//        database.execSQL("DELETE\n" +
//                "  FROM bf_ishop_distributor_dispatch_product\n" +
//                " WHERE distributor_dispatch_id NOT IN ( \n" +
//                "           SELECT distributor_dispatch_id\n" +
//                "             FROM bf_ishop_distributor_dispatch \n" +
//                "       )");
        database.execSQL("DELETE\n" +
                "  FROM bf_ishop_retailer_dispatch_product\n" +
                " WHERE retailer_dispatch_id NOT IN ( \n" +
                "           SELECT retailer_dispatch_id\n" +
                "             FROM bf_ishop_retailer_dispatch \n" +
                "       )");
        database.execSQL("DELETE\n" +
                "  FROM bf_ishop_distributor_return_request_product\n" +
                " WHERE distributor_return_request_id NOT IN ( \n" +
                "           SELECT distributor_return_request_id\n" +
                "             FROM bf_ishop_distributor_return_request \n" +
                "       );\n");
        database.execSQL("DELETE\n" +
                "  FROM bf_ishop_toller_dispatch_product\n" +
                " WHERE toller_dispatch_id NOT IN ( \n" +
                "           SELECT toller_dispatch_id\n" +
                "             FROM bf_ishop_toller_dispatch \n" +
                "       )");
    }


    public void deleteRejectedOrder() {
        database.execSQL("Delete from table_rejected_order");
    }


    public boolean InsertDistributorDispatch(IshopDistributorDispatch object, int isDispatch) {

        ContentValues contentValues = new ContentValues();

        contentValues.put(DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_ID, object.getDistributorDispatchId());
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_FROM_ID, object.getCustomerFromId());
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TO_ID, object.getCustomerToId());
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID, object.getCustomerTypeCountryId());
        contentValues.put(DataBaseHelper.KEY_IS_NEW_CUSTOMER, object.getIsNewCustomer());
        contentValues.put(DataBaseHelper.KEY_DISPATCH_DATE, object.getDispatchDate());
        //  contentValues.put(DataBaseHelper.KEY_RECEIVED, object.getReceived());
        // contentValues.put(DataBaseHelper.KEY_RECEIVED_DATE, object.getReceivedDate());
        contentValues.put(DataBaseHelper.KEY_COUNTRY_ID, object.getCountryId());
        contentValues.put(DataBaseHelper.KEY_CREATED_BY_USER, object.getCreatedByUser());
        contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
        contentValues.put(DataBaseHelper.KEY_STATUS, object.getStatus());
        contentValues.put(DataBaseHelper.KEY_CREATE_ON, object.getCreatedOn());
        contentValues.put(DataBaseHelper.KEY_MODIFIED_ON, object.getModifiedOn());
        contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
        contentValues.put(DataBaseHelper.KEY_SYNC_CODE, object.getSyncCode());
        contentValues.put(DataBaseHelper.KEY_SYNC_FLAG, object.getSyncFlag());
        contentValues.put(DataBaseHelper.KEY_SYNC_DATE, object.getSyncDate());
        contentValues.put(DataBaseHelper.KEY_SYNC_USER, object.getSyncByUser());
        contentValues.put(DataBaseHelper.KEY_READ, object.getRead());
        contentValues.put(DataBaseHelper.KEY_READ_DATE, object.getReadDate());
        contentValues.put(DataBaseHelper.KEY_IS_DISPATCH, isDispatch);
        contentValues.put(DataBaseHelper.KEY_customer_to_name, object.getCustomer_to_name());
        contentValues.put(DataBaseHelper.KEY_customer_to_phone, object.getCustomer_to_phone());
        contentValues.put(DataBaseHelper.KEY_new_customer_type, object.getNew_customer_type());

        long d = database.insert(DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH, null, contentValues);
        if (d > 0) {
            Log.e(TAG, "TABLE DISTRIBUTOR DISPATCH INSERT SUCCESSFULLY");
        } else {
            Log.e(TAG, "TABLE DISTRIBUTOR DISPATCH not INSERT SUCCESSFULLY");
        }

        return true;
    }

    //    Changes Done For Column Name
    public static boolean InsertStickerDetailsNew(JSONArray stickerArray, Context context, String loginId,
                                                  String customer_level,String roleCode) {

        long startTime = System.currentTimeMillis();
        Log.v("INSERT_TRACK", " START TIME::" + startTime);
//        open();
        database.beginTransaction();
        database.execSQL("delete from " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY);

        Log.e("---------------", "---------------------------------");

        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY
                    + " (" + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_STICKER_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_IN + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_IN + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_STICKER_NO + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_ANDROID_SYNC + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + Database_Column.KEY_PALLET_DETAIL_ID + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            try {

                for (int i = 0; i < stickerArray.length(); i++) {
                    int j = 1;
                    JSONObject obj = stickerArray.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, obj.getString("A"));//sticker_details_id
                    statement.bindString(j++, obj.getString("B"));//sticker_id
                    statement.bindString(j++, obj.getString("C"));//btc_no_in
                    statement.bindString(j++, obj.getString("D"));//btc_no_out
                    statement.bindString(j++, obj.getString("E"));//qr_code_in
                    statement.bindString(j++, obj.getString("F"));//qr_code_out
//                    statement.bindString(j++, "");//qr_code_in
//                    statement.bindString(j++,"");//qr_code_out
                    statement.bindString(j++, obj.getString("G"));//sticker_no
                    statement.bindString(j++, obj.getString("H"));//customer_type_country_id
                    statement.bindString(j++, obj.getString("I"));//customer_id
                    statement.bindString(j++, obj.getString("J"));//created_by_user
                    statement.bindString(j++, obj.getString("K"));//created_on
                    statement.bindString(j++, obj.getString("L"));//sync_code
                    statement.bindString(j++, obj.getString("M"));//sync_flag
                    statement.bindString(j++, obj.getString("N"));//sync_date
                    statement.bindString(j++, obj.getString("P"));//android_sync
                    statement.bindString(j++, obj.getString("O"));//sync_by_user

                    if (obj.has("Q")) {
                        if (obj.getString("Q") != null && !obj.getString("Q").trim().isEmpty()) {
                            statement.bindLong(j++, Integer.parseInt(obj.getString("Q"))); //pallet_detail_id
                        } else {
                            statement.bindLong(j++, 0); //pallet_detail_id
                        }
                    } else {
                        statement.bindLong(j++, 0); //pallet_detail_id
                    }

                    statement.execute();

                    Log.e("insert", "TABLE_STICKER_DETAILS_COPY");
                }
            } catch (JSONException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertStickerDetailsNew";
                Log.e("Check log", "" + e.getMessage());
            }

            // process

            // delete data
            database.execSQL("DELETE FROM ishop_sticker_details\n" +
                    "      WHERE sticker_details_id IN (\n" +
                    "    SELECT st.sticker_details_id\n" +
                    "      FROM ishop_sticker_details AS st\n" +
                    "           INNER JOIN\n" +
                    "           ishop_sticker_details_copy AS st_copy ON st.sticker_details_id = st_copy.sticker_details_id\n" +
                    ");");


//            String customer_level = Content.getPreferenceValue(context, Const.CUSTOMER_LEVEL);
            LogHelper.printLog("LOGGED_IN", "::: " + loginId);
            //Deleting Discarded Record For All Customers and Employees
            if (!customer_level.equalsIgnoreCase("L4") && !roleCode.equalsIgnoreCase("FO")) {
                database.execSQL("DELETE FROM " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY + " WHERE customer_id <> '" + loginId + "'");
            }

//            Deleting the Record of Farmers Dispached Stickers
            database.execSQL("DELETE FROM " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY + " WHERE android_sync='D'");


            //Deleting Flag Only For Dist and Retailer
            if (customer_level.equalsIgnoreCase("L3") || customer_level.equalsIgnoreCase("L2")) {
                database.execSQL("DELETE FROM " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY + " WHERE android_sync='R'");
            }

            database.execSQL("Insert into " + DataBaseHelper.TABLE_STICKER_DETAILS + "(sticker_details_id,\n" +
                    "       sticker_id,\n" +
                    "       btc_no_in,\n" +
                    "       btc_no_out,\n" +
                    "       qr_code_in,\n" +
                    "       qr_code_out,\n" +
                    "       sticker_no,\n" +
                    "       isBuffer,\n" +
                    "       customer_type_country_id,\n" +
                    "       customer_id,\n" +
                    "       deleted,\n" +
                    "       created_by_user,\n" +
                    "       created_on,\n" +
                    "       sync_code,\n" +
                    "       sync_flag,\n" +
                    "       sync_date,android_sync,pallet_details_id,\n" +
                    "       sync_by_user)" + "SELECT sticker_details_id,\n" +
                    "       sticker_id,\n" +
                    "       btc_no_in,\n" +
                    "       btc_no_out,\n" +
                    "       qr_code_in,\n" +
                    "       qr_code_out,\n" +
                    "       sticker_no,\n" +
                    "       isBuffer,\n" +
                    "       customer_type_country_id,\n" +
                    "       customer_id,\n" +
                    "       deleted,\n" +
                    "       created_by_user,\n" +
                    "       created_on,\n" +
                    "       sync_code,\n" +
                    "       sync_flag,\n" +
                    "       sync_date,android_sync,pallet_details_id,\n" +
                    "       sync_by_user from " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY);
            database.execSQL("delete from " + DataBaseHelper.TABLE_STICKER_DETAILS_COPY);

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            Log.e("-------message--------", ""+e.getMessage());
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertStickerDetailsNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            Log.e("-------message--------", ""+e.getMessage());
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertStickerDetailsNew";
        } finally {
            database.endTransaction();
//            close();
        }
        long EndTime = System.currentTimeMillis();
        Log.v("INSERT_TRACK", " END TIME::" + EndTime);
        Log.e("---------------", "---------------------------------");

        return true;
    }


    //    For Column Name changes Done By Chandan
    public void InsertCFADispatchProductNew1(JSONArray arrayCfaDispatchProduct) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DISPATCH_PRODUCT_COPY);
        database.beginTransaction();
        try {

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_DISPATCH_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_CFA_DISPATCH_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_CFA_DISPATCH_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + "," + DataBaseHelper.DISPATCH_SCAN_TYPE + " ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            try {
                int totalArraySize = arrayCfaDispatchProduct.length();
                for (int i = 0; i < totalArraySize; i++) {
                    JSONObject object = arrayCfaDispatchProduct.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//cfa_dispatch_product_id
                    statement.bindString(2, object.getString("B"));//cfa_dispatch_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("N"));//sync_code
                    statement.bindString(13, object.getString("O"));//sync_flag
                    statement.bindString(14, object.getString("P"));//sync_date
                    statement.bindString(15, object.getString("Q"));//sync_by_user
                    statement.bindString(16, object.getString("L"));//received
                    statement.bindString(17, object.getString("M"));//received_date
                    statement.bindString(18, object.getString("R"));//dispatch_scan_type
                    statement.execute();

                    Log.e("KEY_DISPATCH_PRODUCT", "KEY_CFA_DISPATCH_PRODUCT_ID");
                }
            } catch (JSONException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchProductNew1";
            }
            manageProductTable();

            database.setTransactionSuccessful();
        } catch (Exception e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchProductNew1";
        } finally {
            database.endTransaction();
        }
    }

    /**
     * Please Check the Following Reference
     * <p>
     * [{"id":"A","email":"B","user_code":"C","bussiness_code":"D",
     * "display_name":"E","parent_user_id":"F","customer_type_country_id":"G",
     * "customer_type_country_code":"H","customer_type_country_name":"I",
     * "customer_type_regional_id":"J","customer_type_regional_name":"K",
     * "customer_type_regional_code":"L","customer_regional_level":"M",
     * "political_geo_id":"N","political_geography_countrylevel_id":"O",
     * "political_regional_level":"P","sap_id":"Q"}]
     *
     * @param jsonArrayCustomerDetails
     */
    public void insertCustomerDetails(JSONArray jsonArrayCustomerDetails, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_CUSTOMER_DETAILS);
        }
        database.beginTransaction();
        try {

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CUSTOMER_DETAILS
                    + " (" + DataBaseHelper.KEY_ID + ","
                    + DataBaseHelper.KEY_EMAIL + ","
                    + DataBaseHelper.KEY_USER_CODE + ","
                    + DataBaseHelper.KEY_BUSSINESS_CODE + ","
                    + DataBaseHelper.KEY_DISPLAY_NAME + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_CODE + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_NAME + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_NAME + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_CODE + ","
                    + DataBaseHelper.KEY_CUSTOMER_TYPE_REGIONAL_LEVEL + ","
                    + DataBaseHelper.KEY_POLITICAL_GEO_ID + ","
                    + DataBaseHelper.KEY_political_geography_countrylevel_id + ","
                    + DataBaseHelper.KEY_political_regional_level + ","
                    + DataBaseHelper.KEY_SAP_ID + ","
                    + DataBaseHelper.KEY_PARENT_USER_ID + ","
                    + DataBaseHelper.KEY_PRIMARY_MOBILE_NO + " ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            try {
                for (int i = 0; i < jsonArrayCustomerDetails.length(); i++) {
                    JSONObject object = jsonArrayCustomerDetails.getJSONObject(i);
                    int j = 1;
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, object.getString("A"));//id
                    statement.bindString(j++, object.getString("B"));//email
                    statement.bindString(j++, object.getString("C"));//user_code
                    statement.bindString(j++, object.getString("D"));//bussiness_code
                    statement.bindString(j++, object.getString("E"));//display_name
                    statement.bindString(j++, object.getString("G"));//customer_type_country_id
                    statement.bindString(j++, object.getString("H"));//customer_type_country_code
                    statement.bindString(j++, object.getString("I"));//customer_type_country_name
                    statement.bindString(j++, object.getString("J"));//customer_type_regional_id
                    statement.bindString(j++, object.getString("K"));//customer_type_regional_name
                    statement.bindString(j++, object.getString("L"));//customer_type_regional_code
                    statement.bindString(j++, object.getString("M"));//customer_regional_level
                    statement.bindString(j++, object.getString("N"));//political_geo_id
                    statement.bindString(j++, object.getString("O"));//political_geography_countrylevel_id
                    statement.bindString(j++, object.getString("P"));//political_regional_level
                    statement.bindString(j++, object.getString("Q"));//sap_id
                    statement.bindString(j++, object.getString("F"));//parent_user_id
                    statement.bindString(j++, object.getString("R"));//parent_user_id
                    statement.execute();
                }
                Log.e("CUSTOMER_DETAILS", "INSERT COMPLETE");
            } catch (JSONException e) {
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
            }
            database.setTransactionSuccessful();
        } catch (Exception e) {
            e.printStackTrace();
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
        }
        database.endTransaction();

    }


    /**
     * Optimized Column
     * For Size
     * <p>
     * <p>
     * [{"sticker_id":"A",
     * "ref_Id":"B",
     * "customer_id":"C",
     * "country_id":"D",
     * "PBG_Country_Id":"E",
     * "Product_SKU_Country_Id":"F",
     * "batch_no":"G",
     * "expire_date":"H",
     * "quantity":"I",
     * "status":"J",
     * "sync_code":"K",
     * "sync_flag":"L",
     * "sync_date":"M",
     * "sync_by_user":"N"}]
     *
     * @param ishop_sticker
     */

    public void InsertStickerNew(JSONArray ishop_sticker, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_STICKER);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_STICKER
                    + " (" + DataBaseHelper.KEY_STICKER_ID + ","
                    + DataBaseHelper.KEY_REF_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_PBG_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_BATCH_NO + ","
                    + DataBaseHelper.KEY_EXPIRE_DATE + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_BATCH_ID + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int i = 0; i < ishop_sticker.length(); i++) {
                try {
                    int j = 1;
                    JSONObject object = ishop_sticker.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, object.getString("A"));//sticker_id
                    statement.bindString(j++, object.getString("B"));//ref_Id
                    statement.bindString(j++, object.getString("C"));//customer_id
                    statement.bindString(j++, object.getString("D"));//country_id
                    statement.bindString(j++, object.getString("E"));//PBG_Country_Id
                    statement.bindString(j++, object.getString("F"));//Product_SKU_Country_Id
                    statement.bindString(j++, object.getString("G"));//batch_no
                    statement.bindString(j++, object.getString("H"));//expire_date
                    statement.bindString(j++, object.getString("I"));//quantity
                    statement.bindString(j++, object.getString("J"));//status
                    statement.bindString(j++, object.getString("K"));//sync_code
                    statement.bindString(j++, object.getString("L"));//sync_flag
                    statement.bindString(j++, object.getString("M"));//sync_date
                    statement.bindString(j++, object.getString("N"));//sync_by_user
                    statement.bindLong(j++, object.optInt("O"));//batch_id
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    SynchronizationService.isSuccess = false;
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertStickerNew";
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertStickerNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertStickerNew";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * [{"toller_dispatch_id":"A",
     * "customer_from_id":"B",
     * "customer_to_id":"C",
     * "dispatch_date":"D",
     * "document_no":"E",
     * "country_id":"F",
     * "received":"G",
     * "received_date":"H",
     * "isRead":"I",
     * "read_date":"J",
     * "created_by_user":"K",
     * "modified_by_user":"L",
     * "status":"M",
     * "created_on":"N",
     * "modified_on":"O",
     * "sync_code":"P",
     * "sync_flag":"Q",
     * "sync_date":"R",
     * "sync_by_user":"S"}]
     *
     * @param ishop_toller_dispatch
     * @return
     */
    public static boolean InsertTollerDispatchNew(JSONArray ishop_toller_dispatch, String fileName) {

        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
            if (fileName.equalsIgnoreCase("1.txt")) {
                database.execSQL("delete from " + DataBaseHelper.TABLE_TOLLER_DISPATCH);
            }
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_TOLLER_DISPATCH
                        + " (" + DataBaseHelper.KEY_TOLLER_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_DOCUMENT_NO + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ","
                        + DataBaseHelper.KEY_RECEIVED + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_REJECT + ","
                        + DataBaseHelper.KEY_REJECT_DATE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int i = 0; i < ishop_toller_dispatch.length(); i++) {
                    try {
                        JSONObject object = ishop_toller_dispatch.getJSONObject(i);
                        int j = 1;
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindLong(j++, Integer.parseInt(object.getString("A")));//toller_dispatch_id
                        statement.bindString(j++, object.getString("B"));//customer_from_id
                        statement.bindString(j++, object.getString("C"));//customer_to_id
                        statement.bindString(j++, object.getString("D"));//dispatch_date
                        statement.bindString(j++, object.getString("E"));//document_no
                        statement.bindString(j++, object.getString("F"));//country_id
                        statement.bindString(j++, object.getString("K"));//created_by_user
                        statement.bindString(j++, object.getString("L"));//modified_by_user
                        statement.bindString(j++, object.getString("M"));//status
                        statement.bindString(j++, object.getString("N"));//created_on
                        statement.bindString(j++, object.getString("O"));//modified_on
                        statement.bindString(j++, object.getString("P"));//sync_code
                        statement.bindString(j++, object.getString("Q"));//sync_flag
                        statement.bindString(j++, object.getString("R"));//sync_date
                        statement.bindString(j++, object.getString("S"));//sync_by_user
                        statement.bindString(j++, object.getString("G"));//received
                        statement.bindString(j++, object.getString("I"));//isRead
                        statement.bindString(j++, object.getString("J"));//read_date
                        statement.bindString(j++, object.getString("H"));//received_date
                        statement.bindString(j++, object.getString("T"));//reject
                        statement.bindString(j++, object.getString("U"));//reject_date
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertTollerDispatchNew";
                    }
                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertTollerDispatchNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertTollerDispatchNew";
            } finally {
                database.endTransaction();
            }
        } else {
            database.execSQL("delete from " + DataBaseHelper.TABLE_TOLLER_DISPATCH_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_TOLLER_DISPATCH_COPY
                        + " (" + DataBaseHelper.KEY_TOLLER_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_DOCUMENT_NO + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ","
                        + DataBaseHelper.KEY_RECEIVED + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_REJECT + ","
                        + DataBaseHelper.KEY_REJECT_DATE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int i = 0; i < ishop_toller_dispatch.length(); i++) {
                    try {
                        JSONObject object = ishop_toller_dispatch.getJSONObject(i);
                        int j = 1;
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindLong(j++, Integer.parseInt(object.getString("A")));//toller_dispatch_id
                        statement.bindString(j++, object.getString("B"));//customer_from_id
                        statement.bindString(j++, object.getString("C"));//customer_to_id
                        statement.bindString(j++, object.getString("D"));//dispatch_date
                        statement.bindString(j++, object.getString("E"));//document_no
                        statement.bindString(j++, object.getString("F"));//country_id
                        statement.bindString(j++, object.getString("K"));//created_by_user
                        statement.bindString(j++, object.getString("L"));//modified_by_user
                        statement.bindString(j++, object.getString("M"));//status
                        statement.bindString(j++, object.getString("N"));//created_on
                        statement.bindString(j++, object.getString("O"));//modified_on
                        statement.bindString(j++, object.getString("P"));//sync_code
                        statement.bindString(j++, object.getString("Q"));//sync_flag
                        statement.bindString(j++, object.getString("R"));//sync_date
                        statement.bindString(j++, object.getString("S"));//sync_by_user
                        statement.bindString(j++, object.getString("G"));//received
                        statement.bindString(j++, object.getString("I"));//isRead
                        statement.bindString(j++, object.getString("J"));//read_date
                        statement.bindString(j++, object.getString("H"));//received_date
                        statement.bindString(j++, object.getString("T"));//reject
                        statement.bindString(j++, object.getString("U"));//reject_date
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertTollerDispatchNew";
                    }
                }

                manageTollerDispatchCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertTollerDispatchNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertTollerDispatchNew";
            } finally {
                database.endTransaction();
            }

        }
        return true;
    }

    private static void manageTollerDispatchCopy() {
        database.execSQL("DELETE FROM bf_ishop_toller_dispatch\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_toller_dispatch AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_toller_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");

        database.execSQL("INSERT INTO bf_ishop_toller_dispatch (\n" +
                "                                              toller_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              dispatch_date,\n" +
                "                                              document_no,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              received,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              received_date,\n" +
                "                                              reject,\n" +
                "                                              rejected_date,\n" +
                "                                              rejected_comment\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              toller_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              dispatch_date,\n" +
                "                                              document_no,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              received,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              received_date,\n" +
                "                                              reject,\n" +
                "                                              rejected_date,\n" +
                "                                              rejected_comment\n" +
                "                                            FROM bf_ishop_toller_dispatch_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_TOLLER_DISPATCH_COPY);
    }


    /**
     * For Column Reference
     * <p>
     * {"toller_dispatch_product_id":"A",
     * "toller_dispatch_id":"B",
     * "product_sku_country_id":"C",
     * "sticker_id":"D",
     * "batch_no":"E",
     * "quantity":"F",
     * "amount":"G",
     * "unit":"H",
     * "qty_kgl":"I",
     * "received":"J",
     * "received_date":"K",
     * "sync_code":"L",
     * "sync_flag":"M",
     * "sync_date":"N",
     * "sync_by_user":"O"}
     *
     * @param ishop_toller_dispatch_product
     */
    public void InsertTollerDispatchProductNew(JSONArray ishop_toller_dispatch_product) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_TOLLER_DISPATCH_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_TOLLER_DISPATCH_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_TOLLER_DISPATCH_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_TOLLER_DISPATCH_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_STICKER_ID + ","
                    + DataBaseHelper.KEY_BATCH_NO + ","
                    //   + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
                    //   + DataBaseHelper.KEY_READ + ","
                    //    + DataBaseHelper.KEY_READ_DATE + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int k = 0; k < ishop_toller_dispatch_product.length(); k++) {
                try {
                    JSONObject obj = ishop_toller_dispatch_product.getJSONObject(k);
                    int j = 1;
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindLong(j++, Integer.parseInt(obj.getString("A")));//toller_dispatch_product_id
                    statement.bindLong(j++, Integer.parseInt(obj.getString("B")));//toller_dispatch_id
                    statement.bindLong(j++, Integer.parseInt(obj.getString("C")));//product_sku_country_id
                    statement.bindLong(j++, Integer.parseInt(obj.getString("D")));//sticker_id
                    statement.bindString(j++, obj.getString("E"));//batch_no
                    //  statement.bindString(6, obj.getString("qr_code_out"));
                    statement.bindString(j++, obj.getString("F"));//quantity
                    statement.bindString(j++, obj.getString("G"));//amount
                    statement.bindString(j++, obj.getString("H"));//unit
                    statement.bindString(j++, obj.getString("I"));//qty_kgl
                    statement.bindString(j++, obj.getString("J"));//received
                    statement.bindString(j++, obj.getString("K"));//received_date
                    //  statement.bindString(13, obj.getString("isRead"));
                    // statement.bindString(14, obj.getString("read_date"));
                    statement.bindString(j++, obj.getString("L"));//sync_code
                    statement.bindString(j++, obj.getString("M"));//sync_flag
                    statement.bindString(j++, obj.getString("N"));//sync_date
                    statement.bindString(j++, obj.getString("O"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertTollerDispatchProductNew";
                }
            }
            manageTollerDispatchProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertTollerDispatchProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertTollerDispatchProductNew";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * For Column Reference
     * <p>
     * {"distributor_dispatch_product_id":"A",
     * "distributor_dispatch_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no_out":"E",
     * "qr_code_out":"F",
     * "quantity":"G",
     * "amount":"H",
     * "unit":"I",
     * "qty_kgl":"J",
     * "is_valid":"K",
     * "received":"L",
     * "received_date":"M",
     * "sync_code":"N",
     * "sync_flag":"O",
     * "sync_date":"P",
     * "sync_by_user":"Q",
     * "dispatch_scan_type":"R"}
     *
     * @param ishop_distributor_dispatch_product
     */
    public void InsertDistributorDispatchProductNew(JSONArray ishop_distributor_dispatch_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
                    + DataBaseHelper.DISPATCH_SCAN_TYPE + ","
                    + DataBaseHelper.KEY_BTC_TYPE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_distributor_dispatch_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_distributor_dispatch_product.getJSONObject(k);
                    int j = 1;
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, object.getString("A"));//distributor_dispatch_product_id
                    statement.bindString(j++, object.getString("B"));//distributor_dispatch_id
                    statement.bindString(j++, object.getString("C"));//product_sku_id
                    statement.bindString(j++, object.getString("D"));//sticker_details_id
                    statement.bindString(j++, object.getString("E"));//btc_no_out
                    statement.bindString(j++, object.getString("F"));//qr_code_out
                    statement.bindString(j++, object.getString("G"));//quantity
                    statement.bindString(j++, object.getString("H"));//amount
                    statement.bindString(j++, object.getString("I"));//unit
                    statement.bindString(j++, object.getString("J"));//qty_kgl
                    statement.bindString(j++, object.getString("K"));//is_valid
                    statement.bindString(j++, object.getString("N"));//sync_code
                    statement.bindString(j++, object.getString("O"));//sync_flag
                    statement.bindString(j++, object.getString("P"));//sync_date
                    statement.bindString(j++, object.getString("Q"));//sync_by_user
                    statement.bindString(j++, object.getString("L"));//received
                    statement.bindString(j++, object.getString("M"));//received_date
                    statement.bindString(j++, object.getString("R"));//dispatch scan type
                    statement.bindString(j++, object.getString("S"));//btc_type
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertDistributorDispatchProductNew";
                }

            }
            manageDistributorProductTable();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertDistributorDispatchProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertDistributorDispatchProductNew";
        } finally {
            database.endTransaction();
        }
    }

    /**
     * For Column Reference
     * <p>
     * {"product_sku_country_id":"A",
     * "product_sku_id":"B",
     * "product_sku_name":"C",
     * "country_id":"D",
     * "created_by_user":"E",
     * "modified_by_user":"F",
     * "deleted":"G",
     * "status":"H",
     * "created_on":"I",
     * "modified_on":"J",
     * "PBG_ID":"K",
     * "product_sku_code":"L"}
     *
     * @param arrayProductSkuCountry
     */
    public void insertProductSkuCountry(JSONArray arrayProductSkuCountry, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_MASTER_PRODUCT_SKU_COUNTRY);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_MASTER_PRODUCT_SKU_COUNTRY
                    + " (" + DataBaseHelper.KEY_PRODUCT_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_NAME + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
//                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
//                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
//                    + DataBaseHelper.KEY_DELETED + ","
//                    + DataBaseHelper.KEY_STATUS + ","
//                    + DataBaseHelper.KEY_CREATE_ON + ","
//                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_PBG_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_CODE + ") VALUES (?,?,?,?,?,?)";


            for (int k = 0; k < arrayProductSkuCountry.length(); k++) {
                JSONObject object = null;
                try {
                    object = arrayProductSkuCountry.getJSONObject(k);
                    int j = 1;
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, object.getString("A"));//product_sku_country_id
                    statement.bindString(j++, object.getString("B"));//product_sku_id
                    statement.bindString(j++, object.getString("C"));//product_sku_name
                    statement.bindString(j++, object.getString("D"));//country_id
                    statement.bindString(j++, object.getString("E"));//PBG_ID
                    statement.bindString(j++, object.getString("F"));//product_sku_code
//                    statement.bindString(j++, object.getString("G"));
//                    statement.bindString(j++, object.getString("H"));
//                    statement.bindString(j++, object.getString("I"));
//                    statement.bindString(j++, object.getString("K"));
//                    statement.bindString(j++, object.getString("L"));
//                    statement.bindString(j++, object.getString("J"));
                    statement.execute();
                } catch (JSONException e) {
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertProductSkuCountry";
                    e.printStackTrace();
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertProductSkuCountry";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertProductSkuCountry";
        } finally {
            database.endTransaction();
        }
    }

    /**
     * {"distributor_return_product_id":"A",
     * "distributor_return_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no_out":"E",
     * "qr_code_out":"F",
     * "quantity":"G",
     * "amount":"H",
     * "unit":"I",
     * "qty_kgl":"J",
     * "is_valid":"K",
     * "sync_code":"L",
     * "sync_flag":"M",
     * "sync_date":"N",
     * "sync_by_user":"O"}
     *
     * @param ishop_distributor_return_product
     */

    public void InsertDistributorReturnProductNew(JSONArray ishop_distributor_return_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_distributor_return_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_distributor_return_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//distributor_return_product_id
                    statement.bindString(2, object.getString("B"));//distributor_return_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("L"));//sync_code
                    statement.bindString(13, object.getString("M"));//sync_flag
                    statement.bindString(14, object.getString("N"));//sync_date
                    statement.bindString(15, object.getString("O"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnProductNew";
                }

            }
            manageDistributorReturnProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnProductNew";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * {"distributor_received_product_id":"A",
     * "distributor_received_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no_out":"E",
     * "qr_code_out":"F",
     * "quantity":"G",
     * "amount":"H",
     * "unit":"I",
     * "qty_kgl":"J",
     * "is_valid":"K",
     * "sync_code":"L",
     * "sync_flag":"M",
     * "sync_date":"N",
     * "sync_by_user":"O",
     * "created_by":"P",
     * "created_on":"Q"}
     *
     * @param ishop_distributor_received_product
     */
    public void InsertDistributorReceivedProductNew(JSONArray ishop_distributor_received_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_DISTRIBUTOR_RECEIVED_PRODUCT
                    + " (" + DataBaseHelper.DISTRIBUTOR_RECEIVED_PRODUCT_ID + ","
                    + DataBaseHelper.DISTRIBUTOR_RECEIVED_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_CREATE_BY + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            for (int k = 0; k < ishop_distributor_received_product.length(); k++) {
                try {
                    JSONObject object = ishop_distributor_received_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//distributor_received_product_id
                    statement.bindString(2, object.getString("B"));//distributor_received_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("L"));//sync_code
                    statement.bindString(13, object.getString("M"));//sync_flag
                    statement.bindString(14, object.getString("N"));//sync_date
                    statement.bindString(15, object.getString("O"));//sync_by_user
                    statement.bindString(16, object.getString("Q"));//created_on
                    statement.bindString(17, object.getString("P"));//created_by
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertDistributorReceivedProductNew";
                }
            }
            database.setTransactionSuccessful();

        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertDistributorReceivedProductNew";

        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertDistributorReceivedProductNew";

        } finally {
            database.endTransaction();
        }


        Log.e(TAG, "TABLE DistributorReceivedProduct Add SUCCESSFULLY");
    }


    /**
     * For Column Reference
     * <p>
     * {"retailer_dispatch_product_id":"A",
     * "retailer_dispatch_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no":"E",
     * "qr_code":"F",
     * "btc_type":"G",
     * "quantity":"H",
     * "amount":"I",
     * "unit":"J",
     * "qty_kgl":"K",
     * "is_valid":"L",
     * "received":"M",
     * "received_date":"N",
     * "sync_code":"O",
     * "sync_flag":"P",
     * "sync_date":"Q",
     * "sync_by_user":"R",
     * "dispatch_scan_type":"S"}
     *
     * @param ishop_retailer_dispatch_product
     */

    public void InsertRetailerDispatchProductNew(JSONArray ishop_retailer_dispatch_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_DISPATCH_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_RETAILER_DISPATCH_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_RETAILER_DISPATCH_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_RETAILER_DISPATCH_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO + ","
                    + DataBaseHelper.KEY_qr_code + ","
                    + DataBaseHelper.KEY_BTC_TYPE + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int k = 0; k < ishop_retailer_dispatch_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_retailer_dispatch_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//retailer_dispatch_product_id
                    statement.bindString(2, object.getString("B"));//retailer_dispatch_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no
                    statement.bindString(6, object.getString("F"));//qr_code
                    statement.bindString(7, object.getString("G"));//btc_type
                    statement.bindString(8, object.getString("H"));//quantity
                    statement.bindString(9, object.getString("I"));//amount
                    statement.bindString(10, object.getString("J"));//unit
                    statement.bindString(11, object.getString("K"));//qty_kgl
                    statement.bindString(12, object.getString("L"));//is_valid
                    statement.bindString(13, object.getString("M"));//received
                    statement.bindString(14, object.getString("N"));//received_date
                    statement.bindString(15, object.getString("O"));//sync_code
                    statement.bindString(16, object.getString("P"));//sync_flag
                    statement.bindString(17, object.getString("Q"));//sync_date
                    statement.bindString(18, object.getString("R"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerDispatchProductNew";
                }

            }

            manageRetailerDispatchProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerDispatchProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerDispatchProductNew";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * For Column Reference
     * <p>
     * {"retailer_received_product_id":"A",
     * "retailer_received_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no_out":"E",
     * "qr_code_out":"F",
     * "quantity":"G",
     * "amount":"H",
     * "unit":"I",
     * "qty_kgl":"J",
     * "is_valid":"K",
     * "sync_code":"L",
     * "sync_flag":"M",
     * "sync_date":"N",
     * "sync_by_user":"O",
     * "created_by":"P",
     * "created_on":"Q"}
     *
     * @param ishop_retailer_received_product
     */
    public void InsertRetailerReceivedProductNew(JSONArray ishop_retailer_received_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT_COPY +
                    " (" + DataBaseHelper.RETAILER_RECEIVED_PRODUCT_ID + ","
                    + DataBaseHelper.RETAILER_RECEIVED_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.SYNC_BY_USER + ","
                    + DataBaseHelper.KEY_CREATE_BY + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_OUT_POINT_CALCULATE + ","
                    + DataBaseHelper.KEY_RECEIVE_SCAN_TYPE
                    + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";
            for (int k = 0; k < ishop_retailer_received_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_retailer_received_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//retailer_received_product_id
                    statement.bindString(2, object.getString("B"));//retailer_received_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("L"));//sync_code
                    statement.bindString(13, object.getString("M"));//sync_flag
                    statement.bindString(14, object.getString("N"));//sync_date
                    statement.bindString(15, object.getString("O"));//sync_by_user
                    statement.bindString(16, object.getString("P"));//created_by
                    statement.bindString(17, object.getString("Q"));//created_on
                    statement.bindString(18, "0");//created_on
                    statement.bindString(19, object.getString("R"));//created_on
                    statement.execute();
                    Log.e(TAG, "TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT Add SUCCESSFULLY");
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedProductNew";
                }

            }
            manageRetailerReceiveProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedProductNew";
        } finally {
            database.endTransaction();
        }

    }

    /**
     * For Column Reference
     * <p>
     * {"product_country_id":"A",
     * "product_regional_id":"B",
     * "product_country_name":"C",
     * "product_regional_code":"D",
     * "Description":"E",
     * "country_id":"F",
     * "created_by_user":"G",
     * "modified_by_user":"H",
     * "deleted":"I",
     * "status":"J",
     * "created_on":"K",
     * "modified_on":"L"}
     *
     * @param arrayProductTypeCountryName
     */
    public void insertProductTypeNameCountry(JSONArray arrayProductTypeCountryName, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_PRODUCT_TYPE_NAME_COUNTRY);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_PRODUCT_TYPE_NAME_COUNTRY +
                    " (" + DataBaseHelper.KEY_PRODUCT_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_REGIONAL_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_COUNTRY_NAME + ","
                    + DataBaseHelper.KEY_PRODUCT_REGIONAL_CODE + ","
                    + DataBaseHelper.KEY_DESCRIPTION + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
//                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
//                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_DELETED + ","
//                    + DataBaseHelper.KEY_STATUS + ","
//                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_STATUS
                    + ") VALUES (?,?,?,?,?,?,?,?)";


            for (int k = 0; k < arrayProductTypeCountryName.length(); k++) {
                JSONObject object = null;
                try {
                    object = arrayProductTypeCountryName.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//product_country_id
                    statement.bindString(2, object.getString("B"));//product_regional_id
                    statement.bindString(3, object.getString("C"));//product_country_name
                    statement.bindString(4, object.getString("D"));//product_regional_code
                    statement.bindString(5, object.getString("E"));//Description
                    statement.bindString(6, object.getString("F"));//country_id
                    statement.bindString(7, object.getString("G"));//deleted
                    statement.bindString(8, object.getString("H"));//status
//                    statement.bindString(9, object.getString("I"));
//                    statement.bindString(10, object.getString("J"));
//                    statement.bindString(11, object.getString("K"));
//                    statement.bindString(12, object.getString("L"));
                    statement.execute();
                    Log.e(TAG, "TABLE_BF_ISHOP_RETAILER_RECEIVED_PRODUCT Add SUCCESSFULLY");
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertProductTypeNameCountry";
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertProductTypeNameCountry";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertProductTypeNameCountry";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * {"scheme_id":"A",
     * "scheme_code":"B",
     * "scheme_name":"C",
     * "from_month":"D",
     * "to_month":"E",
     * "product_sku_code":"F",
     * "product_sku_name":"G",
     * "value_per_point":"H"}
     *
     * @param jsonArray
     */
    public void InsertSchemeMaster(JSONArray jsonArray, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_SCHEME_MASTER);
        }
        database.beginTransaction();

        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_SCHEME_MASTER
                    + " (" + DataBaseHelper.KEY_SCHEME_ID + "," +
                    DataBaseHelper.KEY_SCHEME_CODE + "," +
                    DataBaseHelper.KEY_SCHEME_NAME + "," +
                    DataBaseHelper.KEY_FROM_MONTH + "," +
                    DataBaseHelper.KEY_TO_MONTH + "," +
                    DataBaseHelper.KEY_PRODUCT_SKU_CODE + "," +
                    DataBaseHelper.KEY_PRODUCT_SKU_NAME + "," +
                    DataBaseHelper.KEY_VALUE_PER_POINT + ")VALUES(?,?,?,?,?,?,?,?)";
            for (int i = 0; i < jsonArray.length(); i++) {
                try {
                    JSONObject jsonObject = jsonArray.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, jsonObject.getString("A"));//scheme_id
                    statement.bindString(2, jsonObject.getString("B"));//scheme_code
                    statement.bindString(3, jsonObject.getString("C"));//scheme_name
                    statement.bindString(4, jsonObject.getString("D"));//from_month
                    statement.bindString(5, jsonObject.getString("E"));//to_month
                    statement.bindString(6, jsonObject.getString("F"));//product_sku_code
                    statement.bindString(7, jsonObject.getString("G"));//product_sku_name
                    statement.bindString(8, jsonObject.getString("H"));//value_per_point
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSchemeMaster";
                }
            }
            database.setTransactionSuccessful();
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSchemeMaster";
        } finally {
            database.endTransaction();
        }

    }


    /**
     * {"cfa_dispatch_id":"A",
     * "customer_from_id":"B",
     * "customer_to_id":"C",
     * "sap_id":"D",
     * "dispatch_type":"E",
     * "do_sto_no":"F",
     * "dispatch_date":"G",
     * "received":"H",
     * "received_date":"I",
     * "isRead":"J",
     * "read_date":"K",
     * "country_id":"L",
     * "created_by_user":"M",
     * "modified_by_user":"N",
     * "status":"O",
     * "created_on":"P",
     * "modified_on":"Q",
     * "sync_code":"R",
     * "sync_flag":"S",
     * "sync_date":"T",
     * "sync_by_user":"U"}
     *
     * @param ishop_cfa_dispatch
     * @return
     */

    public boolean InsertCFADispatchNew(JSONArray ishop_cfa_dispatch, String fileName) {
        LogHelper.printLog("TAG_DATA_CFA", "DAT::: " + ishop_cfa_dispatch);
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            if (fileName.equalsIgnoreCase("1.txt")) {
                database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DISPATCH);
            }
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_DISPATCH
                        + " (" + DataBaseHelper.KEY_CFA_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_SAP_ID + ","
                        + DataBaseHelper.KEY_DISPATCH_TYPE + ","
                        + DataBaseHelper.KEY_DO_STO_NO + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_RECEIVED + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_SYNC_USER + ","
                        + DataBaseHelper.KEY_REJECT + ","
                        + DataBaseHelper.KEY_REJECT_DATE + ","
                        + DataBaseHelper.IS_DISPATCH_TYPE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_cfa_dispatch.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_cfa_dispatch.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//cfa_dispatch_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("D"));//sap_id
                        statement.bindString(5, object.getString("E"));//dispatch_type
                        statement.bindString(6, object.getString("F"));//do_sto_no
                        statement.bindString(7, object.getString("G"));//dispatch_date
                        statement.bindString(8, object.getString("H"));//received
                        statement.bindString(9, object.getString("I"));//received_date
                        statement.bindString(10, object.getString("L"));//country_id
                        statement.bindString(11, object.getString("M"));//created_by_user
                        statement.bindString(12, object.getString("N"));//modified_by_user
                        statement.bindString(13, object.getString("O"));//status
                        statement.bindString(14, object.getString("P"));//created_on
                        statement.bindString(15, object.getString("Q"));//modified_on
                        statement.bindString(16, object.getString("R"));//sync_code
                        statement.bindString(17, object.getString("S"));//sync_flag
                        statement.bindString(18, object.getString("T"));//sync_date
                        statement.bindString(19, object.getString("J"));//isRead
                        statement.bindString(20, object.getString("K"));//read_date
                        statement.bindString(21, "1");
                        statement.bindString(22, object.getString("U"));//sync_by_user
                        statement.bindString(23, object.getString("V"));//reject
                        statement.bindString(24, object.getString("W"));//reject_date
                        statement.bindString(25, object.getString("X"));//reject_date
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
                    }

                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
            } finally {
                database.endTransaction();
            }
        } else {

            database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DISPATCH_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_DISPATCH_COPY
                        + " (" + DataBaseHelper.KEY_CFA_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_SAP_ID + ","
                        + DataBaseHelper.KEY_DISPATCH_TYPE + ","
                        + DataBaseHelper.KEY_DO_STO_NO + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_RECEIVED + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_SYNC_USER + ","
                        + DataBaseHelper.KEY_REJECT + ","
                        + DataBaseHelper.KEY_REJECT_DATE + ","
                        + DataBaseHelper.IS_DISPATCH_TYPE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_cfa_dispatch.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_cfa_dispatch.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//cfa_dispatch_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("D"));//sap_id
                        statement.bindString(5, object.getString("E"));//dispatch_type
                        statement.bindString(6, object.getString("F"));//do_sto_no
                        statement.bindString(7, object.getString("G"));//dispatch_date
                        statement.bindString(8, object.getString("H"));//received
                        statement.bindString(9, object.getString("I"));//received_date
                        statement.bindString(10, object.getString("L"));//country_id
                        statement.bindString(11, object.getString("M"));//created_by_user
                        statement.bindString(12, object.getString("N"));//modified_by_user
                        statement.bindString(13, object.getString("O"));//status
                        statement.bindString(14, object.getString("P"));//created_on
                        statement.bindString(15, object.getString("Q"));//modified_on
                        statement.bindString(16, object.getString("R"));//sync_code
                        statement.bindString(17, object.getString("S"));//sync_flag
                        statement.bindString(18, object.getString("T"));//sync_date
                        statement.bindString(19, object.getString("J"));//isRead
                        statement.bindString(20, object.getString("K"));//read_date
                        statement.bindString(21, "1");
                        statement.bindString(22, object.getString("U"));//sync_by_user
                        statement.bindString(23, object.getString("V"));//reject
                        statement.bindString(24, object.getString("W"));//reject_date
                        statement.bindString(25, object.getString("X"));//reject_date
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
                    }

                }

                manageCfaDispatchCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
            } finally {
                database.endTransaction();
            }

        }
        return true;
    }

    private void manageCfaDispatchCopy() {

        database.execSQL("DELETE FROM bf_ishop_cfa_dispatch\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_cfa_dispatch AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_cfa_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_cfa_dispatch (\n" +
                "                                              cfa_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              sap_id,\n" +
                "                                              dispatch_type,\n" +
                "                                              do_sto_no,\n" +
                "                                              dispatch_date,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user,\n" +
                "                                              reject,\n" +
                "                                              rejected_date,\n" +
                "                                              rejected_comment,\n" +
                "                                              rejected_reason,\n" +
                "                                              is_dispatch_type\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              cfa_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              sap_id,\n" +
                "                                              dispatch_type,\n" +
                "                                              do_sto_no,\n" +
                "                                              dispatch_date,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user,\n" +
                "                                              reject,\n" +
                "                                              rejected_date,\n" +
                "                                              rejected_comment,\n" +
                "                                              rejected_reason,\n" +
                "                                              is_dispatch_type\n" +
                "                                            FROM bf_ishop_cfa_dispatch_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_DISPATCH_COPY);
    }


    /**
     * {"cpm_customer_product_stock_id":"A",
     * "customer_id":"B",
     * "product_sku_id":"C",
     * "batch_no":"D",
     * "current_stock_box":"E",
     * "current_stock_kgl":"F",
     * "expire_date":"G"}
     *
     * @param arrayCPMCustomerProductStock
     */

    public void insertCustomerProductStock(JSONArray arrayCPMCustomerProductStock, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_CUSTOMER_PRODUCT_STOCK);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CUSTOMER_PRODUCT_STOCK
                    + " (" + DataBaseHelper.KEY_CUSTOMER_PRODUCT_STOCK_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_STOCK_BOX + ","
                    + DataBaseHelper.KEY_PRODUCT_STOCK_KGL + ","
                    + DataBaseHelper.KEY_BATCH_NO + ","
                    + DataBaseHelper.KEY_EXPIRE_DATE + ") VALUES (?,?,?,?,?,?,?)";

            for (int k = 0; k < arrayCPMCustomerProductStock.length(); k++) {
                JSONObject object = null;
                try {
                    object = arrayCPMCustomerProductStock.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//cpm_customer_product_stock_id
                    statement.bindString(2, object.getString("B"));//customer_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("E"));//current_stock_box
                    statement.bindString(5, object.getString("F"));//current_stock_kgl
                    statement.bindString(6, object.getString("D"));//batch_no
                    statement.bindString(7, object.getString("G"));//expire_date
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertCustomerProductStock";
                }

            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertCustomerProductStock";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertCustomerProductStock";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * {"cpm_customer_product_stock_id":"A",
     * "customer_id":"B",
     * "product_sku_id":"C",
     * "batch_no":"D",
     * "current_stock_box":"E",
     * "current_stock_kgl":"F",
     * "expire_date":"G"}
     *
     * @param arrayCPMCustomerProductStock
     */

    public void InsertDISPATCHBATCHWISESTOCKCALCULATE(JSONArray arrayCPMCustomerProductStock, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISPATCH_BATCHWISE_STOCK_CALCULATE
                    + " (" + DataBaseHelper.KEY_CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_STOCK_BOX + ","
                    + DataBaseHelper.KEY_BATCH_NO + ","
                    + DataBaseHelper.KEY_REMAINING_STOCK_BOX + ","
                    + DataBaseHelper.KEY_NEW_REMAINING_STOCK_BOX + ") VALUES (?,?,?,?,?,?)";

            for (int k = 0; k < arrayCPMCustomerProductStock.length(); k++) {
                JSONObject object = null;
                try {
                    object = arrayCPMCustomerProductStock.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("B"));
                    statement.bindString(2, object.getString("C"));
                    statement.bindString(3, object.getString("E"));
                    statement.bindString(4, object.getString("D"));
                    statement.bindString(5, object.getString("E"));
                    statement.bindString(6, object.getString("E"));
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
                }

            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            e.printStackTrace();
        } catch (NumberFormatException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }
    }


    /**
     * For Column Reference
     * <p>
     * {"distributor_return_request_product_id":"A",
     * "distributor_return_request_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no_out":"E",
     * "qr_code_out":"F",
     * "quantity":"G",
     * "amount":"H",
     * "unit":"I",
     * "qty_kgl":"J",
     * "received":"K",
     * "received_date":"L",
     * "is_valid":"M",
     * "sync_code":"N",
     * "sync_flag":"O",
     * "sync_date":"P",
     * "sync_by_user":"Q"}
     *
     * @param ishop_distributor_return_request_product
     */

    public void InsertDistributorReturnRequestProductNew(JSONArray ishop_distributor_return_request_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);
//        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_REJECT + ","
                    + DataBaseHelper.KEY_REJECT_DATE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_distributor_return_request_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_distributor_return_request_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//distributor_return_request_product_id
                    statement.bindString(2, object.getString("B"));//distributor_return_request_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("M"));//is_valid
                    statement.bindString(12, object.getString("K"));//received
                    statement.bindString(13, object.getString("L"));//received_date
                    statement.bindString(14, object.getString("N"));//sync_code
                    statement.bindString(15, object.getString("O"));//sync_flag
                    statement.bindString(16, object.getString("P"));//sync_date
                    statement.bindString(17, object.getString("Q"));//sync_by_user
                    statement.bindString(18, object.getString("R"));//sync_date
                    statement.bindString(19, object.getString("S"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestProductNew";
                }

            }
//            commnted as discussed by denish bhai
//            database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY+" WHERE reject='1'");
            manageDistributorReturnRequestProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestProductNew";
        } finally {
            database.endTransaction();
//            close();
        }
    }


    /**
     * For Column Reference
     *
     * @param ishop_distributor_dispatch
     */
    public void InsertDistributorDispatchNew(JSONArray ishop_distributor_dispatch, String fileName) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            if (fileName.equalsIgnoreCase("1.txt")) {
                database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH);
            }
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH
                        + " (" + DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_customer_to_name + ","
                        + DataBaseHelper.KEY_customer_to_phone + ","
                        + DataBaseHelper.KEY_new_customer_type + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_distributor_dispatch.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_distributor_dispatch.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//distributor_dispatch_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("F"));//customer_type_country_id
                        statement.bindString(5, object.getString("G"));//is_new_customer
                        statement.bindString(6, object.getString("I"));//dispatch_date
                        statement.bindString(7, object.getString("D"));//customer_to_name
                        statement.bindString(8, object.getString("E"));//customer_to_phone
                        statement.bindString(9, object.getString("H"));//new_customer_type
                        statement.bindString(10, object.getString("L"));//country_id
                        statement.bindString(11, object.getString("M"));//created_by_user
                        statement.bindString(12, object.getString("N"));//modified_by_user
                        statement.bindString(13, object.getString("O"));//status
                        statement.bindString(14, object.getString("P"));//created_on
                        statement.bindString(15, object.getString("Q"));//modified_on
                        statement.bindString(16, object.getString("R"));//sync_code
                        statement.bindString(17, object.getString("S"));//sync_flag
                        statement.bindString(18, object.getString("T"));//sync_date
                        statement.bindString(19, object.getString("J"));//isRead
                        statement.bindString(20, object.getString("K"));//read_date
                        statement.bindString(21, "1");
                        statement.bindString(22, object.getString("U"));//sync_by_user
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorDispatchNew";
                    }

                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorDispatchNew";
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorDispatchNew";
            } finally {
                database.endTransaction();
//                close();
            }
        } else {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_COPY
                        + " (" + DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IS_NEW_CUSTOMER + ","
                        + DataBaseHelper.KEY_DISPATCH_DATE + ","
                        + DataBaseHelper.KEY_customer_to_name + ","
                        + DataBaseHelper.KEY_customer_to_phone + ","
                        + DataBaseHelper.KEY_new_customer_type + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_READ + ","
                        + DataBaseHelper.KEY_READ_DATE + ","
                        + DataBaseHelper.KEY_IS_DISPATCH + ","
                        + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_distributor_dispatch.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_distributor_dispatch.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//distributor_dispatch_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("F"));//customer_type_country_id
                        statement.bindString(5, object.getString("G"));//is_new_customer
                        statement.bindString(6, object.getString("I"));//dispatch_date
                        statement.bindString(7, object.getString("D"));//customer_to_name
                        statement.bindString(8, object.getString("E"));//customer_to_phone
                        statement.bindString(9, object.getString("H"));//new_customer_type
                        statement.bindString(10, object.getString("L"));//country_id
                        statement.bindString(11, object.getString("M"));//created_by_user
                        statement.bindString(12, object.getString("N"));//modified_by_user
                        statement.bindString(13, object.getString("O"));//status
                        statement.bindString(14, object.getString("P"));//created_on
                        statement.bindString(15, object.getString("Q"));//modified_on
                        statement.bindString(16, object.getString("R"));//sync_code
                        statement.bindString(17, object.getString("S"));//sync_flag
                        statement.bindString(18, object.getString("T"));//sync_date
                        statement.bindString(19, object.getString("J"));//isRead
                        statement.bindString(20, object.getString("K"));//read_date
                        statement.bindString(21, "1");
                        statement.bindString(22, object.getString("U"));//sync_by_user
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorDispatchNew";
                    }

                }

                manageDistDispatchCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorDispatchNew";
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorDispatchNew";
            } finally {
                database.endTransaction();
//                close();
            }
        }
    }

    private void manageDistDispatchCopy() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_distributor_dispatch\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_dispatch AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_dispatch (\n" +
                "                                              distributor_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              dispatch_date,\n" +
                "                                              customer_to_name,\n" +
                "                                              customer_to_phone,\n" +
                "                                              new_customer_type,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              distributor_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              is_new_customer,\n" +
                "                                              dispatch_date,\n" +
                "                                              customer_to_name,\n" +
                "                                              customer_to_phone,\n" +
                "                                              new_customer_type,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isRead,\n" +
                "                                              read_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_distributor_dispatch_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH_COPY);
    }


    /**
     * For Column reference
     * <p>
     * {"srip_id":"A",
     * "customer_from_id":"B",
     * "customer_to_id":"C",
     * "fk_PBG_Country_id":"D",
     * "fk_Sku_Country_id":"E",
     * "decQty":"F",
     * "scan_count":"G",
     * "varRemarks":"H",
     * "deleted":"I",
     * "status":"J",
     * "created_by_user":"K",
     * "created_by_name":"L",
     * "modified_by_user":"M",
     * "modified_by_name":"N",
     * "created_on":"O",
     * "modified_on":"P",
     * "sync_code":"Q",
     * "sync_flag":"R",
     * "sync_date":"S",
     * "sync_by_user":"T"}
     *
     * @param jsonArraySalesRep
     * @param fileName
     */

    public void insertSalesRepInitiatedProduct(JSONArray jsonArraySalesRep, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_SALES_REP_INITIATED_PRODUCT);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_SALES_REP_INITIATED_PRODUCT
                    + " (" + DataBaseHelper.SRIP_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                    + DataBaseHelper.FK_PBG_COUNTRY_ID + ","
                    + DataBaseHelper.FK_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.DECQTY + ","
                    + DataBaseHelper.VARREMARKS + ","
                    + DataBaseHelper.KEY_DELETED + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.CREATED_BY_NAME + ","
                    + DataBaseHelper.MODIFIED_BY_NAME + ","
                    + DataBaseHelper.SCAN_COUNT + ","
                    + DataBaseHelper.SYNC_BY_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int k = 0; k < jsonArraySalesRep.length(); k++) {
                JSONObject object = null;
                try {
                    object = jsonArraySalesRep.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//srip_id
                    statement.bindString(2, object.getString("B"));//customer_from_id
                    statement.bindString(3, object.getString("C"));//customer_to_id
                    statement.bindString(4, object.getString("D"));//fk_PBG_Country_id
                    statement.bindString(5, object.getString("E"));//fk_Sku_Country_id
                    statement.bindString(6, object.getString("F"));//decQty
                    statement.bindString(7, object.getString("H"));//varRemarks
                    statement.bindString(8, object.getString("I"));//deleted
                    statement.bindString(9, object.getString("J"));//status
                    statement.bindString(10, object.getString("K"));//created_by_user
                    statement.bindString(11, object.getString("M"));//modified_by_user
                    statement.bindString(12, object.getString("O"));//created_on
                    statement.bindString(13, object.getString("P"));//modified_on
                    statement.bindString(14, object.getString("Q"));//sync_code
                    statement.bindString(15, object.getString("R"));//sync_flag
                    statement.bindString(16, object.getString("S"));//sync_date
                    statement.bindString(17, object.getString("L"));//created_by_name
                    statement.bindString(18, object.getString("N"));//modified_by_name
                    statement.bindString(19, object.getString("G"));//scan_count
                    statement.bindString(20, object.getString("T"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertSalesRepInitiatedProduct";
                }

            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertSalesRepInitiatedProduct";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method insertSalesRepInitiatedProduct";
        } finally {
            database.endTransaction();
//            close();
        }
    }


    /**
     * For Column Reference
     * <p>
     * {"retailer_received_id":"A",
     * "customer_from_id":"B",
     * "customer_to_id":"C",
     * "customer_type_country_id":"D",
     * "received_date":"E",
     * "country_id":"F",
     * "created_by_user":"G",
     * "modified_by_user":"H",
     * "status":"I",
     * "created_on":"J",
     * "modified_on":"K",
     * "sync_code":"L",
     * "sync_flag":"M",
     * "sync_date":"N",
     * "sync_by_user":"O"}
     *
     * @param ishop_retailer_received
     */
    public void InsertRetailerReceivedNew(JSONArray ishop_retailer_received, String fileName) {
        if (!CheckList.OPTIMIZE_MAIN_TABLE) {
//            open();
            if (fileName.equalsIgnoreCase("1.txt")) {
                database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED);
            }
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED +
                        " (" + DataBaseHelper.RETAILER_RECEIVED_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_isDispatch + ","
                        + DataBaseHelper.SYNC_BY_USER
                        + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_retailer_received.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_retailer_received.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//retailer_received_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("D"));//customer_type_country_id
                        statement.bindString(5, object.getString("E"));//received_date
                        statement.bindString(6, object.getString("F"));//country_id
                        statement.bindString(7, object.getString("G"));//created_by_user
                        statement.bindString(8, object.getString("H"));//modified_by_user
                        statement.bindString(9, object.getString("I"));//status
                        statement.bindString(10, object.getString("J"));//created_on
                        statement.bindString(11, object.getString("K"));//modified_on
                        statement.bindString(12, object.getString("L"));//sync_code
                        statement.bindString(13, object.getString("M"));//sync_flag
                        statement.bindString(14, object.getString("N"));//sync_date
                        statement.bindString(15, "1");
                        statement.bindString(16, object.getString("O"));//sync_by_user
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedNew";
                    }
                    Log.e(TAG, "TABLE_BF_ISHOP_RETAILER_RECEIVED Add SUCCESSFULLY");
                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedNew";
            } finally {
                database.endTransaction();
//                close();
            }

        } else {

//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY +
                        " (" + DataBaseHelper.RETAILER_RECEIVED_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                        + DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_RECEIVED_DATE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_CODE + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_isDispatch + ","
                        + DataBaseHelper.SYNC_BY_USER
                        + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < ishop_retailer_received.length(); k++) {
                    JSONObject object = null;
                    try {
                        object = ishop_retailer_received.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));//retailer_received_id
                        statement.bindString(2, object.getString("B"));//customer_from_id
                        statement.bindString(3, object.getString("C"));//customer_to_id
                        statement.bindString(4, object.getString("D"));//customer_type_country_id
                        statement.bindString(5, object.getString("E"));//received_date
                        statement.bindString(6, object.getString("F"));//country_id
                        statement.bindString(7, object.getString("G"));//created_by_user
                        statement.bindString(8, object.getString("H"));//modified_by_user
                        statement.bindString(9, object.getString("I"));//status
                        statement.bindString(10, object.getString("J"));//created_on
                        statement.bindString(11, object.getString("K"));//modified_on
                        statement.bindString(12, object.getString("L"));//sync_code
                        statement.bindString(13, object.getString("M"));//sync_flag
                        statement.bindString(14, object.getString("N"));//sync_date
                        statement.bindString(15, "1");
                        statement.bindString(16, object.getString("O"));//sync_by_user
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                        if (callback != null) {
                            callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                        }
                        SynchronizationService.isSuccess = false;
                        SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedNew";
                    }
                    Log.e(TAG, "TABLE_BF_ISHOP_RETAILER_RECEIVED Add SUCCESSFULLY");
                }

                manageRetailerReceiveCopy();

                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedNew";
            } catch (NumberFormatException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertRetailerReceivedNew";
            } finally {
                database.endTransaction();
//                close();
            }
        }

    }

    private void manageRetailerReceiveCopy() {
        database.execSQL("DELETE FROM bf_ishop_retailer_received\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_retailer_received AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_retailer_received_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_retailer_received (\n" +
                "                                              retailer_received_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT  " +
                "                                              retailer_received_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              customer_type_country_id,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM bf_ishop_retailer_received_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_BF_ISHOP_RETAILER_RECEIVED_COPY);
    }


    /**
     * For Column Reference
     * <p>
     * {"political_geo_id":"A",
     * "geo_level_id":"B",
     * "parent_geo_id":"C",
     * "political_geography_code":"D",
     * "political_geography_name":"E",
     * "country_id":"F",
     * "created_by_user":"G",
     * "modified_by_user":"H",
     * "deleted":"I",
     * "status":"J",
     * "created_on":"K",
     * "modified_on":"L"}
     *
     * @param arrayPoliticalDetails
     * @param fileName
     */

    public void InsertPoliticalDetails(JSONArray arrayPoliticalDetails, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_POLITICAL_DETAILS);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_POLITICAL_DETAILS
                    + " (" + DataBaseHelper.KEY_POLITICAL_GEO_ID + ","
                    + DataBaseHelper.KEY_GEO_LEVEL_ID + ","
                    + DataBaseHelper.KEY_PARENT_GEO_ID + ","
                    + DataBaseHelper.KEY_POLITICAL_GEOGRAPHY_CODE + ","
                    + DataBaseHelper.KEY_POLITICAL_GEOGRAPHY_NAME + ","
//                    + DataBaseHelper.KEY_COUNTRY_ID + ","
//                    + DataBaseHelper.KEY_MODIFIED_ON + ","
//                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
//                    + DataBaseHelper.KEY_MODIFICATION_BY_USER + ","
//                    + DataBaseHelper.KEY_DELETED + ","
//                    + DataBaseHelper.KEY_STATUS + ","
//                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ") VALUES (?,?,?,?,?,?)";

            for (int i = 0; i < arrayPoliticalDetails.length(); i++) {
                try {
                    JSONObject object = arrayPoliticalDetails.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//political_geo_id
                    statement.bindString(2, object.getString("B"));//geo_level_id
                    statement.bindString(3, object.getString("C"));//parent_geo_id
                    statement.bindString(4, object.getString("D"));//political_geography_code
                    statement.bindString(5, object.getString("E"));//political_geography_name
                    statement.bindString(6, object.getString("F"));//country_id
//                    statement.bindString(7, object.getString("G"));
//                    statement.bindString(8, object.getString("H"));
//                    statement.bindString(9, object.getString("I"));
//                    statement.bindString(10, object.getString("J"));
//                    statement.bindString(11, object.getString("K"));
//                    statement.bindString(12, object.getString("L"));
                    statement.execute();
                } catch (JSONException e) {
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPoliticalDetails";
                    e.printStackTrace();
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPoliticalDetails";
            e.printStackTrace();
        } catch (NumberFormatException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPoliticalDetails";
            e.printStackTrace();
        } finally {
            database.endTransaction();
//            close();
        }
    }


    /**
     * {"cpm_customer_product_stock_id":"A",
     * "customer_id":"B",
     * "product_sku_id":"C",
     * "batch_no":"D",
     * "current_stock_box":"E",
     * "current_stock_kgl":"F",
     * "expire_date":"G"}
     *
     * @param arrayCPMCustomerProductStock
     */

    public void insertCustomerProductDamageStock(JSONArray arrayCPMCustomerProductStock, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CUSTOMER_PRODUCT_DAMAGE_STOCK
                    + " (" + DataBaseHelper.KEY_CUSTOMER_PRODUCT_DAMAGE_STOCK_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_STOCK_BOX + ","
                    + DataBaseHelper.KEY_PRODUCT_STOCK_KGL + ","
                    + DataBaseHelper.KEY_BATCH_NO + ","
                    + DataBaseHelper.KEY_EXPIRE_DATE + ") VALUES (?,?,?,?,?,?,?)";

            for (int k = 0; k < arrayCPMCustomerProductStock.length(); k++) {
                JSONObject object = null;
                try {
                    object = arrayCPMCustomerProductStock.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//cpm_customer_damage_product_stock_id
                    statement.bindString(2, object.getString("B"));//customer_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("E"));//current_stock_box
                    statement.bindString(5, object.getString("F"));//current_stock_kgl
                    statement.bindString(6, object.getString("D"));//batch_no
                    statement.bindString(7, object.getString("G"));//expire_date
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                }

            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
//            close();
        }
    }

    /*TODO Chnage By Praveen*/

    public void InsertHelpVideoData(JSONArray videoArray,String loginId,String countryID) {
        {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_HELP_VIDEO_DETAIL);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_HELP_VIDEO_DETAIL
                        + " (" + DataBaseHelper.VIDEO_TYPE_DETAIL_ID + ","
                        + DataBaseHelper.VIDEO_TYPE_ID + ","
                        + DataBaseHelper.VIDEO_MENU_ID + ","
                        + DataBaseHelper.VIDEO_MENU_NAME + ","
                        + DataBaseHelper.ROLE_ID_IN_VIDEO + ","
                        + DataBaseHelper.VIDEO_FILE_NAME + ","
                        + DataBaseHelper.VIDEO_LOCAL_PATH + ","
                        + DataBaseHelper.VIDEO_UPLOAD_TYPE + ","
                        + DataBaseHelper.IS_DOWNLOADED + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ","
                        + DataBaseHelper.KEY_SYNC_FLAG + ","
                        + DataBaseHelper.VIDEO_CUSTOMER_ID + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_SYNC_DATE + ","
                        + DataBaseHelper.KEY_SYNC_USER + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_IMEI_NO + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < videoArray.length(); k++) {
                    JSONObject object = null;
                    try {


                        object = videoArray.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);

                        statement.bindString(1, String.valueOf(dbHelper.getProductIdMaxId(DataBaseHelper.VIDEO_TYPE_DETAIL_ID, DataBaseHelper.TABLE_HELP_VIDEO_DETAIL)));
                        statement.bindString(2, object.getString("A"));  //video_type_id
                        statement.bindString(3, object.getString("B"));  //video_menu_id
                        statement.bindString(4, object.getString("C"));  //video_menu_name
                        statement.bindString(5, object.getString("D"));   //role_id
                        statement.bindString(6, object.getString("E"));  //file_name
                        statement.bindString(7, object.getString("F"));  //video_local_path
                        statement.bindString(8, object.getString("G")); //upload_type
                        statement.bindString(9, object.getString("H"));
                        statement.bindString(10, object.getString("I"));
                        statement.bindString(11, object.getString("J"));
                        statement.bindString(12, loginId);
                        statement.bindString(13, AppUtil.getCurrentDate(AppUtil.DATE_FORMAT));
                        statement.bindString(14, AppUtil.getCurrentDate(AppUtil.DATE_FORMAT));
                        statement.bindString(15, loginId);
                        statement.bindString(16, countryID);
                        statement.bindString(17, object.getString("K"));//Imei No
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }

                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
            } finally {
                database.endTransaction();
//                close();
            }
        }
    }


    public void insertMasterReason(JSONArray videoArray) {
        {
//            open();
            database.execSQL("delete from " + DataBaseHelper.TABLE_MASTER_REASON);
            database.beginTransaction();
            try {
                String sql = "INSERT INTO " + DataBaseHelper.TABLE_MASTER_REASON
                        + " (" + DataBaseHelper.KEY_REASON_ID + ","
                        + DataBaseHelper.KEY_REASON_NAME + ","
                        + DataBaseHelper.KEY_REASON_CODE + ","
                        + DataBaseHelper.KEY_USED_FOR_ID + ","
                        + DataBaseHelper.KEY_USED_FOR_CODE + ","
                        + DataBaseHelper.KEY_COUNTRY_ID + ","
                        + DataBaseHelper.KEY_DELETED + ","
                        + DataBaseHelper.KEY_STATUS + ","
                        + DataBaseHelper.KEY_CREATED_BY_USER + ","
                        + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                        + DataBaseHelper.KEY_CREATE_ON + ","
                        + DataBaseHelper.KEY_MODIFIED_ON + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?)";

                for (int k = 0; k < videoArray.length(); k++) {
                    try {
                        JSONObject object = videoArray.getJSONObject(k);
                        SQLiteStatement statement = database.compileStatement(sql);
                        statement.bindString(1, object.getString("A"));  //reason_id
                        statement.bindString(2, object.getString("B"));  //reason_name
                        statement.bindString(3, object.getString("C"));  //reason_code
                        statement.bindString(4, object.getString("D"));   //used_for_id
                        statement.bindString(5, object.getString("E"));  //used_for_code
                        statement.bindString(6, object.getString("F"));  //country_id
                        statement.bindString(7, object.getString("G")); //deleted
                        statement.bindString(8, object.getString("H"));//status
                        statement.bindString(9, object.getString("I"));//created_by_user
                        statement.bindString(10, object.getString("J"));//modified_by_user
                        statement.bindString(11, object.getString("K"));//created_on
                        statement.bindString(12, object.getString("L"));//modified_on
                        statement.execute();
                    } catch (JSONException e) {
                        e.printStackTrace();
                    }
                }
                database.setTransactionSuccessful();
            } catch (SQLException e) {
                e.printStackTrace();
            } catch (NumberFormatException e) {
                e.printStackTrace();
            } finally {
                database.endTransaction();
//                close();
            }
        }
    }


    /**
     * For Column Reference
     * <p>
     * {"distributor_return_request_product_id":"A",
     * "distributor_return_request_id":"B",
     * "product_sku_id":"C",
     * "sticker_details_id":"D",
     * "btc_no_out":"E",
     * "qr_code_out":"F",
     * "quantity":"G",
     * "amount":"H",
     * "unit":"I",
     * "qty_kgl":"J",
     * "received":"K",
     * "received_date":"L",
     * "is_valid":"M",
     * "sync_code":"N",
     * "sync_flag":"O",
     * "sync_date":"P",
     * "sync_by_user":"Q"}
     *
     * @param ishop_distributor_return_request_product
     */

    public void InsertDistributorReturnRequestProductNewForDist(JSONArray ishop_distributor_return_request_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);
//        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_REJECT + ","
                    + DataBaseHelper.KEY_REJECT_DATE + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_distributor_return_request_product.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_distributor_return_request_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//distributor_return_request_product_id
                    statement.bindString(2, object.getString("B"));//distributor_return_request_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("M"));//is_valid
                    statement.bindString(12, object.getString("K"));//received
                    statement.bindString(13, object.getString("L"));//received_date
                    statement.bindString(14, object.getString("N"));//sync_code
                    statement.bindString(15, object.getString("O"));//sync_flag
                    statement.bindString(16, object.getString("P"));//sync_date
                    statement.bindString(17, object.getString("Q"));//sync_by_user
                    statement.bindString(18, object.getString("R"));//sync_date
                    statement.bindString(19, object.getString("S"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestProductNew";
                }

            }
//            commnted as discussed by denish bhai

            manageDistributorReturnRequestProductForDist();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestProductNew";
        } finally {
            database.endTransaction();
        }
    }


    private void manageDistributorReturnRequestProductForDist() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_distributor_return_request_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_distributor_return_request_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_distributor_return_request_product_copy AS st_copy ON st.sync_code = st_copy.sync_code" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_distributor_return_request_product (\n" +
                "                                              distributor_return_request_product_id,\n" +
                "                                              distributor_return_request_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              reject,\n" +
                "                                              rejected_date,\n" +
                "                                              rejected_comment,\n" +
                "                                              rejected_reason\n" +
                "                                          )\n" +
                "                                          SELECT distributor_return_request_product_id,\n" +
                "                                                 distributor_return_request_id,\n" +
                "                                                 product_sku_id,\n" +
                "                                                 sticker_details_id,\n" +
                "                                                 btc_no_out,\n" +
                "                                                 qr_code_out,\n" +
                "                                                 quantity,\n" +
                "                                                 amount,\n" +
                "                                                 unit,\n" +
                "                                                 qty_kgl,\n" +
                "                                                 is_valid,\n" +
                "                                                 received,\n" +
                "                                                 received_date,\n" +
                "                                                 sync_code,\n" +
                "                                                 sync_flag,\n" +
                "                                                 sync_date,\n" +
                "                                                 sync_by_user,\n" +
                "                                                 reject,\n" +
                "                                                 rejected_date,\n" +
                "                                                 rejected_comment,\n" +
                "                                                 rejected_reason\n" +
                "                                            FROM bf_ishop_distributor_return_request_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT_COPY);
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_PRODUCT + " WHERE reject='1'");
    }

    public boolean InsertDistributorDispatchDelayed(IshopDistributorDispatch object, int isDispatch, int dispatchId) {

        ContentValues contentValues = new ContentValues();

        contentValues.put(DataBaseHelper.KEY_DISTRIBUTOR_DISPATCH_ID, dispatchId);
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_FROM_ID, object.getCustomerFromId());
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TO_ID, object.getCustomerToId());
        contentValues.put(DataBaseHelper.KEY_CUSTOMER_TYPE_COUNTRY_ID, object.getCustomerTypeCountryId());
        contentValues.put(DataBaseHelper.KEY_IS_NEW_CUSTOMER, object.getIsNewCustomer());
        contentValues.put(DataBaseHelper.KEY_DISPATCH_DATE, object.getDispatchDate());
        //  contentValues.put(DataBaseHelper.KEY_RECEIVED, object.getReceived());
        // contentValues.put(DataBaseHelper.KEY_RECEIVED_DATE, object.getReceivedDate());
        contentValues.put(DataBaseHelper.KEY_COUNTRY_ID, object.getCountryId());
        contentValues.put(DataBaseHelper.KEY_CREATED_BY_USER, object.getCreatedByUser());
        contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
        contentValues.put(DataBaseHelper.KEY_STATUS, object.getStatus());
        contentValues.put(DataBaseHelper.KEY_CREATE_ON, object.getCreatedOn());
        contentValues.put(DataBaseHelper.KEY_MODIFIED_ON, object.getModifiedOn());
        contentValues.put(DataBaseHelper.KEY_MODIFIED_BY_USER, object.getModifiedByUser());
        contentValues.put(DataBaseHelper.KEY_SYNC_CODE, object.getSyncCode());
        contentValues.put(DataBaseHelper.KEY_SYNC_FLAG, object.getSyncFlag());
        contentValues.put(DataBaseHelper.KEY_SYNC_DATE, object.getSyncDate());
        contentValues.put(DataBaseHelper.KEY_SYNC_USER, object.getSyncByUser());
        contentValues.put(DataBaseHelper.KEY_READ, object.getRead());
        contentValues.put(DataBaseHelper.KEY_READ_DATE, object.getReadDate());
        contentValues.put(DataBaseHelper.KEY_IS_DISPATCH, isDispatch);
        contentValues.put(DataBaseHelper.KEY_customer_to_name, object.getCustomer_to_name());
        contentValues.put(DataBaseHelper.KEY_customer_to_phone, object.getCustomer_to_phone());
        contentValues.put(DataBaseHelper.KEY_new_customer_type, object.getNew_customer_type());

        long d = database.insert(DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH, null, contentValues);
        if (d > 0) {
            Log.e(TAG, "TABLE DISTRIBUTOR DISPATCH INSERT SUCCESSFULLY");
        } else {
            Log.e(TAG, "TABLE DISTRIBUTOR DISPATCH not INSERT SUCCESSFULLY");
        }

        return true;
    }


    /**
     * Method to Check if the Sticker is Available in Sticker Details Table
     *
     * @return
     */
    private static boolean ifStickerAlreadyAvailable(String stickerDetailId) {
        try {
            String sql = "SELECT * from ishop_sticker_details where sticker_details_id='" + stickerDetailId + "'";
            Cursor cursor = database.rawQuery(sql, null);
            if (cursor != null && cursor.getCount() > 0) {
                if (cursor != null) cursor.close();
                return true;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
    }

    public void InsertExtraStickerDetail(JSONArray arrayCfaDispatchProduct) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_EXTRA_STICKER_COPY);
        database.beginTransaction();
        try {

//            Log.e("KEY_CFA_DISPATCH_PRODUCT_ID", "--------------------------");

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_EXTRA_STICKER_COPY
                    + " (" + DataBaseHelper.EXTRA_STICKER_DETAIL_ID + ","
                    + DataBaseHelper.EXTRA_STICKER_ID + ","
                    + DataBaseHelper.BASE_BTC_NO_OUT + ","
                    + DataBaseHelper.BASE_QR_CODE_OUT + ","
                    + DataBaseHelper.BTC_NO_OUT + ","
                    + DataBaseHelper.QR_CODE_OUT + ","
                    + DataBaseHelper.STICKER_DETAIL_ID + ","
                    + DataBaseHelper.MAPPED_ON + ","
                    + DataBaseHelper.CREATE_BY_USER + ","
                    + DataBaseHelper.CREATE_ON + ","
                    + DataBaseHelper.SYNC_CODE + ","
                    + DataBaseHelper.SYNC_FLAG + ","
                    + DataBaseHelper.SYNC_DATE + ","
                    + DataBaseHelper.SYNC_BY_USER + ","
                    + DataBaseHelper.BASE_BTC_NO_IN + ","
                    + DataBaseHelper.BASE_QR_CODE_IN + ","
                    + DataBaseHelper.KEY_BTC_NO_IN + ","
                    + DataBaseHelper.QR_CODE_IN + ","
                    + DataBaseHelper.KEY_ANDROID_SYNC + " ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            try {
                for (int i = 0; i < arrayCfaDispatchProduct.length(); i++) {
                    JSONObject object = arrayCfaDispatchProduct.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//extra_sticker_detail_id
                    statement.bindString(2, object.getString("B"));//extra_sticker_id
                    statement.bindString(3, object.getString("C"));//base_btc_no_out
                    statement.bindString(4, object.getString("D"));//base_qr_code_out
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//sticker_details_id
                    statement.bindString(8, object.getString("H"));//mapped_on
                    statement.bindString(9, object.getString("I"));//created_by_user
                    statement.bindString(10, object.getString("J"));//created_on
                    statement.bindString(11, object.getString("K"));//sync_code
                    statement.bindString(12, object.getString("L"));//sync_flag
                    statement.bindString(13, object.getString("M"));//sync_date
                    statement.bindString(14, object.getString("N"));//sync_by_user
                    statement.bindString(15, object.getString("P"));//base_btc_no_in
                    statement.bindString(16, object.getString("Q"));//base_qr_code_in
                    statement.bindString(17, object.getString("R"));//btc_no_in
                    statement.bindString(18, object.getString("S"));//qr_code_in
                    statement.bindString(19, object.getString("O"));//android_sync
//                    statement.bindString(16, object.getString("P"));//android_sync
                    statement.execute();
                }
            } catch (JSONException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertExtraStickerDetail";
            }

            manageExtraStickerDetailTable();
            database.setTransactionSuccessful();
        } catch (Exception e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertExtraStickerDetail";
        }
        database.endTransaction();
//        close();
    }


    public void InsertPalletExtraStickerDetail(JSONArray arrayCfaDispatchProduct) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY);
        database.beginTransaction();
        try {

//            Log.e("KEY_CFA_DISPATCH_PRODUCT_ID", "--------------------------");

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY
                    + " (" + DataBaseHelper.EXTRA_PALLET_STICKER_DETAIL_ID + ","
                    + DataBaseHelper.EXTRA_STICKER_ID + ","
                    + DataBaseHelper.BASE_PALLET_SERIAL_NO + ","
                    + DataBaseHelper.BASE_PALLET_QR_CODE + ","
                    + DataBaseHelper.PALLET_SERIAL_NO + ","
                    + DataBaseHelper.PALLET_QR_CODE + ","
                    + DataBaseHelper.KEY_PALLET_DETAIL_ID + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.CREATE_ON + ","
                    + DataBaseHelper.SYNC_CODE + ","
                    + DataBaseHelper.SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.SYNC_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_ANDROID_SYNC + " ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            try {
                for (int i = 0; i < arrayCfaDispatchProduct.length(); i++) {
                    JSONObject object = arrayCfaDispatchProduct.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//extra_pallet_sticker_detail_id
                    statement.bindString(2, object.getString("B"));//extra_sticker_id
                    statement.bindString(3, object.getString("C"));//base_pallet_serial_no
                    statement.bindString(4, object.getString("D"));//base_pallet_qr_code
                    statement.bindString(5, object.getString("E"));//pallet_serial_no
                    statement.bindString(6, object.getString("F"));//pallet_qr_code
                    statement.bindString(7, object.getString("G"));//pallet_details_id
                    statement.bindString(8, object.getString("H"));//created_by_user
                    statement.bindString(9, object.getString("I"));//created_on
                    statement.bindString(10, object.getString("J"));//sync_code
                    statement.bindString(11, object.getString("K"));//sync_flag
                    statement.bindString(12, object.getString("L"));//sync_date
                    statement.bindString(13, object.getString("M"));//sync_by_user
                    statement.bindString(14, object.getString("N"));//modified_by_user
                    statement.bindString(15, object.getString("O"));//modified_on
                    statement.bindString(16, object.getString("P"));//android_sync
                    statement.execute();
                }
            } catch (JSONException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPalletExtraStickerDetail";
            }

            managePalletExtraStickerDetailTable();
            database.setTransactionSuccessful();
        } catch (Exception e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPalletExtraStickerDetail";
        } finally {
            database.endTransaction();
        }

//        close();
    }

    public String getProductName(String barcode) {
        String product_sku_name_name = null;
        String sql = "SELECT psc.product_sku_name FROM ishop_sticker_details AS isd INNER JOIN ishop_sticker AS iss ON iss.sticker_id = isd.sticker_id INNER JOIN product_sku_country AS psc ON psc.product_sku_country_id=iss.product_sku_country_id WHERE isd.btc_no_in= '" + barcode + "' OR isd.btc_no_out='" + barcode + "';";
        //'YAI5EGMZCZ9N';
        Log.e(TAG, "QUERY vailid  sticker : " + sql);
        Cursor cursor = database.rawQuery(sql, null);
        try {

            if (cursor != null && cursor.moveToFirst()) {
                product_sku_name_name = cursor.getString(cursor.getColumnIndex("product_sku_name"));
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (cursor != null) cursor.close();
        }
        return product_sku_name_name;
    }

    public void deleteDeviceTokenTable() {
        database.execSQL("Delete from table_device_token");
    }

    public void insertSalesReturnCurrentLimit(JSONArray arrayCurrentLimit) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT);

        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_SALES_INITIATED_PRODUCT_CURRENT_LIMIT + " (" + DataBaseHelper.CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CURRENT_LIMIT
                    + ") VALUES (?,?,?)";

            for (int i = 0; i < arrayCurrentLimit.length(); i++) {
                try {
                    SQLiteStatement statement = database.compileStatement(sql);
                    JSONObject object = arrayCurrentLimit.getJSONObject(i);
                    statement.bindString(1, object.getString("A"));//customer_id
                    statement.bindString(2, object.getString("B"));//product_sku_id
                    statement.bindString(3, object.getString("C"));//current_limit
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
//            close();
        }
    }

    /**
     * Changed By Chandan For IN and OUT Label ExtraSticker Mapping
     *
     * @param barcode
     * @param fromOut
     * @return
     */
    public boolean isVailidSticker(String barcode, boolean fromOut) {
        boolean isValid;
        String sql;
        if (fromOut) {
//            sql = "SELECT * FROM extra_sticker_detail WHERE btc_no_out='" + barcode + "'";
            sql = "select * from extra_sticker_detail where btc_no_in = '" + barcode + "' OR btc_no_out='" + barcode + "';";
        } else {
            sql = "select * from ishop_sticker_details where btc_no_in = '" + barcode + "' OR btc_no_out='" + barcode + "';";
        }
        Log.e(TAG, "QUERY vailid  sticker : " + sql);
        Cursor cursor = database.rawQuery(sql, null);
        isValid = cursor != null && cursor.getCount() > 0;
        if (cursor != null) cursor.close();
        return isValid;
    }

    /**
     * Deleting 'D' Flag From Extra Stickers
     */
    public void manageExtraStickerDetailTable() {
        // delete new data from original table
        database.execSQL("DELETE FROM extra_sticker_detail\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM extra_sticker_detail AS st\n" +
                "           INNER JOIN\n" +
                "           extra_sticker_detail_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");

        database.execSQL("DELETE FROM " + DataBaseHelper.TABLE_EXTRA_STICKER_COPY + " WHERE android_sync='D'");

        database.execSQL("INSERT INTO extra_sticker_detail (\n" +
                "                                              extra_sticker_detail_id,\n" +
                "                                              extra_sticker_id,\n" +
                "                                              base_btc_no_out,\n" +
                "                                              base_qr_code_out,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              sticker_details_id,\n" +
                "                                              mapped_on,\n" +
                "                                              created_by_user,\n" +
                "                                              created_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              base_btc_no_in,\n" +
                "                                              base_qr_code_in,\n" +
                "                                              btc_no_in,\n" +
                "                                              qr_code_in,\n" +
                "                                              android_sync\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              extra_sticker_detail_id,\n" +
                "                                              extra_sticker_id,\n" +
                "                                              base_btc_no_out,\n" +
                "                                              base_qr_code_out,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              sticker_details_id,\n" +
                "                                              mapped_on,\n" +
                "                                              created_by_user,\n" +
                "                                              created_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              base_btc_no_in,\n" +
                "                                              base_qr_code_in,\n" +
                "                                              btc_no_in,\n" +
                "                                              qr_code_in,\n" +
                "                                              android_sync\n" +
                "                                            FROM extra_sticker_detail_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_EXTRA_STICKER_COPY);
    }


    public void managePalletExtraStickerDetailTable() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_extra_pallet_sticker_details \n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_extra_pallet_sticker_details AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_extra_pallet_sticker_details_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");

        database.execSQL("DELETE FROM " + DataBaseHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY + " WHERE android_sync='D'");

        database.execSQL("INSERT INTO bf_ishop_extra_pallet_sticker_details (\n" +
                "                                              extra_pallet_sticker_detail_id,\n" +
                "                                              extra_sticker_id,\n" +
                "                                              base_pallet_serial_no,\n" +
                "                                              base_pallet_qr_code,\n" +
                "                                              pallet_serial_no,\n" +
                "                                              pallet_qr_code,\n" +
                "                                              pallet_details_id,\n" +
                "                                              created_by_user,\n" +
                "                                              created_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              modified_on,\n" +
                "                                              android_sync\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              extra_pallet_sticker_detail_id,\n" +
                "                                              extra_sticker_id,\n" +
                "                                              base_pallet_serial_no,\n" +
                "                                              base_pallet_qr_code,\n" +
                "                                              pallet_serial_no,\n" +
                "                                              pallet_qr_code,\n" +
                "                                              pallet_details_id,\n" +
                "                                              created_by_user,\n" +
                "                                              created_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              modified_on,\n" +
                "                                              android_sync\n" +
                "                                            FROM bf_ishop_extra_pallet_sticker_details_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_EXTRA_PALLET_STICKER_DETAIL_COPY);
    }

    /**
     * Insert TransactionLog Error
     *
     * @param pagename
     * @param method_name
     * @param error_msg
     * @param stacktrace
     * @param error_code
     */
    public void insertTransactionErrorLog(Context context, String pagename,
                                          String method_name,
                                          String error_msg,
                                          String stacktrace,
                                          String error_code,String userID) {
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_TRANSACTION_ERROR_LOG +
                    " (" + DataBaseHelper.KEY_PAGE_NAME + ","
                    + DataBaseHelper.KEY_METHOD_NAME + ","
                    + DataBaseHelper.KEY_USER_ID + ","
                    + DataBaseHelper.KEY_ERROR_MSG + ","
                    + DataBaseHelper.KEY_STACKTRACE + ","
                    + DataBaseHelper.KEY_MODULE_NAME + ","
                    + DataBaseHelper.KEY_SOURCE_SYSTEM + ","
                    + DataBaseHelper.KEY_ERROR_FORM + ","
                    + DataBaseHelper.KEY_EXTRA1 + ","
                    + DataBaseHelper.KEY_EXTRA2 + ","
                    + DataBaseHelper.KEY_ERROR_CODE + ","
                    + DataBaseHelper.KEY_ERROR_DATE + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_SYNC_PROCESS_ID
                    + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            try {
                SQLiteStatement statement = database.compileStatement(sql);
                statement.bindString(1, pagename);
                statement.bindString(2, method_name);
                statement.bindString(3, userID);
                statement.bindString(4, error_msg);
                statement.bindString(5, stacktrace);
                statement.bindString(6, "CPM Android");
                statement.bindString(7, "");
                statement.bindString(8, "");
                statement.bindString(9, "");
                statement.bindString(10, "");
                statement.bindString(11, error_code);
                statement.bindString(12, AppUtil.getCurrentDate(AppUtil.DATE_FORMAT));
                statement.bindString(13, AppUtil.getSyncCode(userID));
                statement.bindString(14, "Y");
                statement.bindString(15, AppUtil.getCurrentDate(AppUtil.DATE_FORMAT));
                statement.bindString(16, userID);
                statement.bindString(17, "");
                statement.execute();
                Log.e("TAG", "TABLE_TRANSACTION Added SUCCESSFULLY");
            } catch (Exception e) {
                e.printStackTrace();
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }
    }

//    public String getLoginUserId() {
//        String loginId = "";
//        try {
//            String sql = "Select fk_personGlcode from login";
//            Log.e("getLoginId", "" + sql);
//            Cursor cursor = database.rawQuery(sql, null);
//            try {
//                if (cursor != null && cursor.getCount() > 0) {
//                    while (cursor.moveToNext()) {
//                        loginId = cursor.getString(cursor.getColumnIndex("fk_personGlcode"));
//                    }
//                }
//            } catch (Exception e) {
//                e.printStackTrace();
//            } finally {
//                if (cursor != null) cursor.close();
//            }
//
//        } catch (Exception e) {
//            e.printStackTrace();
//        }
//        return loginId;
//    }

    public void doInsertions(Integer numInsertions, Map<Integer, SQLiteStatement> statementCache) {
        if (numInsertions > 999) {
            doInsertions(numInsertions - 999, statementCache);
        }

        SQLiteStatement stmt;
        if (statementCache.containsKey(numInsertions)) {
            stmt = statementCache.get(numInsertions);
        } else {
            StringBuilder valuesBuilder = new StringBuilder();
            for (int i = 0; i < numInsertions; i++) {
                if (i != 0) {
                    valuesBuilder.append(", ");
                }
                valuesBuilder.append("(?)");
            }
            stmt = database.compileStatement("INSERT INTO inserts_1 (val) VALUES " + valuesBuilder.toString());
            statementCache.put(numInsertions, stmt);
        }

        for (int i = 0; i < numInsertions; i++) {
            stmt.bindLong(i + 1, 1);
        }
        stmt.executeInsert();
        stmt.clearBindings();
    }

    public String getScanScreenConfig() {
        String intScanScreen = "";
        try {
            String sql = "Select intScanScreen from user_configuration_mst";
            Log.e("intScanScreen", "" + sql);
            Cursor cursor = database.rawQuery(sql, null);
            try {
                if (cursor != null && cursor.getCount() > 0) {
                    while (cursor.moveToNext()) {
                        intScanScreen = cursor.getString(cursor.getColumnIndex("intScanScreen"));
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                if (cursor != null) cursor.close();
            }
        } catch (Exception e) {

            e.printStackTrace();
        }
        return intScanScreen;
    }

    /**
     * Insert Pallet Details
     *
     * @param arrayPalletDetails
     */
    public void insertPalletDetails(JSONArray arrayPalletDetails, String loginId,String customer_level,String roleCode) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS_COPY);

        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS_COPY
                    + " (" + Database_Column.KEY_PALLET_DETAIL_ID + ","
                    + Database_Column.KEY_STICKER_ID + ","
                    + Database_Column.KEY_PALLET_SERIAL_NO + ","
                    + Database_Column.KEY_CUSTOMER_TYPE_COUNTRY_ID + ","
                    + Database_Column.KEY_CUSTOMER_ID + ","
                    + Database_Column.KEY_IS_PARTIAL_DISPATCH + ","
                    + Database_Column.KEY_PARTIAL_DISPATCH_CUSTOMER_ID + ","
                    + Database_Column.KEY_PARTIAL_DISPATCH_DATE + ","
                    + Database_Column.KEY_CREATED_BY_USER + ","
                    + Database_Column.KEY_CREATED_ON + ","
                    + Database_Column.KEY_SYNC_CODE + ","
                    + Database_Column.KEY_SYNC_FLAG + ","
                    + Database_Column.KEY_SYNC_DATE + ","
                    + Database_Column.KEY_SYNC_BY_USER + ","
                    + Database_Column.KEY_ANDROID_SYNC + ","
                    + Database_Column.KEY_DELETED + ","
                    + Database_Column.KEY_IS_PALLET_SCAN
                    + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int i = 0; i < arrayPalletDetails.length(); i++) {
                try {
                    int j = 1;
                    SQLiteStatement statement = database.compileStatement(sql);
                    JSONObject object = arrayPalletDetails.getJSONObject(i);
                    statement.bindString(j++, object.getString("A"));//pallet_details_id
                    statement.bindString(j++, object.getString("B"));//sticker_id
                    statement.bindString(j++, object.getString("C"));//pallet_serial_no
                    statement.bindString(j++, object.getString("D"));//customer_type_country_id
                    statement.bindString(j++, object.getString("E"));//customer_id
                    statement.bindString(j++, object.getString("F"));//is_partial_dispatch
                    statement.bindString(j++, object.getString("G"));//partial_dispatch_customer_id
                    statement.bindString(j++, object.getString("H"));//partial_dispatch_date
                    statement.bindString(j++, object.getString("I"));//created_by_user
                    statement.bindString(j++, object.getString("J"));//created_on
                    statement.bindString(j++, object.getString("K"));//sync_code
                    statement.bindString(j++, object.getString("L"));//sync_flag
                    statement.bindString(j++, object.getString("M"));//sync_date
                    statement.bindString(j++, object.getString("N"));//sync_by_user
                    statement.bindString(j++, object.getString("O"));//android_sync
                    statement.bindString(j++, object.getString("P"));//deleted
                    statement.bindString(j++, object.getString("Q"));//is_pallet_scan
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                }
            }

        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertPalletDetails";
            Log.e("Check log", "" + e.getMessage());
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertPalletDetails";
            Log.e("Check log", "" + e.getMessage());
        }

        try {
            database.execSQL("DELETE FROM bf_ishop_pallet_details\n" +
                    "      WHERE pallet_details_id IN (\n" +
                    "    SELECT st.pallet_details_id\n" +
                    "      FROM bf_ishop_pallet_details AS st\n" +
                    "           INNER JOIN\n" +
                    "           bf_ishop_pallet_details_copy AS st_copy ON st.pallet_details_id = st_copy.pallet_details_id\n" +
                    ");");

//            String customer_level = Content.getPreferenceValue(context, Const.CUSTOMER_LEVEL);
            if (customer_level.equalsIgnoreCase("L3") && !roleCode.equalsIgnoreCase("FO")) {
                String sql = "DELETE FROM " + DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS_COPY + " WHERE customer_id <> '" + loginId + "'";
                LogHelper.printLog("TAG_PALLET_DELETE", "SQL DELETE::: " + sql);
                database.execSQL(sql);
            }
//            database.execSQL("DELETE FROM " + Database_Table.TABLE_ISHOP_PALLET_DETAILS_COPY + " WHERE android_sync='D'");

            database.execSQL("INSERT INTO " + DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS + "(" + getColumnNames() + ")  SELECT " + getColumnNames() + " FROM " + DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS_COPY);
            database.execSQL("delete from " + DataBaseHelper.TABLE_ISHOP_PALLET_DETAILS_COPY);

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertPalletDetails";
            Log.e("Check log", "" + e.getMessage());
        } finally {
            database.endTransaction();
//            close();
        }

    }


    /**
     * Insert Scanned Barcode Pallet Details
     *
     * @param listBarcodesScanned
     */
    public void insertScannedBarcodePallet(ArrayList<BarcodeModel> listBarcodesScanned) {
        database.beginTransaction();
        try {

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_SCANNEDSTICKERS
                    + " (" + DataBaseHelper.KEY_PRIMARY_SERIALNO + ","
                    + DataBaseHelper.KEY_BARCODENO + ","
                    + DataBaseHelper.KEY_CUSTOMERLEVEL + ","
                    + DataBaseHelper.KEY_LOGGEDINID + ","
                    + DataBaseHelper.KEY_ISVALID + ","
                    + DataBaseHelper.KEY_USERID + ","
                    + DataBaseHelper.KEY_SUBCODE + ","
                    + DataBaseHelper.KEY_SCAN_TYPE + ","
                    + Database_Column.KEY_PALLET_DETAIL_ID + ","
                    + Database_Column.KEY_SHOW_IN_LIST + ") VALUES (?,?,?,?,?,?,?,?,?,?)";

            for (int j = 0; j < listBarcodesScanned.size(); j++) {
                LogHelper.printLog("SCAN_INSERT", "INSERTING DATA");
                BarcodeModel barcodeModel = listBarcodesScanned.get(j);
                int i = 0;
                SQLiteStatement statement = database.compileStatement(sql);
                statement.bindLong(++i, barcodeModel.getSrno());
                statement.bindString(++i, barcodeModel.getBarcodeNo());
                statement.bindString(++i, barcodeModel.getCustomerLevel());
                statement.bindString(++i, barcodeModel.getLoggedInId());
                statement.bindLong(++i, 1);
                statement.bindString(++i, barcodeModel.getUserID());
                statement.bindString(++i, barcodeModel.getSubCode());
                statement.bindString(++i, AppUtil.getIsFrom(context));
                statement.bindLong(++i, barcodeModel.getPallet_detail_id());
                statement.bindLong(++i, 0);//Show in list 0 for not showing it in List of Scanned Details
                statement.execute();

            }

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }
    }

    public boolean isVailidStickerFromInOut(String barcode) {
        boolean isValid;
        String sql;

        sql = "select * from ishop_sticker_details where btc_no_in = '" + barcode + "' OR btc_no_out='" + barcode + "';";

        Log.e(TAG, "QUERY vailid  sticker : " + sql);
        Cursor cursor = database.rawQuery(sql, null);
        isValid = cursor != null && cursor.getCount() > 0;
        if (cursor != null) cursor.close();
        if (isValid) {
            if (isDispatchCheck(barcode)) {
                return false;
            }
        }
        return isValid;
    }

    public boolean isDispatchCheck(String barcode) {
        boolean isValid;
        String sql;

        sql = "SELECT *\n" +
                "  FROM bf_ishop_cfa_dispatch_product bicdp\n" +
                "       INNER JOIN\n" +
                "       bf_ishop_cfa_dispatch bicd ON bicd.cfa_dispatch_id = bicdp.cfa_dispatch_id\n" +
                " WHERE bicdp.is_valid = '1' AND \n" +
                "       bicd.isDispatch='1' AND bicdp.btc_no_out='" + barcode + "' ;";

        Log.e(TAG, "QUERY vailid  sticker : " + sql);
        Cursor cursor = database.rawQuery(sql, null);
        isValid = cursor != null && cursor.getCount() > 0;
        if (cursor != null) cursor.close();
        return isValid;
    }

    public boolean isPalletEnabled() {
        boolean isValid = false;
        String is_pallet_enabled = null;
        String sql;

        try {
            sql = "Select chr_pallet_enable from user_configuration_mst";
            Log.e("intScanScreen", "" + sql);
            Cursor cursor = database.rawQuery(sql, null);
            try {
                if (cursor != null && cursor.getCount() > 0) {
                    while (cursor.moveToNext()) {
                        is_pallet_enabled = cursor.getString(cursor.getColumnIndex("chr_pallet_enable"));
                    }
                    if (is_pallet_enabled.equalsIgnoreCase("Y")) {
                        return true;
                    }
                }
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                if (cursor != null) cursor.close();
            }
        } catch (Exception e) {

            e.printStackTrace();
        }


        return isValid;
    }


    public boolean isPalletValid(boolean isFromPallet) {
        boolean isValid = true;
        String is_pallet_valid = null;
        String sql;

        try {
            if (isFromPallet) {
                sql = "Select isValid from table_scannedsticker where scan_type = 'PM' ";
                Log.e("PalletintScanScreen", "" + sql);
            } else {
                sql = "Select isValid from table_scannedsticker where scan_type = 'IO' ";

            }


            Cursor cursor = database.rawQuery(sql, null);
            try {
                if (cursor != null && cursor.getCount() > 0) {

                    while (cursor.moveToNext()) {
                        is_pallet_valid = cursor.getString(cursor.getColumnIndex("isValid"));

                        if (is_pallet_valid.equalsIgnoreCase("0")) {
                            return false;
                        }
                    }

                } else {

                }
            } catch (Exception e) {
                e.printStackTrace();
            } finally {
                if (cursor != null) cursor.close();
            }
        } catch (Exception e) {

            e.printStackTrace();
        }


        return isValid;
    }

    /**
     * Get Columns
     *
     * @return
     */
    private String getColumnNames() {
        return "pallet_details_id,sticker_id,pallet_serial_no,customer_type_country_id,customer_id,deleted,is_partial_dispatch,partial_dispatch_customer_id,partial_dispatch_date,created_by_user,created_on,sync_code,sync_flag,sync_date,sync_by_user,android_sync,is_pallet_scan";
    }

    /*Code by jay*/
    public boolean insertScmData(JSONArray jsonScmData) {
        Log.e("Data--", jsonScmData.toString());

        database.beginTransaction();
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISPATCH_WAREHOUSE_COPY);

        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISPATCH_WAREHOUSE_COPY
                    + " (" + DataBaseHelper.SCM_CPM_ID + ","
                    + DataBaseHelper.DO_STO_NO + ","
                    + DataBaseHelper.FROM_USER_ID + ","
                    + DataBaseHelper.TO_USER_ID + ","
                    + DataBaseHelper.TRUCK_NO + ","
                    + DataBaseHelper.SHIPMENT_STATUS + ","
                    + DataBaseHelper.ARTICLE_ID + ","
                    + DataBaseHelper.BATCH_NO + ","
                    + DataBaseHelper.DEC_QTY + ","
                    + DataBaseHelper.DELETED + ","
                    + DataBaseHelper.CREATED_BY_USER + ","
                    + DataBaseHelper.CREATED_ON + ","
                    + DataBaseHelper.MODIFIED_ON + ","
                    + DataBaseHelper.DEC_QTY_KGL + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int i = 0; i < jsonScmData.length(); i++) {
                int j = 1;
                JSONObject obj = jsonScmData.getJSONObject(i);
                SQLiteStatement statement = database.compileStatement(sql);
                statement.bindString(j++, obj.optString("A"));//scm_cpm_id
                statement.bindString(j++, obj.optString("B"));//do_sto_no
                statement.bindString(j++, obj.optString("C"));//from_user_id
                statement.bindString(j++, obj.optString("D"));//to_user_id
                statement.bindString(j++, obj.optString("E"));//truck_no
                statement.bindString(j++, obj.optString("F"));//shipment_status
                statement.bindString(j++, obj.optString("G"));//article_id
                statement.bindString(j++, obj.optString("H"));//batch_no
                statement.bindString(j++, obj.optString("I"));//dec_qty
                statement.bindString(j++, obj.optString("J"));//deleted
                statement.bindString(j++, obj.optString("K"));//created_by_user
                statement.bindString(j++, obj.optString("L"));//created_on
                statement.bindString(j++, obj.optString("M"));//modified_on
                statement.bindString(j++, obj.optString("N"));//modified_on
                statement.execute();
                Log.e("insert", "TABLE_DISPATCH_WAREHOUSE_COPY");
            }
            // delete data
            database.execSQL("DELETE FROM bf_scm_cpm_integration_data\n" +
                    "      WHERE scm_cpm_id IN (\n" +
                    "    SELECT st.scm_cpm_id\n" +
                    "      FROM bf_scm_cpm_integration_data AS st\n" +
                    "           INNER JOIN\n" +
                    "           bf_scm_cpm_integration_data_copy AS st_copy ON st.scm_cpm_id = st_copy.scm_cpm_id\n" +
                    ");");


            database.execSQL("Insert into " + DataBaseHelper.TABLE_DISPATCH_WAREHOUSE + "(scm_cpm_id,\n" +
                    "       do_sto_no,\n" +
                    "       from_user_id,\n" +
                    "       to_user_id,\n" +
                    "       truck_no,\n" +
                    "       shipment_status,\n" +
                    "       article_id,\n" +
                    "       batch_no,\n" +
                    "       dec_qty,\n" +
                    "       deleted,\n" +
                    "       created_by_user,\n" +
                    "       created_on,\n" +
                    "       modified_on,\n" +
                    "dec_qty_kgl)" + "SELECT scm_cpm_id,\n" +
                    "       do_sto_no,\n" +
                    "       from_user_id,\n" +
                    "       to_user_id,\n" +
                    "       truck_no,\n" +
                    "       shipment_status,\n" +
                    "       article_id,\n" +
                    "       batch_no,\n" +
                    "       dec_qty,\n" +
                    "       deleted,\n" +
                    "       created_by_user,\n" +
                    "       created_on,\n" +
                    "       modified_on,dec_qty_kgl from " + DataBaseHelper.TABLE_DISPATCH_WAREHOUSE_COPY);
            database.execSQL("delete from " + DataBaseHelper.TABLE_DISPATCH_WAREHOUSE_COPY);

            database.setTransactionSuccessful();


        } catch (Throwable e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method insertScmData";
            Log.e("Check log", "" + e.getMessage());
        } finally {
            database.endTransaction();
        }

        return true;
    }


    /**
     * Optimized Column
     * For Size
     * <p>
     * <p>
     * [{"sticker_id":"A",
     * "ref_Id":"B",
     * "customer_id":"C",
     * "country_id":"D",
     * "PBG_Country_Id":"E",
     * "Product_SKU_Country_Id":"F",
     * "batch_no":"G",
     * "expire_date":"H",
     * "quantity":"I",
     * "status":"J",
     * "sync_code":"K",
     * "sync_flag":"L",
     * "sync_date":"M",
     * "sync_by_user":"N"}]
     *
     * @param ishop_sticker
     */
    public void InsertIshopStickerNew(JSONArray ishop_sticker) {

        database.execSQL("delete from " + DataBaseHelper.TABLE_STICKER_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_STICKER_COPY
                    + " (" + DataBaseHelper.KEY_STICKER_ID + ","
                    + DataBaseHelper.KEY_REF_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_ID + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_PBG_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_BATCH_NO + ","
                    + DataBaseHelper.KEY_EXPIRE_DATE + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_BATCH_ID + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int i = 0; i < ishop_sticker.length(); i++) {
                try {
                    int j = 1;
                    JSONObject object = ishop_sticker.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, object.getString("A"));//sticker_id
                    statement.bindString(j++, object.getString("B"));//ref_Id
                    statement.bindString(j++, object.getString("C"));//customer_id
                    statement.bindString(j++, object.getString("D"));//country_id
                    statement.bindString(j++, object.getString("E"));//PBG_Country_Id
                    statement.bindString(j++, object.getString("F"));//Product_SKU_Country_Id
                    statement.bindString(j++, object.getString("G"));//batch_no
                    statement.bindString(j++, object.getString("H"));//expire_date
                    statement.bindString(j++, object.getString("I"));//quantity
                    statement.bindString(j++, object.getString("J"));//status
                    statement.bindString(j++, object.getString("K"));//sync_code
                    statement.bindString(j++, object.getString("L"));//sync_flag
                    statement.bindString(j++, object.getString("M"));//sync_date
                    statement.bindString(j++, object.getString("N"));//sync_by_user
                    statement.bindLong(j++, object.optInt("O"));//batch_id
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    SynchronizationService.isSuccess = false;
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertStickerNew";
                }
            }
            manageIshopSticker();

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertTollerDispatchProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + "In Method InsertTollerDispatchProductNew";
        } finally {
            database.endTransaction();
        }
    }

    private void manageIshopSticker() {
        // delete new data from original table
        database.execSQL("DELETE FROM ishop_sticker\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM ishop_sticker AS st\n" +
                "           INNER JOIN\n" +
                "           ishop_sticker_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO ishop_sticker (\n" +
                "                                              sticker_id,\n" +
                "                                              ref_Id,\n" +
                "                                              system_code,\n" +
                "                                              toller_code,\n" +
                "                                              customer_id,\n" +
                "                                              country_id,\n" +
                "                                              production_date,\n" +
                "                                              PBG_Country_Id,\n" +
                "                                              product_sku_country_id,\n" +
                "                                              batch_no,\n" +
                "                                              batch_id,\n" +
                "                                              mfg_date,\n" +
                "                                              expire_date,\n" +
                "                                              quantity,\n" +
                "                                              buffer,\n" +
                "                                              status,\n" +
                "                                              draft,\n" +
                "                                              draft_date,\n" +
                "                                              draft_reason,\n" +
                "                                              deleted,\n" +
                "                                              created_by_user,\n" +
                "                                              created_on,\n" +
                "                                              modified_by_user,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                          )\n" +
                "                                          SELECT sticker_id,\n" +
                "                                              ref_Id,\n" +
                "                                              system_code,\n" +
                "                                              toller_code,\n" +
                "                                              customer_id,\n" +
                "                                              country_id,\n" +
                "                                              production_date,\n" +
                "                                              PBG_Country_Id,\n" +
                "                                              product_sku_country_id,\n" +
                "                                              batch_no,\n" +
                "                                              batch_id,\n" +
                "                                              mfg_date,\n" +
                "                                              expire_date,\n" +
                "                                              quantity,\n" +
                "                                              buffer,\n" +
                "                                              status,\n" +
                "                                              draft,\n" +
                "                                              draft_date,\n" +
                "                                              draft_reason,\n" +
                "                                              deleted,\n" +
                "                                              created_by_user,\n" +
                "                                              created_on,\n" +
                "                                              modified_by_user,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user\n" +
                "                                            FROM ishop_sticker_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_STICKER_COPY);
    }

    /**
     * Please Check the Following Reference
     * <p>
     * [{"id":"A","email":"B","user_code":"C","bussiness_code":"D",
     * "display_name":"E","parent_user_id":"F","customer_type_country_id":"G",
     * "customer_type_country_code":"H","customer_type_country_name":"I",
     * "customer_type_regional_id":"J","customer_type_regional_name":"K",
     * "customer_type_regional_code":"L","customer_regional_level":"M",
     * "political_geo_id":"N","political_geography_countrylevel_id":"O",
     * "political_regional_level":"P","sap_id":"Q"}]
     *
     * @param jsonArrayEmployeeDetails
     */
    public void insertEmployeeDetails(JSONArray jsonArrayEmployeeDetails, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_EMPLOYEE_DETAILS);
        }
        database.beginTransaction();
        try {

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_EMPLOYEE_DETAILS
                    + " (" + DataBaseHelper.KEY_ID + ","
                    + DataBaseHelper.KEY_EMAIL + ","
                    + DataBaseHelper.KEY_USER_CODE + ","
                    + DataBaseHelper.KEY_BUSSINESS_CODE + ","
                    + DataBaseHelper.KEY_DISPLAY_NAME + ","
                    + DataBaseHelper.KEY_PRIMARY_MOBILE_NO + ","
                    + DataBaseHelper.KEY_POLITICAL_GEO_ID + ","
                    + DataBaseHelper.KEY_political_geography_countrylevel_id + ","
                    + DataBaseHelper.KEY_political_regional_level + ","
                    + DataBaseHelper.KEY_EMPLOYEE_TYPE_REGIONAL_LEVEL + " ) VALUES (?,?,?,?,?,?,?,?,?,?)";


            try {
                for (int i = 0; i < jsonArrayEmployeeDetails.length(); i++) {
                    JSONObject object = jsonArrayEmployeeDetails.getJSONObject(i);
                    int j = 1;
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(j++, object.getString("A"));//id
                    statement.bindString(j++, object.getString("B"));//email
                    statement.bindString(j++, object.getString("C"));//user_code
                    statement.bindString(j++, object.getString("D"));//bussiness_code
                    statement.bindString(j++, object.getString("E"));//display_name
                    statement.bindString(j++, object.getString("F"));//primary_mobile_no
                    statement.bindString(j++, object.getString("G"));//political_geo_id
                    statement.bindString(j++, object.getString("H"));//political_geography_countrylevel_id
                    statement.bindString(j++, object.getString("I"));//political_regional_level
                    statement.bindString(j++, object.getString("J"));//employee_regional_level
                    statement.execute();
                }
                Log.e("CUSTOMER_DETAILS", "INSERT COMPLETE");
            } catch (JSONException e) {
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
            }
            database.setTransactionSuccessful();
        } catch (Exception e) {
            e.printStackTrace();
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
        }
        database.endTransaction();

    }


    /**
     * For Column Reference
     * <p>
     * {"political_geo_id":"A",
     * "geo_level_id":"B",
     * "parent_geo_id":"C",
     * "political_geography_code":"D",
     * "political_geography_name":"E",
     * "country_id":"F",
     * "created_by_user":"G",
     * "modified_by_user":"H",
     * "deleted":"I",
     * "status":"J",
     * "created_on":"K",
     * "modified_on":"L"}
     *
     * @param arrayPoliticalDetailsEmp
     * @param fileName
     */

    public void InsertPoliticalDetailsEmp(JSONArray arrayPoliticalDetailsEmp, String fileName) {
//        open();
        if (fileName.equalsIgnoreCase("1.txt")) {
            database.execSQL("delete from " + DataBaseHelper.TABLE_POLITICAL_DETAILS_EMP);
        }
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_POLITICAL_DETAILS_EMP
                    + " (" + DataBaseHelper.KEY_POLITICAL_GEO_ID + ","
                    + DataBaseHelper.KEY_GEO_LEVEL_ID + ","
                    + DataBaseHelper.KEY_PARENT_GEO_ID + ","
                    + DataBaseHelper.KEY_POLITICAL_GEOGRAPHY_CODE + ","
                    + DataBaseHelper.KEY_POLITICAL_GEOGRAPHY_NAME + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ") VALUES (?,?,?,?,?,?)";

            for (int i = 0; i < arrayPoliticalDetailsEmp.length(); i++) {
                try {
                    JSONObject object = arrayPoliticalDetailsEmp.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//political_geo_id
                    statement.bindString(2, object.getString("B"));//geo_level_id
                    statement.bindString(3, object.getString("C"));//parent_geo_id
                    statement.bindString(4, object.getString("D"));//political_geography_code
                    statement.bindString(5, object.getString("E"));//political_geography_name
                    statement.bindString(6, object.getString("F"));//country_id
                    statement.execute();
                } catch (JSONException e) {
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPoliticalDetails";
                    e.printStackTrace();
                }
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPoliticalDetails";
            e.printStackTrace();
        } catch (NumberFormatException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertPoliticalDetails";
            e.printStackTrace();
        } finally {
            database.endTransaction();
        }
    }

    public void InsertSampleFocDispatchProduct(JSONArray arrayCfaDispatchProduct) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY);
        database.beginTransaction();
        try {

            String sql = "INSERT INTO " + DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY
                    + " (" + DataBaseHelper.COL_SAMPLE_DISPATCH_PRODUCT_ID + ","
                    + DataBaseHelper.COL_SAMPLE_DISPATCH_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QR_CODE_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + "," + DataBaseHelper.DISPATCH_SCAN_TYPE + " ) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            try {
                int totalArraySize = arrayCfaDispatchProduct.length();
                for (int i = 0; i < totalArraySize; i++) {
                    JSONObject object = arrayCfaDispatchProduct.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//sample_dispatch_product_id
                    statement.bindString(2, object.getString("B"));//sample_dispatch_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("F"));//qr_code_out
                    statement.bindString(7, object.getString("G"));//quantity
                    statement.bindString(8, object.getString("H"));//amount
                    statement.bindString(9, object.getString("I"));//unit
                    statement.bindString(10, object.getString("J"));//qty_kgl
                    statement.bindString(11, object.getString("K"));//is_valid
                    statement.bindString(12, object.getString("N"));//sync_code
                    statement.bindString(13, object.getString("O"));//sync_flag
                    statement.bindString(14, object.getString("P"));//sync_date
                    statement.bindString(15, object.getString("Q"));//sync_by_user
                    statement.bindString(16, object.getString("L"));//received
                    statement.bindString(17, object.getString("M"));//received_date
                    statement.bindString(18, object.getString("R"));//dispatch_scan_type
                    statement.execute();

                    Log.e("KEY_SAMPLE_PRODUCT", "KEY_SAMPLE_DISPATCH_PRODUCT_ID");
                }
            } catch (JSONException e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSampleFocDispatchProduct";
            }
            manageProductTableSampleFoc();

            database.setTransactionSuccessful();
        } catch (Exception e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSampleFocDispatchProduct";
        } finally {
            database.endTransaction();
        }
    }


    public void manageProductTableSampleFoc() {
        // delete new data from original table
        database.execSQL("DELETE FROM bf_ishop_sample_dispatch_product\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_sample_dispatch_product AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_sample_dispatch_product_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_sample_dispatch_product (\n" +
                "                                              sample_dispatch_product_id,\n" +
                "                                              sample_dispatch_id,\n" +
                "                                              product_sku_id,\n" +
                "                                              sticker_details_id,\n" +
                "                                              btc_no_out,\n" +
                "                                              qr_code_out,\n" +
                "                                              quantity,\n" +
                "                                              amount,\n" +
                "                                              unit,\n" +
                "                                              qty_kgl,\n" +
                "                                              is_valid,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              sync_by_user,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              dispatch_scan_type\n" +
                "                                          )\n" +
                "                                          SELECT sample_dispatch_product_id,\n" +
                "                                                 sample_dispatch_id,\n" +
                "                                                 product_sku_id,\n" +
                "                                                 sticker_details_id,\n" +
                "                                                 btc_no_out,\n" +
                "                                                 qr_code_out,\n" +
                "                                                 quantity,\n" +
                "                                                 amount,\n" +
                "                                                 unit,\n" +
                "                                                 qty_kgl,\n" +
                "                                                 is_valid,\n" +
                "                                                 sync_code,\n" +
                "                                                 sync_flag,\n" +
                "                                                 sync_date,\n" +
                "                                                 sync_by_user,\n" +
                "                                                 received,\n" +
                "                                                 received_date,\n" +
                "                                                 dispatch_scan_type\n" +
                "                                            FROM bf_ishop_sample_dispatch_product_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_PRODUCT_COPY);
    }


    public boolean InsertSampleFocDispatchMain(JSONArray ishop_cfa_dispatch, String fileName) {
        LogHelper.printLog("TAG_DATA_CFA", "DAT::: " + ishop_cfa_dispatch);
        database.execSQL("delete from " + DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_COPY
                    + " (" + DataBaseHelper.COL_SAMPLE_DISPATCH_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                    + DataBaseHelper.KEY_SAP_ID + ","
                    + DataBaseHelper.KEY_DISPATCH_TYPE + ","
                    + DataBaseHelper.KEY_DOC_NO + ","
                    + DataBaseHelper.KEY_DISPATCH_DATE + ","
                    + DataBaseHelper.KEY_RECEIVED + ","
                    + DataBaseHelper.KEY_RECEIVED_DATE + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ","
                    + DataBaseHelper.IS_DISPATCH_TYPE + ","
                    + DataBaseHelper.KEY_IS_DISPATCH + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";

            for (int k = 0; k < ishop_cfa_dispatch.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_cfa_dispatch.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//sample_dispatch_id
                    statement.bindString(2, object.getString("B"));//customer_from_id
                    statement.bindString(3, object.getString("C"));//customer_to_id
                    statement.bindString(4, object.getString("D"));//sap_id
                    statement.bindString(5, object.getString("E"));//dispatch_type
                    statement.bindString(6, object.getString("F"));//doc_no
                    statement.bindString(7, object.getString("G"));//dispatch_date
                    statement.bindString(8, object.getString("H"));//received
                    statement.bindString(9, object.getString("I"));//received_date
                    statement.bindString(10, object.getString("J"));//country_id
                    statement.bindString(11, object.getString("K"));//created_by_user
                    statement.bindString(12, object.getString("L"));//modified_by_user
                    statement.bindString(13, object.getString("M"));//status
                    statement.bindString(14, object.getString("N"));//created_on
                    statement.bindString(15, object.getString("O"));//modified_on
                    statement.bindString(16, object.getString("P"));//sync_code
                    statement.bindString(17, object.getString("Q"));//sync_flag
                    statement.bindString(18, object.getString("R"));//sync_date
                    statement.bindString(19, object.getString("S"));//sync_by_user
                    statement.bindString(20, object.getString("T"));//is_dispatch_type
                    statement.bindString(21, "1");

                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
                }

            }

            manageSampleDispatchMain();

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
            e.printStackTrace();
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFADispatchNew";
        } finally {
            database.endTransaction();
        }
        return true;
    }



    private void manageSampleDispatchMain() {

        database.execSQL("DELETE FROM bf_ishop_sample_dispatch\n" +
                "      WHERE sync_code IN (\n" +
                "    SELECT st.sync_code\n" +
                "      FROM bf_ishop_sample_dispatch AS st\n" +
                "           INNER JOIN\n" +
                "           bf_ishop_sample_dispatch_copy AS st_copy ON st.sync_code = st_copy.sync_code\n" +
                ");");
        database.execSQL("INSERT INTO bf_ishop_sample_dispatch (\n" +
                "                                              sample_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              sap_id,\n" +
                "                                              dispatch_type,\n" +
                "                                              doc_no,\n" +
                "                                              dispatch_date,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user,\n" +
                "                                              is_dispatch_type\n" +
                "                                          )\n" +
                "                                          SELECT " +
                "                                              sample_dispatch_id,\n" +
                "                                              customer_from_id,\n" +
                "                                              customer_to_id,\n" +
                "                                              sap_id,\n" +
                "                                              dispatch_type,\n" +
                "                                              doc_no,\n" +
                "                                              dispatch_date,\n" +
                "                                              received,\n" +
                "                                              received_date,\n" +
                "                                              country_id,\n" +
                "                                              created_by_user,\n" +
                "                                              modified_by_user,\n" +
                "                                              status,\n" +
                "                                              created_on,\n" +
                "                                              modified_on,\n" +
                "                                              sync_code,\n" +
                "                                              sync_flag,\n" +
                "                                              sync_date,\n" +
                "                                              isDispatch,\n" +
                "                                              sync_by_user,\n" +
                "                                              is_dispatch_type\n" +
                "                                            FROM bf_ishop_sample_dispatch_copy;");

        //delete copy table data
        database.execSQL("delete from " + DataBaseHelper.TABLE_ISHOP_SAMPLE_DISPATCH_COPY);
    }

    public JSONArray getJsonFromTableINVALIDForFOCMainTable(SQLiteDatabase db) {
        JSONArray jsonTableData = new JSONArray();
        ArrayList<String> listDispatchID=new ArrayList<>();
        String listIDs="";
        String qry = "SELECT biddp.distributor_dispatch_id AS distributor_dispatch_id\n" +
                "  FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                "       INNER JOIN\n" +
                "       bf_ishop_distributor_dispatch AS bidp ON bidp.distributor_dispatch_id = biddp.distributor_dispatch_id\n" +
                " WHERE biddp.is_valid = '6' AND \n" +
                "       biddp.sync_flag = 'Y' AND \n" +
                "       bidp.sync_flag = 'Y' AND \n" +
                "       bidp.isDispatch <> '1';\n";

        Cursor cursor = db.rawQuery(qry, null);
        try {
            if (cursor != null && cursor.getCount()>0) {
                for (int i=0;i<cursor.getCount();i++){
                    cursor.moveToPosition(i);
                    listDispatchID.add(cursor.getString(cursor.getColumnIndex("distributor_dispatch_id")));
                    if (listIDs.isEmpty()){
                        listIDs="'"+cursor.getString(cursor.getColumnIndex("distributor_dispatch_id"))+"'";
                    }else {
                        listIDs=listIDs+","+"'"+cursor.getString(cursor.getColumnIndex("distributor_dispatch_id"))+"'";
                    }
                }

            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            cursor.close();
        }

        if (!listIDs.isEmpty()){
            String sql2="SELECT bidd.*\n" +
                    "  FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                    "       INNER JOIN\n" +
                    "       bf_ishop_distributor_dispatch AS bidd ON bidd.distributor_dispatch_id = biddp.distributor_dispatch_id\n" +
                    " WHERE bidd.isDispatch = '0' AND \n" +
                    "       biddp.sync_flag = 'Y' AND \n" +
                    "       biddp.is_valid = '6' AND \n" +
                    "       biddp.distributor_dispatch_id IN ("+listIDs+");\n";

            Cursor c = db.rawQuery(sql2, null);
            if (c != null && c.getCount() > 0) {
                c.moveToFirst();
                //int i = 0;
                //for (int i = 0; i < c.getColumnCount(); i++) {
                do {
                    int totalColumn = c.getColumnCount();
                    if (totalColumn > 0) {
                        JSONObject rowObject = new JSONObject();
                        for (int i = 0; i < totalColumn; i++) {
                            String cName = c.getColumnName(i);
                            Log.e("getType", ":::::" + c.getType(i));
                            try {
                                switch (c.getType(i)) {
                                    case Cursor.FIELD_TYPE_INTEGER:
                                        if (cName.equalsIgnoreCase("id") || cName.equalsIgnoreCase("_id")) {
                                            continue;
                                        } else if (cName.equalsIgnoreCase("intglcode")) {
                                            continue;
                                        } else {
                                            if (c.getInt(i) != 0) {
                                                rowObject.put(cName, c.getInt(i));
                                            } else {
                                                rowObject.put(cName, 0);
                                            }
                                        }
                                        break;
                                    case Cursor.FIELD_TYPE_FLOAT:
                                        if (c.getFloat(i) != 0) {
                                            rowObject.put(cName, c.getFloat(i));
                                        } else {
                                            rowObject.put(cName, 0);
                                        }
                                        break;
                                    case Cursor.FIELD_TYPE_STRING:
                                        //isDispatch
                                        if (cName.equalsIgnoreCase("isDispatch")) {
                                            continue;
                                        } else if (c.getString(i) != null && !c.getString(i).equalsIgnoreCase("")) {
                                            rowObject.put(cName, c.getString(i));
                                        } else {
                                            rowObject.put(cName, "");
                                        }
                                        break;
                                    case Cursor.FIELD_TYPE_NULL:
                                        rowObject.put(cName, "");
                                        break;
                                }
                            } catch (Exception ex) {
                                ex.printStackTrace();
                                Log.e("", "Exception converting cursor column to json field: " + cName);
                                insertTransactionErrorLog(context, this.getClass().getSimpleName(), "getJsonFromTable",
                                        AppUtil.getStackTrace(ex),
                                        AppUtil.getStackTrace(ex),
                                        "1",SynchronizationService.userID);
                            }
                        }
                        jsonTableData.put(rowObject);
                    }
                } while (c.moveToNext());
            }
            assert c != null;
            c.close();
        }

        return jsonTableData;
    }

    public JSONArray getJsonFromTableINVALIDForFOC(SQLiteDatabase db) {
        JSONArray jsonTableData = new JSONArray();
        ArrayList<String> listDispatchID=new ArrayList<>();
        String listIDs="";
        String qry = "SELECT biddp.distributor_dispatch_id AS distributor_dispatch_id\n" +
                "  FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                "       INNER JOIN\n" +
                "       bf_ishop_distributor_dispatch AS bidp ON bidp.distributor_dispatch_id = biddp.distributor_dispatch_id\n" +
                " WHERE biddp.is_valid = '6' AND \n" +
                "       biddp.sync_flag = 'Y' AND \n" +
                "       bidp.sync_flag = 'Y' AND \n" +
                "       bidp.isDispatch <> '1';\n";

        Cursor cursor = db.rawQuery(qry, null);
        try {
            if (cursor != null && cursor.getCount()>0) {
                for (int i=0;i<cursor.getCount();i++){
                    cursor.moveToPosition(i);
                    listDispatchID.add(cursor.getString(cursor.getColumnIndex("distributor_dispatch_id")));
                    if (listIDs.isEmpty()){
                        listIDs="'"+cursor.getString(cursor.getColumnIndex("distributor_dispatch_id"))+"'";
                    }else {
                        listIDs=listIDs+","+"'"+cursor.getString(cursor.getColumnIndex("distributor_dispatch_id"))+"'";
                    }
                }

            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            cursor.close();
        }

        if (!listIDs.isEmpty()){
            String sql2="SELECT biddp.*\n" +
                    "  FROM bf_ishop_distributor_dispatch_product AS biddp\n" +
                    "       INNER JOIN\n" +
                    "       bf_ishop_distributor_dispatch AS bidd ON bidd.distributor_dispatch_id = biddp.distributor_dispatch_id\n" +
                    " WHERE bidd.isDispatch = '0' AND \n" +
                    "       biddp.sync_flag = 'Y' AND \n" +
                    "       biddp.is_valid = '6' AND \n" +
                    "       biddp.distributor_dispatch_id IN ("+listIDs+");\n";

            Cursor c = db.rawQuery(sql2, null);
            if (c != null && c.getCount() > 0) {
                c.moveToFirst();
                //int i = 0;
                //for (int i = 0; i < c.getColumnCount(); i++) {
                do {
                    int totalColumn = c.getColumnCount();
                    if (totalColumn > 0) {
                        JSONObject rowObject = new JSONObject();
                        for (int i = 0; i < totalColumn; i++) {
                            String cName = c.getColumnName(i);
                            Log.e("getType", ":::::" + c.getType(i));
                            try {
                                switch (c.getType(i)) {
                                    case Cursor.FIELD_TYPE_INTEGER:
                                        if (cName.equalsIgnoreCase("id") || cName.equalsIgnoreCase("_id")) {
                                            continue;
                                        } else if (cName.equalsIgnoreCase("intglcode")) {
                                            continue;
                                        } else {
                                            if (c.getInt(i) != 0) {
                                                rowObject.put(cName, c.getInt(i));
                                            } else {
                                                rowObject.put(cName, 0);
                                            }
                                        }
                                        break;
                                    case Cursor.FIELD_TYPE_FLOAT:
                                        if (c.getFloat(i) != 0) {
                                            rowObject.put(cName, c.getFloat(i));
                                        } else {
                                            rowObject.put(cName, 0);
                                        }
                                        break;
                                    case Cursor.FIELD_TYPE_STRING:
                                        //isDispatch
                                        if (cName.equalsIgnoreCase("isDispatch")) {
                                            continue;
                                        } else if (c.getString(i) != null && !c.getString(i).equalsIgnoreCase("")) {
                                            rowObject.put(cName, c.getString(i));
                                        } else {
                                            rowObject.put(cName, "");
                                        }
                                        break;
                                    case Cursor.FIELD_TYPE_NULL:
                                        rowObject.put(cName, "");
                                        break;
                                }
                            } catch (Exception ex) {
                                ex.printStackTrace();
                                Log.e("", "Exception converting cursor column to json field: " + cName);
                                insertTransactionErrorLog(context, this.getClass().getSimpleName(), "getJsonFromTable",
                                        AppUtil.getStackTrace(ex),
                                        AppUtil.getStackTrace(ex),
                                        "1",SynchronizationService.userID);
                            }
                        }
                        jsonTableData.put(rowObject);
                    }
                } while (c.moveToNext());
            }
            assert c != null;
            c.close();
        }

        return jsonTableData;
    }

    private JSONArray addDistributorDispatchForSampleAndFOC(JSONArray table_distributor_dispatch) {
        try {
            JSONArray TABLE_DISTRIBUTOR_DISPATCH_INVALID_FOC = getJsonFromTableINVALIDForFOCMainTable(database);
            if (TABLE_DISTRIBUTOR_DISPATCH_INVALID_FOC!=null && TABLE_DISTRIBUTOR_DISPATCH_INVALID_FOC.length()>0){
                for (int i=0;i<TABLE_DISTRIBUTOR_DISPATCH_INVALID_FOC.length();i++){
                    JSONObject object=TABLE_DISTRIBUTOR_DISPATCH_INVALID_FOC.getJSONObject(i);
                    if (table_distributor_dispatch==null){
                        table_distributor_dispatch=new JSONArray();
                    }
                    table_distributor_dispatch.put(object);
                }
            }

        } catch (JSONException e) {
            e.printStackTrace();
        }
        LogHelper.printLog("TAG_FOC",table_distributor_dispatch+"");
        return table_distributor_dispatch;
    }

    private JSONArray addDistributorDispatchForSampleAndFOCProduct(JSONArray table_distributor_dispatch_product) {
        try {
            JSONArray TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_INVALID_FOC = getJsonFromTableINVALIDForFOC(database);

            if (TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_INVALID_FOC!=null && TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_INVALID_FOC.length()>0){
                for (int i=0;i<TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_INVALID_FOC.length();i++){
                    JSONObject object=TABLE_DISTRIBUTOR_DISPATCH_PRODUCT_INVALID_FOC.getJSONObject(i);
                    if (table_distributor_dispatch_product==null){
                        table_distributor_dispatch_product=new JSONArray();
                    }
                    table_distributor_dispatch_product.put(object);
                }
            }
        } catch (JSONException e) {
            e.printStackTrace();
        }
        LogHelper.printLog("TAG_FOC",table_distributor_dispatch_product+"");
        return  table_distributor_dispatch_product;
    }


    public void InsertRETAILERSCANNEDINNew(JSONArray arrayScannedIN) {
        try {
            if (arrayScannedIN!=null && arrayScannedIN.length()>0){
                database.execSQL("delete from " + DataBaseHelper.TABLE_RETAILER_SCANNED_IN_STICKER);
                for (int i=0;i<arrayScannedIN.length();i++){
                    JSONObject objMain=arrayScannedIN.getJSONObject(i);
                    ContentValues contentValues = new ContentValues();
                    contentValues.put(DataBaseHelper.TOTALINSCANNED, objMain.getString("TotalInScanned"));
                    contentValues.put(DataBaseHelper.DTMONTH, objMain.getString("dtmonth"));
                    database.insert(DataBaseHelper.TABLE_RETAILER_SCANNED_IN_STICKER, null, contentValues);
                    Log.e(TAG, "TABLE_RETAILER_SCANNED_IN_STICKER");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public String getSynchronizationMaster() {
        JSONArray TABLE_TRANSACTION_ERROR = new JSONArray();
        JSONArray TABLE_ISHOP_PALLET_DETAILS = new JSONArray();
        JSONArray TABLE_DEVICE_TOKEN = new JSONArray();
        JSONArray TABLE_SAVE_OFFLINE_LOG = new JSONArray();
        JSONArray TABLE_TOLLER_DISPATCH = new JSONArray();
        JSONArray TABLE_TOLLER_DISPATCH_PRODUCT =new JSONArray();
        JSONArray TABLE_RETAILER_DISPATCH = new JSONArray();
        JSONArray TABLE_RETAILER_DISPATCH_PRODUCT = new JSONArray();
        //asdf
        JSONArray TABLE_CFA_DISPATCH = new JSONArray();
        JSONArray TABLE_CFA_DISPATCH_PRODUCT =new JSONArray();
        JSONArray TABLE_SAMPLE_DISPATCH = new JSONArray();
        JSONArray TABLE_SAMPLE_DISPATCH_PRODUCT = new JSONArray();
        JSONArray TABLE_CFA_RETURN =new JSONArray();

        JSONArray TABLE_DISTRIBUTOR_DISPATCH = new JSONArray();

        JSONArray TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = new JSONArray();

        //For Sample and FOC Invalid
        TABLE_DISTRIBUTOR_DISPATCH=new JSONArray();
        TABLE_DISTRIBUTOR_DISPATCH_PRODUCT = new JSONArray();


        //Amit Vaghela changes
        JSONArray TABLE_ishop_distributor_received = new JSONArray();
        JSONArray TABLE_ishop_distributor_received_product = new JSONArray();
        JSONArray TABLE_ishop_reatialer_received = new JSONArray();
        JSONArray TABLE_ishop_reatialer_received_product = new JSONArray();

        JSONArray TABLE_bf_ishop_cfa_return =new JSONArray();
        JSONArray TABLE_bf_ishop_cfa_return_product = new JSONArray();

        JSONArray TABLE_bf_ishop_distributor_return_request = new JSONArray();
        JSONArray TABLE_bf_ishop_distributor_return_request_product = new JSONArray();

        JSONArray TABLE_SALES_REP_INITIATED_PRODUCT = new JSONArray();


        JSONArray TABLE_CFA_DAMAGE = new JSONArray();
        JSONArray TABLE_CFA_DAMAGE_PRODUCT = new JSONArray();

        JSONArray TABLE_DIST_DAMAGE = new JSONArray();
        JSONArray TABLE_DIST_DAMAGE_PRODUCT =new JSONArray();

        JSONArray TABLE_RET_DAMAGE = new JSONArray();
        JSONArray TABLE_RET_DAMAGE_PRODUCT = new JSONArray();
        //JSONArray TABLE_CustomerType_Details = getJsonFromTable(DataBaseHelper.TABLE_CustomerType_Details, database, "0");
        /*  TODO CHange By Praveen  */
        JSONArray TABLE_VIDEO_HELP_DETAIL = new JSONArray();

        //$result['ishop_distributor_received'] = $ishop_distributor_received;
        // $result['ishop_distributor_received_product'] = $ishop_distributor_received_product;

        // bf_tmp_ishop_distributor_dispatch
        //DataBaseHelper.TABLE_DISTRIBUTOR_DISPATCH
        JSONObject jsonObject;
        Synchronization object = new Synchronization();

        //object.setIshop_cfa_dispatch(CFADispatchSyncData());
        //object.setIshop_cfa_dispatch_product(CFADispatchSyncDataProduct());

        /*object.setIshop_cfa_return(CFAReturnSyncData());
        object.setBf_ishop_cfa_return_product(CFAReturnProductSyncData());*/

        //object.setIshop_distributor_dispatch(DistributorDispatchSyncData());
        //object.setIshop_distributor_dispatch_product(DistributorDispatchSyncDataProduct());

        object.setIshop_distributor_return(new ArrayList<>());
        object.setIshop_distributor_return_product(new ArrayList<>());
        //asdf
        /*object.setIshop_distributor_return_request(DistributorReturnRequestSyncData());
        object.setIshop_distributor_return_request_product(DistributorReturnRequestProductSyncData());*/

        //object.setIshop_retailer_dispatch(RetailerDispatchSyncData());
        //object.setIshop_retailer_dispatch_product(RetailerDispatchSyncDataProduct());

        String jsonObject1 = AppUtil.getJsonFromObject(object);
        try {
            jsonObject = new JSONObject(jsonObject1);

            Log.e("", "" + TABLE_TOLLER_DISPATCH);
            if (TABLE_TOLLER_DISPATCH != null && TABLE_TOLLER_DISPATCH.length() > 0)
                jsonObject.put("ishop_toller_dispatch", TABLE_TOLLER_DISPATCH);

            if (TABLE_TOLLER_DISPATCH_PRODUCT != null && TABLE_TOLLER_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_toller_dispatch_product", TABLE_TOLLER_DISPATCH_PRODUCT);

            Log.e("", "" + TABLE_RETAILER_DISPATCH);
            if (TABLE_RETAILER_DISPATCH != null && TABLE_RETAILER_DISPATCH.length() > 0)
                jsonObject.put("ishop_retailer_dispatch", TABLE_RETAILER_DISPATCH);

            Log.e("", "" + TABLE_RETAILER_DISPATCH_PRODUCT);
            if (TABLE_RETAILER_DISPATCH_PRODUCT != null && TABLE_RETAILER_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_retailer_dispatch_product", TABLE_RETAILER_DISPATCH_PRODUCT);

            if (TABLE_CFA_DISPATCH != null && TABLE_CFA_DISPATCH.length() > 0)
                jsonObject.put("ishop_cfa_dispatch", TABLE_CFA_DISPATCH);

            if (TABLE_CFA_DISPATCH_PRODUCT != null && TABLE_CFA_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_cfa_dispatch_product", TABLE_CFA_DISPATCH_PRODUCT);

            if (TABLE_SAMPLE_DISPATCH != null && TABLE_SAMPLE_DISPATCH.length() > 0)
                jsonObject.put("ishop_sample_dispatch", TABLE_SAMPLE_DISPATCH);

            if (TABLE_SAMPLE_DISPATCH_PRODUCT != null && TABLE_SAMPLE_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_sample_dispatch_product", TABLE_SAMPLE_DISPATCH_PRODUCT);

            if (TABLE_CFA_RETURN != null && TABLE_CFA_RETURN.length() > 0)
                jsonObject.put("ishop_cfa_return", TABLE_CFA_RETURN);

            if (TABLE_DISTRIBUTOR_DISPATCH != null && TABLE_DISTRIBUTOR_DISPATCH.length() > 0)
                jsonObject.put("ishop_distributor_dispatch", TABLE_DISTRIBUTOR_DISPATCH);

            if (TABLE_DISTRIBUTOR_DISPATCH_PRODUCT != null && TABLE_DISTRIBUTOR_DISPATCH_PRODUCT.length() > 0)
                jsonObject.put("ishop_distributor_dispatch_product", TABLE_DISTRIBUTOR_DISPATCH_PRODUCT);

            if (TABLE_ishop_distributor_received != null && TABLE_ishop_distributor_received.length() > 0)
                jsonObject.put("ishop_distributor_received", TABLE_ishop_distributor_received);

            if (TABLE_ishop_distributor_received_product != null && TABLE_ishop_distributor_received_product
                    .length() > 0)
                jsonObject.put("ishop_distributor_received_product", TABLE_ishop_distributor_received_product);

            if (TABLE_ishop_reatialer_received != null && TABLE_ishop_reatialer_received.length() > 0)
                jsonObject.put("ishop_retailer_received", TABLE_ishop_reatialer_received);

            if (TABLE_ishop_reatialer_received_product != null && TABLE_ishop_reatialer_received_product
                    .length() > 0)
                jsonObject.put("ishop_retailer_received_product", TABLE_ishop_reatialer_received_product);

            if (TABLE_bf_ishop_cfa_return != null && TABLE_bf_ishop_cfa_return.length() > 0)
                jsonObject.put("ishop_cfa_return", TABLE_bf_ishop_cfa_return);

            if (TABLE_bf_ishop_cfa_return_product != null && TABLE_bf_ishop_cfa_return_product.length() > 0)
                jsonObject.put("ishop_cfa_return_product", TABLE_bf_ishop_cfa_return_product);

            if (TABLE_bf_ishop_distributor_return_request != null && TABLE_bf_ishop_distributor_return_request
                    .length() > 0)
                jsonObject.put("ishop_distributor_return_request", TABLE_bf_ishop_distributor_return_request);

            if (TABLE_bf_ishop_distributor_return_request_product != null &&
                    TABLE_bf_ishop_distributor_return_request_product.length() > 0)
                jsonObject.put("ishop_distributor_return_request_product",
                        TABLE_bf_ishop_distributor_return_request_product);

            if (TABLE_SALES_REP_INITIATED_PRODUCT != null && TABLE_SALES_REP_INITIATED_PRODUCT.length() > 0)
                jsonObject.put("sales_rep_initiated_product", TABLE_SALES_REP_INITIATED_PRODUCT);

            if (TABLE_CFA_DAMAGE != null && TABLE_CFA_DAMAGE.length() > 0)
                jsonObject.put("ishop_cfa_damage", TABLE_CFA_DAMAGE);

            if (TABLE_CFA_DAMAGE_PRODUCT != null && TABLE_CFA_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_cfa_damage_product", TABLE_CFA_DAMAGE_PRODUCT);


            if (TABLE_DIST_DAMAGE != null && TABLE_DIST_DAMAGE.length() > 0)
                jsonObject.put("ishop_distributor_damage", TABLE_DIST_DAMAGE);

            if (TABLE_DIST_DAMAGE_PRODUCT != null && TABLE_DIST_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_distributor_damage_product", TABLE_DIST_DAMAGE_PRODUCT);


            if (TABLE_RET_DAMAGE != null && TABLE_RET_DAMAGE.length() > 0)
                jsonObject.put("ishop_retailer_damage", TABLE_RET_DAMAGE);

            if (TABLE_RET_DAMAGE_PRODUCT != null && TABLE_RET_DAMAGE_PRODUCT.length() > 0)
                jsonObject.put("ishop_retailer_damage_product", TABLE_RET_DAMAGE_PRODUCT);


            /*TODO Changes By Praveen */

            if (TABLE_VIDEO_HELP_DETAIL != null && TABLE_VIDEO_HELP_DETAIL.length() > 0) {
                jsonObject.put("bf_master_cpm_help_video_details", TABLE_VIDEO_HELP_DETAIL);
            }
            /*if (TABLE_CustomerType_Details != null && TABLE_CustomerType_Details.length() > 0)
                jsonObject.put("CustomerType_Details", TABLE_CustomerType_Details);*/

            if (TABLE_SAVE_OFFLINE_LOG != null && TABLE_SAVE_OFFLINE_LOG.length() > 0) {
                jsonObject.put("bf_ishop_save_offline_log_android_cpm", TABLE_SAVE_OFFLINE_LOG);
            }

            if (TABLE_DEVICE_TOKEN != null && TABLE_DEVICE_TOKEN.length() > 0) {
                jsonObject.put("table_device_token", TABLE_DEVICE_TOKEN);
            }

            if (TABLE_TRANSACTION_ERROR != null && TABLE_TRANSACTION_ERROR.length() > 0) {
                jsonObject.put("bf_ishop_transaction_error_log", TABLE_TRANSACTION_ERROR);
            }

            if (TABLE_ISHOP_PALLET_DETAILS != null && TABLE_ISHOP_PALLET_DETAILS.length() > 0) {
                jsonObject.put("bf_ishop_pallet_details", TABLE_ISHOP_PALLET_DETAILS);
            }
            writeStringAsFile(jsonObject.toString(), "RE_CPM",context);
            Log.e(TAG, "SYNCHRONIZATION JSON : " + jsonObject);
            return jsonObject.toString();
        } catch (JSONException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e);
            Log.e("error", "->>" + e);
            return "json not found";
        }
    }


    /**
     * Added for Testing with Gson Library
     * @param ishop_cfa_return_product
     */
    public void InsertCFAReturnProductGson(JsonArray ishop_cfa_return_product) {
//        open();
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_CFA_RETURN_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_CFA_RETURN_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_cfa_return_product.size(); k++) {
                JsonObject object = null;
                try {
                    object = ishop_cfa_return_product.get(k).getAsJsonObject();
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.get("cfa_return_product_id").getAsString());
                    statement.bindString(2, object.get("cfa_return_id").getAsString());
                    statement.bindString(3, object.get("product_sku_id").getAsString());
                    statement.bindString(4, object.get("sticker_details_id").getAsString());
                    statement.bindString(5, object.get("btc_no_out").getAsString());
                    statement.bindString(6, object.get("quantity").getAsString());
                    statement.bindString(7, object.get("amount").getAsString());
                    statement.bindString(8, object.get("unit").getAsString());
                    statement.bindString(9, object.get("qty_kgl").getAsString());
                    statement.bindString(10, object.get("is_valid").getAsString());
                    statement.bindString(11, object.get("sync_code").getAsString());
                    statement.bindString(12, object.get("sync_flag").getAsString());
                    statement.bindString(13, object.get("sync_date").getAsString());
                    statement.bindString(14, object.get("sync_by_user").getAsString());
                    statement.execute();
                } catch (Exception e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
                }

            }
            manageCFAReturnProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
        } finally {
            database.endTransaction();
//            close();
        }
    }

    /**
     * Inserting Bulk Entry By Reading file by file , one by one
     * @param ishop_cfa_return
     */
    public void InsertCFAReturnBulk(JSONArray ishop_cfa_return) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_RETURN_COPY
                    + " (" + DataBaseHelper.KEY_CFA_RETURN_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                    + DataBaseHelper.KEY_RETURN_DATE + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_IS_DISPATCH + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_cfa_return.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_cfa_return.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//cfa_return_id
                    statement.bindString(2, object.getString("B"));//customer_from_id
                    statement.bindString(3, object.getString("C"));//customer_to_id
                    statement.bindString(4, object.getString("D"));//return_date
                    statement.bindString(5, object.getString("E"));//country_id
                    statement.bindString(6, object.getString("F"));//created_by_user
                    statement.bindString(7, object.getString("G"));//modified_by_user
                    statement.bindString(8, object.getString("H"));//status
                    statement.bindString(9, object.getString("I"));//created_on
                    statement.bindString(10, object.getString("J"));//modified_on
                    statement.bindString(11, object.getString("K"));//sync_code
                    statement.bindString(12, object.getString("L"));//sync_flag
                    statement.bindString(13, object.getString("M"));//sync_date
                    statement.bindString(14, "1");
                    statement.bindString(15, object.getString("N"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
                }

            }

            manageCfaReturnCopy();

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnNew";
        } finally {
            database.endTransaction();
        }

    }

    public void InsertDistributorReturnRequestBulk(JSONArray ishop_distributor_return_request) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_DISTRIBUTOR_RETURN_REQUEST_COPY
                    + " (" + DataBaseHelper.KEY_DISTRIBUTOR_RETURN_REQUEST_ID + ","
                    + DataBaseHelper.SRIP_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_FROM_ID + ","
                    + DataBaseHelper.KEY_CUSTOMER_TO_ID + ","
                    + DataBaseHelper.KEY_RETURN_REQUEST_DATE + ","
                    + DataBaseHelper.KEY_COUNTRY_ID + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_STATUS + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_isDispatch + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_distributor_return_request.length(); k++) {
                JSONObject object = null;
                try {
                    object = ishop_distributor_return_request.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.optString("A"));//distributor_return_request_id
                    statement.bindString(2, object.optString("E"));//srip_id
                    statement.bindString(3, object.optString("B"));//customer_from_id
                    statement.bindString(4, object.optString("C"));//customer_to_id
                    statement.bindString(5, object.optString("D"));//return_request_date
                    statement.bindString(6, object.optString("F"));//country_id
                    statement.bindString(7, object.optString("G"));//created_by_user
                    statement.bindString(8, object.optString("H"));//modified_by_user
                    statement.bindString(9, object.optString("I"));//status
                    statement.bindString(10, object.optString("J"));//created_on
                    statement.bindString(11, object.optString("K"));//modified_on
                    statement.bindString(12, object.optString("L"));//sync_code
                    statement.bindString(13, object.optString("M"));//sync_flag
                    statement.bindString(14, object.optString("N"));//sync_date
                    statement.bindString(15, "1");
                    statement.bindString(16, object.optString("O"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
                }
            }

            manageDistReturnRequestCopy();

            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertDistributorReturnRequestNew";
        } finally {
            database.endTransaction();
        }
    }

    public void InsertCFAReturnProductBulk(JSONArray ishop_cfa_return_product) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_CFA_RETURN_PRODUCT_COPY
                    + " (" + DataBaseHelper.KEY_CFA_RETURN_PRODUCT_ID + ","
                    + DataBaseHelper.KEY_CFA_RETURN_ID + ","
                    + DataBaseHelper.KEY_PRODUCT_SKU_ID + ","
                    + DataBaseHelper.KEY_STICKER_DETAILS_ID + ","
                    + DataBaseHelper.KEY_BTC_NO_OUT + ","
                    + DataBaseHelper.KEY_QUANTITY + ","
                    + DataBaseHelper.KEY_AMOUNT + ","
                    + DataBaseHelper.KEY_UNIT + ","
                    + DataBaseHelper.KEY_QTY_KGL + ","
                    + DataBaseHelper.KEY_IS_VALID + ","
                    + DataBaseHelper.KEY_SYNC_CODE + ","
                    + DataBaseHelper.KEY_SYNC_FLAG + ","
                    + DataBaseHelper.KEY_SYNC_DATE + ","
                    + DataBaseHelper.KEY_SYNC_USER + ") VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?)";


            for (int k = 0; k < ishop_cfa_return_product.length(); k++) {
                try {
                    JSONObject object = ishop_cfa_return_product.getJSONObject(k);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("A"));//cfa_return_product_id
                    statement.bindString(2, object.getString("B"));//cfa_return_id
                    statement.bindString(3, object.getString("C"));//product_sku_id
                    statement.bindString(4, object.getString("D"));//sticker_details_id
                    statement.bindString(5, object.getString("E"));//btc_no_out
                    statement.bindString(6, object.getString("G"));//quantity
                    statement.bindString(7, object.getString("H"));//amount
                    statement.bindString(8, object.getString("I"));//unit
                    statement.bindString(9, object.getString("J"));//qty_kgl
                    statement.bindString(10, object.getString("K"));//is_valid
                    statement.bindString(11, object.getString("L"));//sync_code
                    statement.bindString(12, object.getString("M"));//sync_flag
                    statement.bindString(13, object.getString("N"));//sync_date
                    statement.bindString(14, object.getString("O"));//sync_by_user
                    statement.execute();
                } catch (JSONException e) {
                    e.printStackTrace();
                    if (callback != null) {
                        callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                    }
                    SynchronizationService.isSuccess = false;
                    SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
                }

            }
            manageCFAReturnProduct();
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertCFAReturnProductNew";
        } finally {
            database.endTransaction();
        }
    }


    /**
     * Insert Data For Lookup Value For Story DP-30707, DP-30708
     * @param arrayLookupConfig
     */
    public void InsertLookUpValuesConfig(JSONArray arrayLookupConfig) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_BLOCKING_LOOKUP_VALUES);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_BLOCKING_LOOKUP_VALUES + " ("
                    + DataBaseHelper.KEY_LOOKUP_TYPE_ID + ","
                    + DataBaseHelper.KEY_LOOKUP_CODE + ","
                    + DataBaseHelper.KEY_LOOKUP_VALUE + ") VALUES (?,?,?)";

            try {
                for (int i = 0; i < arrayLookupConfig.length(); i++) {
                    JSONObject object = arrayLookupConfig.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("lookuptype_id"));
                    statement.bindString(2, object.getString("varLookupCode"));
                    statement.bindString(3, object.getString("varLookupValue"));
                    statement.execute();
                }
            } catch (Exception e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertLookUpValuesConfig";
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertLookUpValuesConfig";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertLookUpValuesConfig";
        } finally {
            database.endTransaction();
        }

    }

    /**
     * Deleting when configuration from server is off and we do not get data in Master Sync
     */
    public void deleteLookUpTable() {
        database.execSQL("delete from " + DataBaseHelper.TABLE_BLOCKING_LOOKUP_VALUES);
    }

    /**
     * Insert Data For Lookup Value For Story DP-30707, DP-30708
     * @param arrayskuwiseblock
     */
    public void InsertSkuWiseBlockDetails(JSONArray arrayskuwiseblock) {
        database.execSQL("delete from " + DataBaseHelper.TABLE_SKU_WISE_BLOCKING);
        database.beginTransaction();
        try {
            String sql = "INSERT INTO " + DataBaseHelper.TABLE_SKU_WISE_BLOCKING + " ("
                    + DataBaseHelper.KEY_INT_ID + ","
                    + DataBaseHelper.KEY_PBG_ID_BLOCK + ","
                    + DataBaseHelper.KEY_SKU_ID + ","
                    + DataBaseHelper.KEY_NO_OF_MONTH + ","
                    + DataBaseHelper.KEY_BLOCK_SCANNING_CODE + ","
                    + DataBaseHelper.KEY_BLOCK_SCANNING_BY + ","
                    + DataBaseHelper.KEY_CREATED_BY_USER + ","
                    + DataBaseHelper.KEY_CREATE_ON + ","
                    + DataBaseHelper.KEY_MODIFIED_BY_USER + ","
                    + DataBaseHelper.KEY_MODIFIED_ON + ") VALUES (?,?,?,?,?,?,?,?,?,?)";

            try {
                for (int i = 0; i < arrayskuwiseblock.length(); i++) {
                    JSONObject object = arrayskuwiseblock.getJSONObject(i);
                    SQLiteStatement statement = database.compileStatement(sql);
                    statement.bindString(1, object.getString("intId"));
                    statement.bindString(2, object.getString("pbg_id"));
                    statement.bindString(3, object.getString("sku_id"));
                    statement.bindString(4, object.getString("no_of_month"));
                    statement.bindString(5, object.getString("block_scanning_code"));
                    statement.bindString(6, object.getString("block_scanning_by"));
                    statement.bindString(7, object.getString("created_by_user"));
                    statement.bindString(8, object.getString("created_on"));
                    statement.bindString(9, object.getString("modified_by_user"));
                    statement.bindString(10, object.getString("modified_on"));
                    statement.execute();
                }
            } catch (Exception e) {
                e.printStackTrace();
                if (callback != null) {
                    callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
                }
                SynchronizationService.isSuccess = false;
                SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSkuWiseBlockDetails";
            }
            database.setTransactionSuccessful();
        } catch (SQLException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSkuWiseBlockDetails";
        } catch (NumberFormatException e) {
            e.printStackTrace();
            if (callback != null) {
                callback.onDatabaseError(String.valueOf(SyncErrorCode.ERROR_108), AppUtil.getStackTrace(e));
            }
            SynchronizationService.isSuccess = false;
            SynchronizationService.exceptionDetails = AppUtil.getStackTrace(e) + " In Method InsertSkuWiseBlockDetails";
        } finally {
            database.endTransaction();
        }

    }

    /**
     * Deleting when configuration from server is off and we do not get data in Master Sync
     */
    public void deleteBlockDetailsTable() {
        database.execSQL("delete from " + DataBaseHelper.TABLE_SKU_WISE_BLOCKING);
    }



}